# type: ignore
from typing import Any, List, Tuple
import enum


##################################################
#    Manually inserted code (typedefs, etc.)
##################################################


from imgui_bundle.imgui import *


"""
// Use your programming IDE "Go to definition" facility on the names of the center columns to find the actual flags/enum lists.
typedef int ImGuiDataAuthority;         // -> enum ImGuiDataAuthority_      // Enum: for storing the source authority (dock node vs window) of a field
typedef int ImGuiLayoutType;            // -> enum ImGuiLayoutType_         // Enum: Horizontal or vertical
typedef int ImGuiActivateFlags;         // -> enum ImGuiActivateFlags_      // Flags: for navigation/focus function (will be for ActivateItem() later)
typedef int ImGuiDebugLogFlags;         // -> enum ImGuiDebugLogFlags_      // Flags: for ShowDebugLogWindow(), g.DebugLogFlags
typedef int ImGuiItemFlags;             // -> enum ImGuiItemFlags_          // Flags: for PushItemFlag()
typedef int ImGuiItemStatusFlags;       // -> enum ImGuiItemStatusFlags_    // Flags: for DC.LastItemStatusFlags
typedef int ImGuiOldColumnFlags;        // -> enum ImGuiOldColumnFlags_     // Flags: for BeginColumns()
typedef int ImGuiNavHighlightFlags;     // -> enum ImGuiNavHighlightFlags_  // Flags: for RenderNavHighlight()
typedef int ImGuiNavDirSourceFlags;     // -> enum ImGuiNavDirSourceFlags_  // Flags: for GetNavInputAmount2d()
typedef int ImGuiNavMoveFlags;          // -> enum ImGuiNavMoveFlags_       // Flags: for navigation requests
typedef int ImGuiNextItemDataFlags;     // -> enum ImGuiNextItemDataFlags_  // Flags: for SetNextItemXXX() functions
typedef int ImGuiNextWindowDataFlags;   // -> enum ImGuiNextWindowDataFlags_// Flags: for SetNextWindowXXX() functions
typedef int ImGuiScrollFlags;           // -> enum ImGuiScrollFlags_        // Flags: for ScrollToItem() and navigation requests
typedef int ImGuiSeparatorFlags;        // -> enum ImGuiSeparatorFlags_     // Flags: for SeparatorEx()
typedef int ImGuiTextFlags;             // -> enum ImGuiTextFlags_          // Flags: for TextEx()
typedef int ImGuiTooltipFlags;          // -> enum ImGuiTooltipFlags_       // Flags: for BeginTooltipEx()
"""
ImGuiDataAuthority = int #         // -> enum ImGuiDataAuthority_      // Enum: for storing the source authority (dock node vs window) of a field
ImGuiLayoutType = int  #            // -> enum ImGuiLayoutType_         // Enum: Horizontal or vertical
ImGuiActivateFlags = int  #         // -> enum ImGuiActivateFlags_      // Flags: for navigation/focus function (will be for ActivateItem() later)
ImGuiDebugLogFlags = int  #         // -> enum ImGuiDebugLogFlags_      // Flags: for ShowDebugLogWindow(), g.DebugLogFlags
ImGuiItemFlags = int  #             // -> enum ImGuiItemFlags_          // Flags: for PushItemFlag()
ImGuiItemStatusFlags = int  #       // -> enum ImGuiItemStatusFlags_    // Flags: for DC.LastItemStatusFlags
ImGuiOldColumnFlags = int  #        // -> enum ImGuiOldColumnFlags_     // Flags: for BeginColumns()
ImGuiNavHighlightFlags = int  #     // -> enum ImGuiNavHighlightFlags_  // Flags: for RenderNavHighlight()
ImGuiNavDirSourceFlags = int  #     // -> enum ImGuiNavDirSourceFlags_  // Flags: for GetNavInputAmount2d()
ImGuiNavMoveFlags = int  #          // -> enum ImGuiNavMoveFlags_       // Flags: for navigation requests
ImGuiNextItemDataFlags = int  #     // -> enum ImGuiNextItemDataFlags_  // Flags: for SetNextItemXXX() functions
ImGuiNextWindowDataFlags = int  #   // -> enum ImGuiNextWindowDataFlags_// Flags: for SetNextWindowXXX() functions
ImGuiScrollFlags = int  #           // -> enum ImGuiScrollFlags_        // Flags: for ScrollToItem() and navigation requests
ImGuiSeparatorFlags = int  #        // -> enum ImGuiSeparatorFlags_     // Flags: for SeparatorEx()
ImGuiTextFlags = int  #             // -> enum ImGuiTextFlags_          // Flags: for TextEx()
ImGuiTooltipFlags = int  #          // -> enum ImGuiTooltipFlags_       // Flags: for BeginTooltipEx()


ImGuiTextBuffer = Any
ImFileHandle = Any

# // Our current column maximum is 64 but we may raise that in the future.
# typedef ImS8 ImGuiTableColumnIdx;
# typedef ImU8 ImGuiTableDrawChannelIdx;
ImGuiTableColumnIdx = int
ImGuiTableDrawChannelIdx = int


# Disable black formatter
# fmt: off

##################################################
#    AUTO GENERATED CODE BELOW
##################################################
# <litgen_stub> // Autogenerated code below! Do not edit!
####################    <generated_from:imgui_internal.h>    ####################
# dear imgui, v1.88
# (internal structures/api)

# You may use this file to debug, understand or extend ImGui features but we don't provide any guarantee of forward compatibility!
# Set:
#   #define IMGUI_DEFINE_MATH_OPERATORS
# To implement maths operators for ImVec2 (disabled by default to not collide with using IM_VEC2_CLASS_EXTRA along with your own math types+operators)

#
#
#Index of this file:
#
#// [SECTION] Header mess
#// [SECTION] Forward declarations
#// [SECTION] Context pointer
#// [SECTION] STB libraries includes
#// [SECTION] Macros
#// [SECTION] Generic helpers
#// [SECTION] ImDrawList support
#// [SECTION] Widgets support: flags, enums, data structures
#// [SECTION] Inputs support
#// [SECTION] Clipper support
#// [SECTION] Navigation support
#// [SECTION] Columns support
#// [SECTION] Multi-select support
#// [SECTION] Docking support
#// [SECTION] Viewport support
#// [SECTION] Settings support
#// [SECTION] Metrics, Debug tools
#// [SECTION] Generic context hooks
#// [SECTION] ImGuiContext (main imgui context)
#// [SECTION] ImGuiWindowTempData, ImGuiWindow
#// [SECTION] Tab bar, Tab item support
#// [SECTION] Table support
#// [SECTION] ImGui internal API
#// [SECTION] ImFontAtlas internal API
#// [SECTION] Test Engine specific hooks (imgui_test_engine)
#
#


#-----------------------------------------------------------------------------
# [SECTION] Header mess
#-----------------------------------------------------------------------------



# Enable SSE intrinsics if available

# Visual Studio warnings

# Clang/GCC warnings with -Weverything

# Legacy defines

# Enable stb_truetype by default unless FreeType is enabled.
# You can compile with both by defining both IMGUI_ENABLE_FREETYPE and IMGUI_ENABLE_STB_TRUETYPE together.

#-----------------------------------------------------------------------------
# [SECTION] Forward declarations
#-----------------------------------------------------------------------------


# Use your programming IDE "Go to definition" facility on the names of the center columns to find the actual flags/enum lists.


#-----------------------------------------------------------------------------
# [SECTION] Context pointer
# See implementation of this variable in imgui.cpp for comments and details.
#-----------------------------------------------------------------------------


#-------------------------------------------------------------------------
# [SECTION] STB libraries includes
#-------------------------------------------------------------------------

# namespace ImStb

#-----------------------------------------------------------------------------
# [SECTION] Macros
#-----------------------------------------------------------------------------

# Internal Drag and Drop payload types. String starting with '_' are reserved for Dear ImGui.

# Debug Printing Into TTY
# (since IMGUI_VERSION_NUM >= 18729: IMGUI_DEBUG_LOG was reworked into IMGUI_DEBUG_PRINTF (and removed framecount from it). If you were using a #define IMGUI_DEBUG_LOG please rename)

# Debug Logging for ShowDebugLogWindow(). This is designed for relatively rare events so please don't spam.


# "Paranoid" Debug Asserts are meant to only be enabled during specific debugging/work, otherwise would slow down the code too much.
# We currently don't have many of those so the effect is currently negligible, but onward intent to add more aggressive ones in the code.
##define IMGUI_DEBUG_PARANOID

# Error handling
# Down the line in some frameworks/languages we would like to have a way to redirect those to the programmer and recover from more faults.


# Enforce cdecl calling convention for functions called by the standard library, in case compilation settings changed the default to e.g. __vectorcall

# Warnings

# Debug Tools
# Use 'Metrics/Debugger->Tools->Item Picker' to break into the call-stack of a specific item.
# This will call IM_DEBUG_BREAK() which you may redefine yourself. See https://github.com/scottt/debugbreak for more reference.

#-----------------------------------------------------------------------------
# [SECTION] Generic helpers
# Note that the ImXXX helpers functions are lower-level than ImGui functions.
# ImGui functions or the ImGui context are never called/used from other ImXXX functions.
#-----------------------------------------------------------------------------
# - Helpers: Hashing
# - Helpers: Sorting
# - Helpers: Bit manipulation
# - Helpers: String
# - Helpers: Formatting
# - Helpers: UTF-8 <> wchar conversions
# - Helpers: ImVec2/ImVec4 operators
# - Helpers: Maths
# - Helpers: Geometry
# - Helper: ImVec1
# - Helper: ImVec2ih
# - Helper: ImRect
# - Helper: ImBitArray
# - Helper: ImBitVector
# - Helper: ImSpan<>, ImSpanAllocator<>
# - Helper: ImPool<>
# - Helper: ImChunkStream<>
#-----------------------------------------------------------------------------

# Helpers: Hashing
# IMGUI_API ImGuiID       ImHashData(const void* data, size_t data_size, ImU32 seed = 0);    /* original C++ signature */
def im_hash_data(data: Any, data_size: int, seed: ImU32 = 0) -> ImGuiID:    # imgui_internal.h:315
    pass
# IMGUI_API ImGuiID       ImHashStr(const char* data, size_t data_size = 0, ImU32 seed = 0);    /* original C++ signature */
def im_hash_str(data: str, data_size: int = 0, seed: ImU32 = 0) -> ImGuiID:    # imgui_internal.h:316
    pass

# Helpers: Sorting

# IMGUI_API ImU32         ImAlphaBlendColors(ImU32 col_a, ImU32 col_b);    /* original C++ signature */
def im_alpha_blend_colors(col_a: ImU32, col_b: ImU32) -> ImU32:    # imgui_internal.h:324
    """ Helpers: Color Blending"""
    pass

# Helpers: Bit manipulation

# Helpers: String

# Helpers: Formatting

# Helpers: UTF-8 <> wchar conversions
# return number of bytes to express string in UTF-8

# Helpers: ImVec2/ImVec4 operators
# We are keeping those disabled by default so they don't leak in user space, to allow user enabling implicit cast operators between ImVec2 and their own types (using IM_VEC2_CLASS_EXTRA etc.)
# We unfortunately don't have a unary- operator for ImVec2 because this would needs to be defined inside the class itself.

# Helpers: File System
# IMGUI_API void*             ImFileLoadToMemory(const char* filename, const char* mode, size_t* out_file_size = NULL, int padding_bytes = 0);    /* original C++ signature */
def im_file_load_to_memory(filename: str, mode: str, out_file_size: int = None, padding_bytes: int = 0) -> Any:    # imgui_internal.h:411
    pass

# - Wrapper for standard libs functions. (Note that imgui_demo.cpp does _not_ use them to keep the code easy to copy)
# - ImMin/ImMax/ImClamp/ImLerp/ImSwap are used by widgets which support variety of types: signed/unsigned int/long long float/double
# (Exceptionally using templates here but we could also redefine them for those types)
# - Misc maths helpers

# Helpers: Geometry
# IMGUI_API ImVec2     ImBezierCubicCalc(const ImVec2& p1, const ImVec2& p2, const ImVec2& p3, const ImVec2& p4, float t);    /* original C++ signature */
def im_bezier_cubic_calc(p1: ImVec2, p2: ImVec2, p3: ImVec2, p4: ImVec2, t: float) -> ImVec2:    # imgui_internal.h:476
    pass
# IMGUI_API ImVec2     ImBezierCubicClosestPoint(const ImVec2& p1, const ImVec2& p2, const ImVec2& p3, const ImVec2& p4, const ImVec2& p, int num_segments);           /* original C++ signature */
def im_bezier_cubic_closest_point(p1: ImVec2, p2: ImVec2, p3: ImVec2, p4: ImVec2, p: ImVec2, num_segments: int) -> ImVec2:    # imgui_internal.h:477
    """ For curves with explicit number of segments"""
    pass
# IMGUI_API ImVec2     ImBezierCubicClosestPointCasteljau(const ImVec2& p1, const ImVec2& p2, const ImVec2& p3, const ImVec2& p4, const ImVec2& p, float tess_tol);    /* original C++ signature */
def im_bezier_cubic_closest_point_casteljau(p1: ImVec2, p2: ImVec2, p3: ImVec2, p4: ImVec2, p: ImVec2, tess_tol: float) -> ImVec2:    # imgui_internal.h:478
    """ For auto-tessellated curves you can use tess_tol = style.CurveTessellationTol"""
    pass
# IMGUI_API ImVec2     ImBezierQuadraticCalc(const ImVec2& p1, const ImVec2& p2, const ImVec2& p3, float t);    /* original C++ signature */
def im_bezier_quadratic_calc(p1: ImVec2, p2: ImVec2, p3: ImVec2, t: float) -> ImVec2:    # imgui_internal.h:479
    pass
# IMGUI_API ImVec2     ImLineClosestPoint(const ImVec2& a, const ImVec2& b, const ImVec2& p);    /* original C++ signature */
def im_line_closest_point(a: ImVec2, b: ImVec2, p: ImVec2) -> ImVec2:    # imgui_internal.h:480
    pass
# IMGUI_API bool       ImTriangleContainsPoint(const ImVec2& a, const ImVec2& b, const ImVec2& c, const ImVec2& p);    /* original C++ signature */
def im_triangle_contains_point(a: ImVec2, b: ImVec2, c: ImVec2, p: ImVec2) -> bool:    # imgui_internal.h:481
    pass
# IMGUI_API ImVec2     ImTriangleClosestPoint(const ImVec2& a, const ImVec2& b, const ImVec2& c, const ImVec2& p);    /* original C++ signature */
def im_triangle_closest_point(a: ImVec2, b: ImVec2, c: ImVec2, p: ImVec2) -> ImVec2:    # imgui_internal.h:482
    pass
# IMGUI_API void       ImTriangleBarycentricCoords(const ImVec2& a, const ImVec2& b, const ImVec2& c, const ImVec2& p, float& out_u, float& out_v, float& out_w);    /* original C++ signature */
def im_triangle_barycentric_coords(a: ImVec2, b: ImVec2, c: ImVec2, p: ImVec2, out_u: float, out_v: float, out_w: float) -> Tuple[float, float, float]:    # imgui_internal.h:483
    pass
# IMGUI_API ImGuiDir   ImGetDirQuadrantFromDelta(float dx, float dy);    /* original C++ signature */
def im_get_dir_quadrant_from_delta(dx: float, dy: float) -> ImGuiDir:    # imgui_internal.h:485
    pass

class ImVec1:    # imgui_internal.h:490
    # float   x;    /* original C++ signature */
    x: float                                  # imgui_internal.h:492
    # constexpr ImVec1()         : x(0.0f) { }    /* original C++ signature */
    def __init__(self) -> None:               # imgui_internal.h:493
        pass
    # constexpr ImVec1(float _x) : x(_x) { }    /* original C++ signature */
    def __init__(self, _x: float) -> None:    # imgui_internal.h:494
        pass

class ImVec2ih:    # imgui_internal.h:498
    """ Helper: ImVec2ih (2D vector, half-size integer, for long-term packed storage)"""
    # short   x,     /* original C++ signature */
    x: int                                           # imgui_internal.h:500
    # y;    /* original C++ signature */
    y: int                                           # imgui_internal.h:500
    # constexpr ImVec2ih()                           : x(0), y(0) {}    /* original C++ signature */
    def __init__(self) -> None:                      # imgui_internal.h:501
        pass
    # constexpr ImVec2ih(short _x, short _y)         : x(_x), y(_y) {}    /* original C++ signature */
    def __init__(self, _x: int, _y: int) -> None:    # imgui_internal.h:502
        pass
    # constexpr explicit ImVec2ih(const ImVec2& rhs) : x((short)rhs.x), y((short)rhs.y) {}    /* original C++ signature */
    def __init__(self, rhs: ImVec2) -> None:         # imgui_internal.h:503
        pass

class ImRect:    # imgui_internal.h:508
    """ Helper: ImRect (2D axis aligned bounding-box)
     NB: we can't rely on ImVec2 math operators being available here!
    """
    # ImVec2      Min;    /* original C++ signature */
    min: ImVec2                                                                # Upper-left    # imgui_internal.h:510
    # ImVec2      Max;    /* original C++ signature */
    max: ImVec2                                                                # Lower-right    # imgui_internal.h:511

    # constexpr ImRect()                                        : Min(0.0f, 0.0f), Max(0.0f, 0.0f)  {}    /* original C++ signature */
    def __init__(self) -> None:                                                # imgui_internal.h:513
        pass
    # constexpr ImRect(const ImVec2& min, const ImVec2& max)    : Min(min), Max(max)                {}    /* original C++ signature */
    def __init__(self, min: ImVec2, max: ImVec2) -> None:                      # imgui_internal.h:514
        pass
    # constexpr ImRect(const ImVec4& v)                         : Min(v.x, v.y), Max(v.z, v.w)      {}    /* original C++ signature */
    def __init__(self, v: ImVec4) -> None:                                     # imgui_internal.h:515
        pass
    # constexpr ImRect(float x1, float y1, float x2, float y2)  : Min(x1, y1), Max(x2, y2)          {}    /* original C++ signature */
    def __init__(self, x1: float, y1: float, x2: float, y2: float) -> None:    # imgui_internal.h:516
        pass


# Helper: ImBitArray


class ImBitVector:    # imgui_internal.h:580
    """ Helper: ImBitVector
     Store 1-bit per value.
    """
    pass





#-----------------------------------------------------------------------------
# [SECTION] ImDrawList support
#-----------------------------------------------------------------------------

# ImDrawList: Helper function to calculate a circle's segment count given its radius and a "maximum error" value.
# Estimation of number of circle segment based on error is derived using method described in https://stackoverflow.com/a/2244088/15194693
# Number of segments (N) is calculated using equation:
#   N = ceil ( pi / acos(1 - error / r) )     where r > 0, error <= r
# Our equation is significantly simpler that one in the post thanks for choosing segment that is
# perpendicular to X axis. Follow steps in the article from this starting condition and you will
# will get this result.
#
# Rendering circles with an odd number of segments, while mathematically correct will produce
# asymmetrical results on the raster grid. Therefore we're rounding N to next even number (7->8, 8->8, 9->10 etc.)

# Raw equation from IM_DRAWLIST_CIRCLE_AUTO_SEGMENT_CALC rewritten for 'r' and 'error'.

# ImDrawList: Lookup table size for adaptive arc drawing, cover full circle.

class ImDrawListSharedData:    # imgui_internal.h:732
    """ Data shared between all ImDrawList instances
     You may want to create your own instance of this if you want to use ImDrawList completely without ImGui. In that case, watch out for future changes to this structure.
    """
    # ImVec2          TexUvWhitePixel;    /* original C++ signature */
    tex_uv_white_pixel: ImVec2         # UV of white pixel in the atlas    # imgui_internal.h:734
    # ImFont*         Font;    /* original C++ signature */
    font: ImFont                       # Current/default font (optional, for simplified AddText overload)    # imgui_internal.h:735
    # float           FontSize;    /* original C++ signature */
    font_size: float                   # Current/default font size (optional, for simplified AddText overload)    # imgui_internal.h:736
    # float           CurveTessellationTol;    /* original C++ signature */
    curve_tessellation_tol: float      # Tessellation tolerance when using PathBezierCurveTo()    # imgui_internal.h:737
    # float           CircleSegmentMaxError;    /* original C++ signature */
    circle_segment_max_error: float    # Number of circle segments to use per pixel of radius for AddCircle() etc    # imgui_internal.h:738
    # ImVec4          ClipRectFullscreen;    /* original C++ signature */
    clip_rect_fullscreen: ImVec4       # Value for PushClipRectFullscreen()    # imgui_internal.h:739
    # ImDrawListFlags InitialFlags;    /* original C++ signature */
    initial_flags: ImDrawListFlags     # Initial flags at the beginning of the frame (it is possible to alter flags on a per-drawlist basis afterwards)    # imgui_internal.h:740

    # [Internal] Lookup tables
    # float           ArcFastRadiusCutoff;    /* original C++ signature */
    arc_fast_radius_cutoff: float      # Cutoff radius after which arc drawing will fallback to slower PathArcTo()    # imgui_internal.h:744
    # ImU8            CircleSegmentCounts[64];    /* original C++ signature */
    circle_segment_counts: np.ndarray  # ndarray[type=ImU8, size=64]  # Precomputed segment count for given radius before we calculate it dynamically (to avoid calculation overhead)    # imgui_internal.h:745
    # const ImVec4*   TexUvLines;    /* original C++ signature */
    tex_uv_lines: ImVec4               # UV of anti-aliased lines in the atlas    # imgui_internal.h:746

    # ImDrawListSharedData();    /* original C++ signature */
    def __init__(self) -> None:        # imgui_internal.h:748
        pass

class ImDrawDataBuilder:    # imgui_internal.h:752

    # IMGUI_API void FlattenIntoSingleLayer();    /* original C++ signature */
    def flatten_into_single_layer(self) -> None:    # imgui_internal.h:759
        pass

#-----------------------------------------------------------------------------
# [SECTION] Widgets support: flags, enums, data structures
#-----------------------------------------------------------------------------

class ImGuiItemFlags_(enum.Enum):    # imgui_internal.h:768
    """ Transient per-window flags, reset at the beginning of the frame. For child window, inherited from parent on first Begin().
     This is going to be exposed in imgui.h when stabilized enough.
    """
    # ImGuiItemFlags_None                     = 0,    /* original C++ signature */
    none = enum.auto()                        # (= 0)
    # ImGuiItemFlags_NoTabStop                = 1 << 0,      /* original C++ signature */
    no_tab_stop = enum.auto()                 # (= 1 << 0)  # False     // Disable keyboard tabbing (FIXME: should merge with _NoNav)
    # ImGuiItemFlags_ButtonRepeat             = 1 << 1,      /* original C++ signature */
    button_repeat = enum.auto()               # (= 1 << 1)  # False     // Button() will return True multiple times based on io.KeyRepeatDelay and io.KeyRepeatRate settings.
    # ImGuiItemFlags_Disabled                 = 1 << 2,      /* original C++ signature */
    disabled = enum.auto()                    # (= 1 << 2)  # False     // Disable interactions but doesn't affect visuals. See BeginDisabled()/EndDisabled(). See github.com/ocornut/imgui/issues/211
    # ImGuiItemFlags_NoNav                    = 1 << 3,      /* original C++ signature */
    no_nav = enum.auto()                      # (= 1 << 3)  # False     // Disable keyboard/gamepad directional navigation (FIXME: should merge with _NoTabStop)
    # ImGuiItemFlags_NoNavDefaultFocus        = 1 << 4,      /* original C++ signature */
    no_nav_default_focus = enum.auto()        # (= 1 << 4)  # False     // Disable item being a candidate for default focus (e.g. used by title bar items)
    # ImGuiItemFlags_SelectableDontClosePopup = 1 << 5,      /* original C++ signature */
    selectable_dont_close_popup = enum.auto() # (= 1 << 5)  # False     // Disable MenuItem/Selectable() automatically closing their popup window
    # ImGuiItemFlags_MixedValue               = 1 << 6,      /* original C++ signature */
    mixed_value = enum.auto()                 # (= 1 << 6)  # False     // [BETA] Represent a mixed/indeterminate value, generally multi-selection where values differ. Currently only supported by Checkbox() (later should support all sorts of widgets)
    # ImGuiItemFlags_ReadOnly                 = 1 << 7,      /* original C++ signature */
    read_only = enum.auto()                   # (= 1 << 7)  # False     // [ALPHA] Allow hovering interactions but underlying value is not changed.
    # ImGuiItemFlags_Inputable                = 1 << 8       /* original C++ signature */
    inputable = enum.auto()                   # (= 1 << 8)  # False     // [WIP] Auto-activate input mode when tab focused. Currently only used and supported by a few items before it becomes a generic feature.

class ImGuiItemStatusFlags_(enum.Enum):    # imgui_internal.h:783
    """ Storage for LastItem data"""
    # ImGuiItemStatusFlags_None               = 0,    /* original C++ signature */
    none = enum.auto()               # (= 0)
    # ImGuiItemStatusFlags_HoveredRect        = 1 << 0,       /* original C++ signature */
    hovered_rect = enum.auto()       # (= 1 << 0)  # Mouse position is within item rectangle (does NOT mean that the window is in correct z-order and can be hovered!, this is only one part of the most-common IsItemHovered test)
    # ImGuiItemStatusFlags_HasDisplayRect     = 1 << 1,       /* original C++ signature */
    has_display_rect = enum.auto()   # (= 1 << 1)  # g.LastItemData.DisplayRect is valid
    # ImGuiItemStatusFlags_Edited             = 1 << 2,       /* original C++ signature */
    edited = enum.auto()             # (= 1 << 2)  # Value exposed by item was edited in the current frame (should match the bool return value of most widgets)
    # ImGuiItemStatusFlags_ToggledSelection   = 1 << 3,       /* original C++ signature */
    toggled_selection = enum.auto()  # (= 1 << 3)  # Set when Selectable(), TreeNode() reports toggling a selection. We can't report "Selected", only state changes, in order to easily handle clipping with less issues.
    # ImGuiItemStatusFlags_ToggledOpen        = 1 << 4,       /* original C++ signature */
    toggled_open = enum.auto()       # (= 1 << 4)  # Set when TreeNode() reports toggling their open state.
    # ImGuiItemStatusFlags_HasDeactivated     = 1 << 5,       /* original C++ signature */
    has_deactivated = enum.auto()    # (= 1 << 5)  # Set if the widget/group is able to provide data for the ImGuiItemStatusFlags_Deactivated flag.
    # ImGuiItemStatusFlags_Deactivated        = 1 << 6,       /* original C++ signature */
    deactivated = enum.auto()        # (= 1 << 6)  # Only valid if ImGuiItemStatusFlags_HasDeactivated is set.
    # ImGuiItemStatusFlags_HoveredWindow      = 1 << 7,       /* original C++ signature */
    hovered_window = enum.auto()     # (= 1 << 7)  # Override the HoveredWindow test to allow cross-window hover testing.
    # ImGuiItemStatusFlags_FocusedByTabbing   = 1 << 8        /* original C++ signature */
    focused_by_tabbing = enum.auto() # (= 1 << 8)
    # Set when the Focusable item just got focused by Tabbing (FIXME: to be removed soon)


class ImGuiInputTextFlagsPrivate_(enum.Enum):    # imgui_internal.h:806
    """ Extend ImGuiInputTextFlags_"""
    # [Internal]
    # ImGuiInputTextFlags_Multiline           = 1 << 26,      /* original C++ signature */
    im_gui_input_text_flags_multiline = enum.auto()      # (= 1 << 26)  # For internal use by InputTextMultiline()
    # ImGuiInputTextFlags_NoMarkEdited        = 1 << 27,      /* original C++ signature */
    im_gui_input_text_flags_no_mark_edited = enum.auto() # (= 1 << 27)  # For internal use by functions using InputText() before reformatting data
    # ImGuiInputTextFlags_MergedItem          = 1 << 28       /* original C++ signature */
    im_gui_input_text_flags_merged_item = enum.auto()    # (= 1 << 28)  # For internal use by TempInputText(), will skip calling ItemAdd(). Require bounding-box to strictly match.

class ImGuiButtonFlagsPrivate_(enum.Enum):    # imgui_internal.h:815
    """ Extend ImGuiButtonFlags_"""
    # ImGuiButtonFlags_PressedOnClick         = 1 << 4,       /* original C++ signature */
    im_gui_button_flags_pressed_on_click = enum.auto()                  # (= 1 << 4)  # return True on click (mouse down event)
    # ImGuiButtonFlags_PressedOnClickRelease  = 1 << 5,       /* original C++ signature */
    im_gui_button_flags_pressed_on_click_release = enum.auto()          # (= 1 << 5)  # [Default] return True on click + release on same item <-- this is what the majority of Button are using
    # ImGuiButtonFlags_PressedOnClickReleaseAnywhere = 1 << 6,     /* original C++ signature */
    im_gui_button_flags_pressed_on_click_release_anywhere = enum.auto() # (= 1 << 6)  # return True on click + release even if the release event is not done while hovering the item
    # ImGuiButtonFlags_PressedOnRelease       = 1 << 7,       /* original C++ signature */
    im_gui_button_flags_pressed_on_release = enum.auto()                # (= 1 << 7)  # return True on release (default requires click+release)
    # ImGuiButtonFlags_PressedOnDoubleClick   = 1 << 8,       /* original C++ signature */
    im_gui_button_flags_pressed_on_double_click = enum.auto()           # (= 1 << 8)  # return True on double-click (default requires click+release)
    # ImGuiButtonFlags_PressedOnDragDropHold  = 1 << 9,       /* original C++ signature */
    im_gui_button_flags_pressed_on_drag_drop_hold = enum.auto()         # (= 1 << 9)  # return True when held into while we are drag and dropping another item (used by e.g. tree nodes, collapsing headers)
    # ImGuiButtonFlags_Repeat                 = 1 << 10,      /* original C++ signature */
    im_gui_button_flags_repeat = enum.auto()                            # (= 1 << 10)  # hold to repeat
    # ImGuiButtonFlags_FlattenChildren        = 1 << 11,      /* original C++ signature */
    im_gui_button_flags_flatten_children = enum.auto()                  # (= 1 << 11)  # allow interactions even if a child window is overlapping
    # ImGuiButtonFlags_AllowItemOverlap       = 1 << 12,      /* original C++ signature */
    im_gui_button_flags_allow_item_overlap = enum.auto()                # (= 1 << 12)  # require previous frame HoveredId to either match id or be null before being usable, use along with SetItemAllowOverlap()
    # ImGuiButtonFlags_DontClosePopups        = 1 << 13,      /* original C++ signature */
    im_gui_button_flags_dont_close_popups = enum.auto()                 # (= 1 << 13)  # disable automatically closing parent popup on press // [UNUSED]
    #ImGuiButtonFlags_Disabled             = 1 << 14,  // disable interactions -> use BeginDisabled() or ImGuiItemFlags_Disabled
    # ImGuiButtonFlags_AlignTextBaseLine      = 1 << 15,      /* original C++ signature */
    im_gui_button_flags_align_text_base_line = enum.auto()              # (= 1 << 15)  # vertically align button to match text baseline - ButtonEx() only // FIXME: Should be removed and handled by SmallButton(), not possible currently because of DC.CursorPosPrevLine
    # ImGuiButtonFlags_NoKeyModifiers         = 1 << 16,      /* original C++ signature */
    im_gui_button_flags_no_key_modifiers = enum.auto()                  # (= 1 << 16)  # disable mouse interaction if a key modifier is held
    # ImGuiButtonFlags_NoHoldingActiveId      = 1 << 17,      /* original C++ signature */
    im_gui_button_flags_no_holding_active_id = enum.auto()              # (= 1 << 17)  # don't set ActiveId while holding the mouse (ImGuiButtonFlags_PressedOnClick only)
    # ImGuiButtonFlags_NoNavFocus             = 1 << 18,      /* original C++ signature */
    im_gui_button_flags_no_nav_focus = enum.auto()                      # (= 1 << 18)  # don't override navigation focus when activated
    # ImGuiButtonFlags_NoHoveredOnFocus       = 1 << 19,      /* original C++ signature */
    im_gui_button_flags_no_hovered_on_focus = enum.auto()               # (= 1 << 19)  # don't report as hovered when nav focus is on this item
    # ImGuiButtonFlags_PressedOnMask_         = ImGuiButtonFlags_PressedOnClick | ImGuiButtonFlags_PressedOnClickRelease | ImGuiButtonFlags_PressedOnClickReleaseAnywhere | ImGuiButtonFlags_PressedOnRelease | ImGuiButtonFlags_PressedOnDoubleClick | ImGuiButtonFlags_PressedOnDragDropHold,    /* original C++ signature */
    im_gui_button_flags_pressed_on_mask_ = enum.auto()                  # (= ImGuiButtonFlagsPrivate_.im_gui_button_flags_pressed_on_click | ImGuiButtonFlagsPrivate_.im_gui_button_flags_pressed_on_click_release | ImGuiButtonFlagsPrivate_.im_gui_button_flags_pressed_on_click_release_anywhere | ImGuiButtonFlagsPrivate_.im_gui_button_flags_pressed_on_release | ImGuiButtonFlagsPrivate_.im_gui_button_flags_pressed_on_double_click | ImGuiButtonFlagsPrivate_.im_gui_button_flags_pressed_on_drag_drop_hold)
    # ImGuiButtonFlags_PressedOnDefault_      = ImGuiButtonFlags_PressedOnClickRelease    /* original C++ signature */
    # }
    im_gui_button_flags_pressed_on_default_ = enum.auto()               # (= ImGuiButtonFlagsPrivate_.im_gui_button_flags_pressed_on_click_release)

class ImGuiComboFlagsPrivate_(enum.Enum):    # imgui_internal.h:838
    """ Extend ImGuiComboFlags_"""
    # ImGuiComboFlags_CustomPreview           = 1 << 20       /* original C++ signature */
    im_gui_combo_flags_custom_preview = enum.auto() # (= 1 << 20)  # enable BeginComboPreview()

class ImGuiSliderFlagsPrivate_(enum.Enum):    # imgui_internal.h:844
    """ Extend ImGuiSliderFlags_"""
    # ImGuiSliderFlags_Vertical               = 1 << 20,      /* original C++ signature */
    im_gui_slider_flags_vertical = enum.auto()  # (= 1 << 20)  # Should this slider be orientated vertically?
    # ImGuiSliderFlags_ReadOnly               = 1 << 21    /* original C++ signature */
    # }
    im_gui_slider_flags_read_only = enum.auto() # (= 1 << 21)

class ImGuiSelectableFlagsPrivate_(enum.Enum):    # imgui_internal.h:851
    """ Extend ImGuiSelectableFlags_"""
    # NB: need to be in sync with last value of ImGuiSelectableFlags_
    # ImGuiSelectableFlags_NoHoldingActiveID      = 1 << 20,    /* original C++ signature */
    im_gui_selectable_flags_no_holding_active_id = enum.auto()     # (= 1 << 20)
    # ImGuiSelectableFlags_SelectOnNav            = 1 << 21,      /* original C++ signature */
    im_gui_selectable_flags_select_on_nav = enum.auto()            # (= 1 << 21)  # (WIP) Auto-select when moved into. This is not exposed in public API as to handle multi-select and modifiers we will need user to explicitly control focus scope. May be replaced with a BeginSelection() API.
    # ImGuiSelectableFlags_SelectOnClick          = 1 << 22,      /* original C++ signature */
    im_gui_selectable_flags_select_on_click = enum.auto()          # (= 1 << 22)  # Override button behavior to react on Click (default is Click+Release)
    # ImGuiSelectableFlags_SelectOnRelease        = 1 << 23,      /* original C++ signature */
    im_gui_selectable_flags_select_on_release = enum.auto()        # (= 1 << 23)  # Override button behavior to react on Release (default is Click+Release)
    # ImGuiSelectableFlags_SpanAvailWidth         = 1 << 24,      /* original C++ signature */
    im_gui_selectable_flags_span_avail_width = enum.auto()         # (= 1 << 24)  # Span all avail width even if we declared less for layout purpose. FIXME: We may be able to remove this (added in 6251379, 2bcafc86 for menus)
    # ImGuiSelectableFlags_DrawHoveredWhenHeld    = 1 << 25,      /* original C++ signature */
    im_gui_selectable_flags_draw_hovered_when_held = enum.auto()   # (= 1 << 25)  # Always show active when held, even is not hovered. This concept could probably be renamed/formalized somehow.
    # ImGuiSelectableFlags_SetNavIdOnHover        = 1 << 26,      /* original C++ signature */
    im_gui_selectable_flags_set_nav_id_on_hover = enum.auto()      # (= 1 << 26)  # Set Nav/Focus ID on mouse hover (used by MenuItem)
    # ImGuiSelectableFlags_NoPadWithHalfSpacing   = 1 << 27       /* original C++ signature */
    im_gui_selectable_flags_no_pad_with_half_spacing = enum.auto() # (= 1 << 27)  # Disable padding each side with ItemSpacing * 0.5

class ImGuiTreeNodeFlagsPrivate_(enum.Enum):    # imgui_internal.h:865
    """ Extend ImGuiTreeNodeFlags_"""
    # ImGuiTreeNodeFlags_ClipLabelForTrailingButton = 1 << 20    /* original C++ signature */
    # }
    im_gui_tree_node_flags_clip_label_for_trailing_button = enum.auto() # (= 1 << 20)

class ImGuiSeparatorFlags_(enum.Enum):    # imgui_internal.h:870
    # ImGuiSeparatorFlags_None                = 0,    /* original C++ signature */
    none = enum.auto()             # (= 0)
    # ImGuiSeparatorFlags_Horizontal          = 1 << 0,       /* original C++ signature */
    horizontal = enum.auto()       # (= 1 << 0)  # Axis default to current layout type, so generally Horizontal unless e.g. in a menu bar
    # ImGuiSeparatorFlags_Vertical            = 1 << 1,    /* original C++ signature */
    vertical = enum.auto()         # (= 1 << 1)
    # ImGuiSeparatorFlags_SpanAllColumns      = 1 << 2    /* original C++ signature */
    # }
    span_all_columns = enum.auto() # (= 1 << 2)

class ImGuiTextFlags_(enum.Enum):    # imgui_internal.h:878
    # ImGuiTextFlags_None = 0,    /* original C++ signature */
    none = enum.auto()                            # (= 0)
    # ImGuiTextFlags_NoWidthForLargeClippedText = 1 << 0    /* original C++ signature */
    # }
    no_width_for_large_clipped_text = enum.auto() # (= 1 << 0)

class ImGuiTooltipFlags_(enum.Enum):    # imgui_internal.h:884
    # ImGuiTooltipFlags_None = 0,    /* original C++ signature */
    none = enum.auto()                      # (= 0)
    # ImGuiTooltipFlags_OverridePreviousTooltip = 1 << 0          /* original C++ signature */
    override_previous_tooltip = enum.auto() # (= 1 << 0)  # Override will clear/ignore previously submitted tooltip (defaults to append)

class ImGuiLayoutType_(enum.Enum):    # imgui_internal.h:892
    """ FIXME: this is in development, not exposed/functional as a generic feature yet.
     Horizontal/Vertical enums are fixed to 0/1 so they may be used to index ImVec2
    """
    # ImGuiLayoutType_Horizontal = 0,    /* original C++ signature */
    horizontal = enum.auto() # (= 0)
    # ImGuiLayoutType_Vertical = 1    /* original C++ signature */
    # }
    vertical = enum.auto()   # (= 1)

class ImGuiLogType(enum.Enum):    # imgui_internal.h:898
    # ImGuiLogType_None = 0,    /* original C++ signature */
    none = enum.auto()      # (= 0)
    # ImGuiLogType_TTY,    /* original C++ signature */
    tty = enum.auto()       # (= 1)
    # ImGuiLogType_File,    /* original C++ signature */
    file = enum.auto()      # (= 2)
    # ImGuiLogType_Buffer,    /* original C++ signature */
    buffer = enum.auto()    # (= 3)
    # ImGuiLogType_Clipboard    /* original C++ signature */
    # }
    clipboard = enum.auto() # (= 4)

class ImGuiAxis(enum.Enum):    # imgui_internal.h:908
    """ X/Y enums are fixed to 0/1 so they may be used to index ImVec2"""
    # ImGuiAxis_None = -1,    /* original C++ signature */
    none = enum.auto() # (= -1)
    # ImGuiAxis_X = 0,    /* original C++ signature */
    x = enum.auto()    # (= 0)
    # ImGuiAxis_Y = 1    /* original C++ signature */
    # }
    y = enum.auto()    # (= 1)

class ImGuiPlotType(enum.Enum):    # imgui_internal.h:915
    # ImGuiPlotType_Lines,    /* original C++ signature */
    lines = enum.auto()     # (= 0)
    # ImGuiPlotType_Histogram    /* original C++ signature */
    # }
    histogram = enum.auto() # (= 1)

class ImGuiPopupPositionPolicy(enum.Enum):    # imgui_internal.h:921
    # ImGuiPopupPositionPolicy_Default,    /* original C++ signature */
    default = enum.auto()   # (= 0)
    # ImGuiPopupPositionPolicy_ComboBox,    /* original C++ signature */
    combo_box = enum.auto() # (= 1)
    # ImGuiPopupPositionPolicy_Tooltip    /* original C++ signature */
    # }
    tooltip = enum.auto()   # (= 2)

class ImGuiDataTypeTempStorage:    # imgui_internal.h:928
    # ImU8        Data[8];    /* original C++ signature */
    data: np.ndarray  # ndarray[type=ImU8, size=8]  # Can fit any data up to ImGuiDataType_COUNT    # imgui_internal.h:930

class ImGuiDataTypeInfo:    # imgui_internal.h:934
    """ Type information associated to one ImGuiDataType. Retrieve with DataTypeGetInfo()."""
    # size_t      Size;    /* original C++ signature */
    size: int       # Size in bytes    # imgui_internal.h:936
    # const char* Name;    /* original C++ signature */
    name: str       # Short descriptive name for the type, for debugging    # imgui_internal.h:937
    # const char* PrintFmt;    /* original C++ signature */
    print_fmt: str  # Default printf format for the type    # imgui_internal.h:938
    # const char* ScanFmt;    /* original C++ signature */
    scan_fmt: str   # Default scanf format for the type    # imgui_internal.h:939

class ImGuiDataTypePrivate_(enum.Enum):    # imgui_internal.h:943
    """ Extend ImGuiDataType_"""
    # ImGuiDataType_String = ImGuiDataType_COUNT + 1,    /* original C++ signature */
    im_gui_data_type_string = enum.auto()  # (= ImGuiDataType_.count + 1)
    # ImGuiDataType_Pointer,    /* original C++ signature */
    im_gui_data_type_pointer = enum.auto() # (= )
    # ImGuiDataType_ID    /* original C++ signature */
    # }
    im_gui_data_type_id = enum.auto()      # (= )

class ImGuiColorMod:    # imgui_internal.h:951
    """ Stacked color modifier, backup of modified data so we can restore it"""
    # ImGuiCol        Col;    /* original C++ signature */
    col: ImGuiCol           # imgui_internal.h:953
    # ImVec4          BackupValue;    /* original C++ signature */
    backup_value: ImVec4    # imgui_internal.h:954

class ImGuiStyleMod:    # imgui_internal.h:958
    """ Stacked style modifier, backup of modified data so we can restore it. Data type inferred from the variable."""
    # ImGuiStyleVar   VarIdx;    /* original C++ signature */
    var_idx: ImGuiStyleVar                                        # imgui_internal.h:960
    # ImGuiStyleMod(ImGuiStyleVar idx, int v)     { VarIdx = idx; BackupInt[0] = v; }    /* original C++ signature */
    def __init__(self, idx: ImGuiStyleVar, v: int) -> None:       # imgui_internal.h:962
        pass
    # ImGuiStyleMod(ImGuiStyleVar idx, float v)   { VarIdx = idx; BackupFloat[0] = v; }    /* original C++ signature */
    def __init__(self, idx: ImGuiStyleVar, v: float) -> None:     # imgui_internal.h:963
        pass
    # ImGuiStyleMod(ImGuiStyleVar idx, ImVec2 v)  { VarIdx = idx; BackupFloat[0] = v.x; BackupFloat[1] = v.y; }    /* original C++ signature */
    def __init__(self, idx: ImGuiStyleVar, v: ImVec2) -> None:    # imgui_internal.h:964
        pass

class ImGuiComboPreviewData:    # imgui_internal.h:968
    """ Storage data for BeginComboPreview()/EndComboPreview()"""
    # ImRect          PreviewRect;    /* original C++ signature */
    preview_rect: ImRect                        # imgui_internal.h:970
    # ImVec2          BackupCursorPos;    /* original C++ signature */
    backup_cursor_pos: ImVec2                   # imgui_internal.h:971
    # ImVec2          BackupCursorMaxPos;    /* original C++ signature */
    backup_cursor_max_pos: ImVec2               # imgui_internal.h:972
    # ImVec2          BackupCursorPosPrevLine;    /* original C++ signature */
    backup_cursor_pos_prev_line: ImVec2         # imgui_internal.h:973
    # float           BackupPrevLineTextBaseOffset;    /* original C++ signature */
    backup_prev_line_text_base_offset: float    # imgui_internal.h:974
    # ImGuiLayoutType BackupLayout;    /* original C++ signature */
    backup_layout: ImGuiLayoutType              # imgui_internal.h:975

    # ImGuiComboPreviewData() { memset(this, 0, sizeof(*this)); }    /* original C++ signature */
    def __init__(self) -> None:                 # imgui_internal.h:977
        pass

class ImGuiGroupData:    # imgui_internal.h:981
    """ Stacked storage data for BeginGroup()/EndGroup()"""
    # ImGuiID     WindowID;    /* original C++ signature */
    window_id: ImGuiID                                # imgui_internal.h:983
    # ImVec2      BackupCursorPos;    /* original C++ signature */
    backup_cursor_pos: ImVec2                         # imgui_internal.h:984
    # ImVec2      BackupCursorMaxPos;    /* original C++ signature */
    backup_cursor_max_pos: ImVec2                     # imgui_internal.h:985
    # ImVec1      BackupIndent;    /* original C++ signature */
    backup_indent: ImVec1                             # imgui_internal.h:986
    # ImVec1      BackupGroupOffset;    /* original C++ signature */
    backup_group_offset: ImVec1                       # imgui_internal.h:987
    # ImVec2      BackupCurrLineSize;    /* original C++ signature */
    backup_curr_line_size: ImVec2                     # imgui_internal.h:988
    # float       BackupCurrLineTextBaseOffset;    /* original C++ signature */
    backup_curr_line_text_base_offset: float          # imgui_internal.h:989
    # ImGuiID     BackupActiveIdIsAlive;    /* original C++ signature */
    backup_active_id_is_alive: ImGuiID                # imgui_internal.h:990
    # bool        BackupActiveIdPreviousFrameIsAlive;    /* original C++ signature */
    backup_active_id_previous_frame_is_alive: bool    # imgui_internal.h:991
    # bool        BackupHoveredIdIsAlive;    /* original C++ signature */
    backup_hovered_id_is_alive: bool                  # imgui_internal.h:992
    # bool        EmitItem;    /* original C++ signature */
    emit_item: bool                                   # imgui_internal.h:993

class ImGuiMenuColumns:    # imgui_internal.h:997
    """ Simple column measurement, currently used for MenuItem() only.. This is very short-sighted/throw-away code and NOT a generic helper."""
    # ImU32       TotalWidth;    /* original C++ signature */
    total_width: ImU32             # imgui_internal.h:999
    # ImU32       NextTotalWidth;    /* original C++ signature */
    next_total_width: ImU32        # imgui_internal.h:1000
    # ImU16       Spacing;    /* original C++ signature */
    spacing: ImU16                 # imgui_internal.h:1001
    # ImU16       OffsetIcon;    /* original C++ signature */
    offset_icon: ImU16             # Always zero for now    # imgui_internal.h:1002
    # ImU16       OffsetLabel;    /* original C++ signature */
    offset_label: ImU16            # Offsets are locked in Update()    # imgui_internal.h:1003
    # ImU16       OffsetShortcut;    /* original C++ signature */
    offset_shortcut: ImU16         # imgui_internal.h:1004
    # ImU16       OffsetMark;    /* original C++ signature */
    offset_mark: ImU16             # imgui_internal.h:1005
    # ImU16       Widths[4];    /* original C++ signature */
    widths: np.ndarray             # ndarray[type=ImU16, size=4]  # Width of:   Icon, Label, Shortcut, Mark  (accumulators for current frame)    # imgui_internal.h:1006

    # ImGuiMenuColumns() { memset(this, 0, sizeof(*this)); }    /* original C++ signature */
    def __init__(self) -> None:    # imgui_internal.h:1008
        pass

class ImGuiInputTextState:    # imgui_internal.h:1016
    """ Internal state of the currently focused/edited text input box
     For a given item ID, access with ImGui::GetInputTextState()
    """
    # ImGuiID                 ID;    /* original C++ signature */
    id: ImGuiID                    # widget id owning the text state    # imgui_internal.h:1018
    # int                     CurLenW,     /* original C++ signature */
    cur_len_w: int                 # we need to maintain our buffer length in both UTF-8 and wchar format. UTF-8 length is valid even if TextA is not.    # imgui_internal.h:1019
    # CurLenA;    /* original C++ signature */
    cur_len_a: int                 # we need to maintain our buffer length in both UTF-8 and wchar format. UTF-8 length is valid even if TextA is not.    # imgui_internal.h:1019
    # bool                    TextAIsValid;    /* original C++ signature */
    text_a_is_valid: bool          # temporary UTF8 buffer is not initially valid before we make the widget active (until then we pull the data from user argument)    # imgui_internal.h:1023
    # int                     BufCapacityA;    /* original C++ signature */
    buf_capacity_a: int            # end-user buffer capacity    # imgui_internal.h:1024
    # float                   ScrollX;    /* original C++ signature */
    scroll_x: float                # horizontal scrolling/offset    # imgui_internal.h:1025
    # ImStb::STB_TexteditState Stb;    /* original C++ signature */
    stb: ImStb.STB_TexteditState   # state for stb_textedit.h    # imgui_internal.h:1026
    # float                   CursorAnim;    /* original C++ signature */
    cursor_anim: float             # timer for cursor blink, reset on every user action so the cursor reappears immediately    # imgui_internal.h:1027
    # bool                    CursorFollow;    /* original C++ signature */
    cursor_follow: bool            # set when we want scrolling to follow the current cursor position (not always!)    # imgui_internal.h:1028
    # bool                    SelectedAllMouseLock;    /* original C++ signature */
    selected_all_mouse_lock: bool  # after a double-click to select all, we ignore further mouse drags to update selection    # imgui_internal.h:1029
    # bool                    Edited;    /* original C++ signature */
    edited: bool                   # edited this frame    # imgui_internal.h:1030
    # ImGuiInputTextFlags     Flags;    /* original C++ signature */
    flags: ImGuiInputTextFlags     # copy of InputText() flags    # imgui_internal.h:1031

    # ImGuiInputTextState()                   { memset(this, 0, sizeof(*this)); }    /* original C++ signature */
    def __init__(self) -> None:    # imgui_internal.h:1033
        pass

    # Cursor & Selection

class ImGuiPopupData:    # imgui_internal.h:1052
    """ Storage for current popup stack"""
    # ImGuiID             PopupId;    /* original C++ signature */
    popup_id: ImGuiID              # Set on OpenPopup()    # imgui_internal.h:1054
    # ImGuiWindow*        Window;    /* original C++ signature */
    window: ImGuiWindow            # Resolved on BeginPopup() - may stay unresolved if user never calls OpenPopup()    # imgui_internal.h:1055
    # ImGuiWindow*        SourceWindow;    /* original C++ signature */
    source_window: ImGuiWindow     # Set on OpenPopup() copy of NavWindow at the time of opening the popup    # imgui_internal.h:1056
    # int                 ParentNavLayer;    /* original C++ signature */
    parent_nav_layer: int          # Resolved on BeginPopup(). Actually a ImGuiNavLayer type (declared down below), initialized to -1 which is not part of an enum, but serves well-enough as "not any of layers" value    # imgui_internal.h:1057
    # int                 OpenFrameCount;    /* original C++ signature */
    open_frame_count: int          # Set on OpenPopup()    # imgui_internal.h:1058
    # ImGuiID             OpenParentId;    /* original C++ signature */
    open_parent_id: ImGuiID        # Set on OpenPopup(), we need this to differentiate multiple menu sets from each others (e.g. inside menu bar vs loose menu items)    # imgui_internal.h:1059
    # ImVec2              OpenPopupPos;    /* original C++ signature */
    open_popup_pos: ImVec2         # Set on OpenPopup(), preferred popup position (typically == OpenMousePos when using mouse)    # imgui_internal.h:1060
    # ImVec2              OpenMousePos;    /* original C++ signature */
    open_mouse_pos: ImVec2         # Set on OpenPopup(), copy of mouse position at the time of opening popup    # imgui_internal.h:1061

    # ImGuiPopupData()    { memset(this, 0, sizeof(*this)); ParentNavLayer = OpenFrameCount = -1; }    /* original C++ signature */
    def __init__(self) -> None:    # imgui_internal.h:1063
        pass

class ImGuiNextWindowDataFlags_(enum.Enum):    # imgui_internal.h:1066
    # ImGuiNextWindowDataFlags_None               = 0,    /* original C++ signature */
    none = enum.auto()                # (= 0)
    # ImGuiNextWindowDataFlags_HasPos             = 1 << 0,    /* original C++ signature */
    has_pos = enum.auto()             # (= 1 << 0)
    # ImGuiNextWindowDataFlags_HasSize            = 1 << 1,    /* original C++ signature */
    has_size = enum.auto()            # (= 1 << 1)
    # ImGuiNextWindowDataFlags_HasContentSize     = 1 << 2,    /* original C++ signature */
    has_content_size = enum.auto()    # (= 1 << 2)
    # ImGuiNextWindowDataFlags_HasCollapsed       = 1 << 3,    /* original C++ signature */
    has_collapsed = enum.auto()       # (= 1 << 3)
    # ImGuiNextWindowDataFlags_HasSizeConstraint  = 1 << 4,    /* original C++ signature */
    has_size_constraint = enum.auto() # (= 1 << 4)
    # ImGuiNextWindowDataFlags_HasFocus           = 1 << 5,    /* original C++ signature */
    has_focus = enum.auto()           # (= 1 << 5)
    # ImGuiNextWindowDataFlags_HasBgAlpha         = 1 << 6,    /* original C++ signature */
    has_bg_alpha = enum.auto()        # (= 1 << 6)
    # ImGuiNextWindowDataFlags_HasScroll          = 1 << 7,    /* original C++ signature */
    has_scroll = enum.auto()          # (= 1 << 7)
    # ImGuiNextWindowDataFlags_HasViewport        = 1 << 8,    /* original C++ signature */
    has_viewport = enum.auto()        # (= 1 << 8)
    # ImGuiNextWindowDataFlags_HasDock            = 1 << 9,    /* original C++ signature */
    has_dock = enum.auto()            # (= 1 << 9)
    # ImGuiNextWindowDataFlags_HasWindowClass     = 1 << 10    /* original C++ signature */
    # }
    has_window_class = enum.auto()    # (= 1 << 10)

class ImGuiNextWindowData:    # imgui_internal.h:1083
    """ Storage for SetNexWindow** functions"""
    # ImGuiNextWindowDataFlags    Flags;    /* original C++ signature */
    flags: ImGuiNextWindowDataFlags    # imgui_internal.h:1085
    # ImGuiCond                   PosCond;    /* original C++ signature */
    pos_cond: ImGuiCond                # imgui_internal.h:1086
    # ImGuiCond                   SizeCond;    /* original C++ signature */
    size_cond: ImGuiCond               # imgui_internal.h:1087
    # ImGuiCond                   CollapsedCond;    /* original C++ signature */
    collapsed_cond: ImGuiCond          # imgui_internal.h:1088
    # ImGuiCond                   DockCond;    /* original C++ signature */
    dock_cond: ImGuiCond               # imgui_internal.h:1089
    # ImVec2                      PosVal;    /* original C++ signature */
    pos_val: ImVec2                    # imgui_internal.h:1090
    # ImVec2                      PosPivotVal;    /* original C++ signature */
    pos_pivot_val: ImVec2              # imgui_internal.h:1091
    # ImVec2                      SizeVal;    /* original C++ signature */
    size_val: ImVec2                   # imgui_internal.h:1092
    # ImVec2                      ContentSizeVal;    /* original C++ signature */
    content_size_val: ImVec2           # imgui_internal.h:1093
    # ImVec2                      ScrollVal;    /* original C++ signature */
    scroll_val: ImVec2                 # imgui_internal.h:1094
    # bool                        PosUndock;    /* original C++ signature */
    pos_undock: bool                   # imgui_internal.h:1095
    # bool                        CollapsedVal;    /* original C++ signature */
    collapsed_val: bool                # imgui_internal.h:1096
    # ImRect                      SizeConstraintRect;    /* original C++ signature */
    size_constraint_rect: ImRect       # imgui_internal.h:1097
    # void*                       SizeCallbackUserData;    /* original C++ signature */
    size_callback_user_data: Any       # imgui_internal.h:1099
    # float                       BgAlphaVal;    /* original C++ signature */
    bg_alpha_val: float                # Override background alpha    # imgui_internal.h:1100
    # ImGuiID                     ViewportId;    /* original C++ signature */
    viewport_id: ImGuiID               # imgui_internal.h:1101
    # ImGuiID                     DockId;    /* original C++ signature */
    dock_id: ImGuiID                   # imgui_internal.h:1102
    # ImGuiWindowClass            WindowClass;    /* original C++ signature */
    window_class: ImGuiWindowClass     # imgui_internal.h:1103
    # ImVec2                      MenuBarOffsetMinVal;    /* original C++ signature */
    menu_bar_offset_min_val: ImVec2    # (Always on) This is not exposed publicly, so we don't clear it and it doesn't have a corresponding flag (could we? for consistency?)    # imgui_internal.h:1104

    # ImGuiNextWindowData()       { memset(this, 0, sizeof(*this)); }    /* original C++ signature */
    def __init__(self) -> None:        # imgui_internal.h:1106
        pass

class ImGuiNextItemDataFlags_(enum.Enum):    # imgui_internal.h:1110
    # ImGuiNextItemDataFlags_None     = 0,    /* original C++ signature */
    none = enum.auto()      # (= 0)
    # ImGuiNextItemDataFlags_HasWidth = 1 << 0,    /* original C++ signature */
    has_width = enum.auto() # (= 1 << 0)
    # ImGuiNextItemDataFlags_HasOpen  = 1 << 1    /* original C++ signature */
    # }
    has_open = enum.auto()  # (= 1 << 1)

class ImGuiNextItemData:    # imgui_internal.h:1117
    # ImGuiNextItemDataFlags      Flags;    /* original C++ signature */
    flags: ImGuiNextItemDataFlags    # imgui_internal.h:1119
    # float                       Width;    /* original C++ signature */
    width: float                     # Set by SetNextItemWidth()    # imgui_internal.h:1120
    # ImGuiID                     FocusScopeId;    /* original C++ signature */
    focus_scope_id: ImGuiID          # Set by SetNextItemMultiSelectData() (!= 0 signify value has been set, so it's an alternate version of HasSelectionData, we don't use Flags for this because they are cleared too early. This is mostly used for debugging)    # imgui_internal.h:1121
    # ImGuiCond                   OpenCond;    /* original C++ signature */
    open_cond: ImGuiCond             # imgui_internal.h:1122
    # bool                        OpenVal;    /* original C++ signature */
    open_val: bool                   # Set by SetNextItemOpen()    # imgui_internal.h:1123

    # ImGuiNextItemData()         { memset(this, 0, sizeof(*this)); }    /* original C++ signature */
    def __init__(self) -> None:      # imgui_internal.h:1125
        pass

class ImGuiLastItemData:    # imgui_internal.h:1130
    """ Status storage for the last submitted item"""
    # ImGuiID                 ID;    /* original C++ signature */
    id: ImGuiID                         # imgui_internal.h:1132
    # ImGuiItemFlags          InFlags;    /* original C++ signature */
    in_flags: ImGuiItemFlags            # See ImGuiItemFlags_    # imgui_internal.h:1133
    # ImGuiItemStatusFlags    StatusFlags;    /* original C++ signature */
    status_flags: ImGuiItemStatusFlags  # See ImGuiItemStatusFlags_    # imgui_internal.h:1134
    # ImRect                  Rect;    /* original C++ signature */
    rect: ImRect                        # Full rectangle    # imgui_internal.h:1135
    # ImRect                  NavRect;    /* original C++ signature */
    nav_rect: ImRect                    # Navigation scoring rectangle (not displayed)    # imgui_internal.h:1136
    # ImRect                  DisplayRect;    /* original C++ signature */
    display_rect: ImRect                # Display rectangle (only if ImGuiItemStatusFlags_HasDisplayRect is set)    # imgui_internal.h:1137

    # ImGuiLastItemData()     { memset(this, 0, sizeof(*this)); }    /* original C++ signature */
    def __init__(self) -> None:         # imgui_internal.h:1139
        pass

class ImGuiStackSizes:    # imgui_internal.h:1142
    # short   SizeOfIDStack;    /* original C++ signature */
    size_of_id_stack: int             # imgui_internal.h:1144
    # short   SizeOfColorStack;    /* original C++ signature */
    size_of_color_stack: int          # imgui_internal.h:1145
    # short   SizeOfStyleVarStack;    /* original C++ signature */
    size_of_style_var_stack: int      # imgui_internal.h:1146
    # short   SizeOfFontStack;    /* original C++ signature */
    size_of_font_stack: int           # imgui_internal.h:1147
    # short   SizeOfFocusScopeStack;    /* original C++ signature */
    size_of_focus_scope_stack: int    # imgui_internal.h:1148
    # short   SizeOfGroupStack;    /* original C++ signature */
    size_of_group_stack: int          # imgui_internal.h:1149
    # short   SizeOfItemFlagsStack;    /* original C++ signature */
    size_of_item_flags_stack: int     # imgui_internal.h:1150
    # short   SizeOfBeginPopupStack;    /* original C++ signature */
    size_of_begin_popup_stack: int    # imgui_internal.h:1151
    # short   SizeOfDisabledStack;    /* original C++ signature */
    size_of_disabled_stack: int       # imgui_internal.h:1152

    # ImGuiStackSizes() { memset(this, 0, sizeof(*this)); }    /* original C++ signature */
    def __init__(self) -> None:       # imgui_internal.h:1154
        pass

class ImGuiWindowStackData:    # imgui_internal.h:1160
    """ Data saved for each window pushed into the stack"""
    # ImGuiWindow*            Window;    /* original C++ signature */
    window: ImGuiWindow                                # imgui_internal.h:1162
    # ImGuiLastItemData       ParentLastItemDataBackup;    /* original C++ signature */
    parent_last_item_data_backup: ImGuiLastItemData    # imgui_internal.h:1163
    # ImGuiStackSizes         StackSizesOnBegin;    /* original C++ signature */
    stack_sizes_on_begin: ImGuiStackSizes              # Store size of various stacks for asserting    # imgui_internal.h:1164

class ImGuiShrinkWidthItem:    # imgui_internal.h:1167
    # int         Index;    /* original C++ signature */
    index: int              # imgui_internal.h:1169
    # float       Width;    /* original C++ signature */
    width: float            # imgui_internal.h:1170
    # float       InitialWidth;    /* original C++ signature */
    initial_width: float    # imgui_internal.h:1171

class ImGuiPtrOrIndex:    # imgui_internal.h:1174
    # void*       Ptr;    /* original C++ signature */
    ptr: Any                                   # Either field can be set, not both. e.g. Dock node tab bars are loose while BeginTabBar() ones are in a pool.    # imgui_internal.h:1176
    # int         Index;    /* original C++ signature */
    index: int                                 # Usually index in a main pool.    # imgui_internal.h:1177

    # ImGuiPtrOrIndex(void* ptr)  { Ptr = ptr; Index = -1; }    /* original C++ signature */
    def __init__(self, ptr: Any) -> None:      # imgui_internal.h:1179
        pass
    # ImGuiPtrOrIndex(int index)  { Ptr = NULL; Index = index; }    /* original C++ signature */
    def __init__(self, index: int) -> None:    # imgui_internal.h:1180
        pass

#-----------------------------------------------------------------------------
# [SECTION] Inputs support
#-----------------------------------------------------------------------------


class ImGuiKeyPrivate_(enum.Enum):    # imgui_internal.h:1189
    # ImGuiKey_LegacyNativeKey_BEGIN  = 0,    /* original C++ signature */
    im_gui_key_legacy_native_key_begin = enum.auto() # (= 0)
    # ImGuiKey_LegacyNativeKey_END    = 512,    /* original C++ signature */
    im_gui_key_legacy_native_key_end = enum.auto()   # (= 512)
    # ImGuiKey_Gamepad_BEGIN          = ImGuiKey_GamepadStart,    /* original C++ signature */
    im_gui_key_gamepad_begin = enum.auto()           # (= ImGuiKey_.gamepad_start)
    # ImGuiKey_Gamepad_END            = ImGuiKey_GamepadRStickRight + 1    /* original C++ signature */
    # }
    im_gui_key_gamepad_end = enum.auto()             # (= ImGuiKey_.gamepad_r_stick_right + 1)

class ImGuiInputEventType(enum.Enum):    # imgui_internal.h:1197
    # ImGuiInputEventType_None = 0,    /* original C++ signature */
    none = enum.auto()           # (= 0)
    # ImGuiInputEventType_MousePos,    /* original C++ signature */
    mouse_pos = enum.auto()      # (= 1)
    # ImGuiInputEventType_MouseWheel,    /* original C++ signature */
    mouse_wheel = enum.auto()    # (= 2)
    # ImGuiInputEventType_MouseButton,    /* original C++ signature */
    mouse_button = enum.auto()   # (= 3)
    # ImGuiInputEventType_MouseViewport,    /* original C++ signature */
    mouse_viewport = enum.auto() # (= 4)
    # ImGuiInputEventType_Key,    /* original C++ signature */
    key = enum.auto()            # (= 5)
    # ImGuiInputEventType_Text,    /* original C++ signature */
    text = enum.auto()           # (= 6)
    # ImGuiInputEventType_Focus,    /* original C++ signature */
    focus = enum.auto()          # (= 7)
    # ImGuiInputEventType_COUNT    /* original C++ signature */
    # }
    count = enum.auto()          # (= 8)

class ImGuiInputSource(enum.Enum):    # imgui_internal.h:1210
    # ImGuiInputSource_None = 0,    /* original C++ signature */
    none = enum.auto()      # (= 0)
    # ImGuiInputSource_Mouse,    /* original C++ signature */
    mouse = enum.auto()     # (= 1)
    # ImGuiInputSource_Keyboard,    /* original C++ signature */
    keyboard = enum.auto()  # (= 2)
    # ImGuiInputSource_Gamepad,    /* original C++ signature */
    gamepad = enum.auto()   # (= 3)
    # ImGuiInputSource_Clipboard,         /* original C++ signature */
    clipboard = enum.auto() # (= 4)  # Currently only used by InputText()
    # ImGuiInputSource_Nav,               /* original C++ signature */
    nav = enum.auto()       # (= 5)  # Stored in g.ActiveIdSource only
    # ImGuiInputSource_COUNT    /* original C++ signature */
    # }
    count = enum.auto()     # (= 6)

# FIXME: Structures in the union below need to be declared as anonymous unions appears to be an extension?
# Using ImVec2() would fail on Clang 'union member 'MousePos' has a non-trivial default constructor'
class ImGuiInputEventMousePos:    # imgui_internal.h:1223
    # float PosX,     /* original C++ signature */
    pos_x: float    # imgui_internal.h:1223
    # PosY;    /* original C++ signature */
    pos_y: float    # imgui_internal.h:1223
class ImGuiInputEventMouseWheel:    # imgui_internal.h:1224
    # float WheelX,     /* original C++ signature */
    wheel_x: float    # imgui_internal.h:1224
    # WheelY;    /* original C++ signature */
    wheel_y: float    # imgui_internal.h:1224
class ImGuiInputEventMouseButton:    # imgui_internal.h:1225
    # int Button;    /* original C++ signature */
    button: int    # imgui_internal.h:1225
    # bool Down;    /* original C++ signature */
    down: bool     # imgui_internal.h:1225
class ImGuiInputEventMouseViewport:    # imgui_internal.h:1226
    # ImGuiID HoveredViewportID;    /* original C++ signature */
    hovered_viewport_id: ImGuiID    # imgui_internal.h:1226
class ImGuiInputEventKey:    # imgui_internal.h:1227
    # ImGuiKey Key;    /* original C++ signature */
    key: ImGuiKey          # imgui_internal.h:1227
    # bool Down;    /* original C++ signature */
    down: bool             # imgui_internal.h:1227
    # float AnalogValue;    /* original C++ signature */
    analog_value: float    # imgui_internal.h:1227
class ImGuiInputEventText:    # imgui_internal.h:1228
    # unsigned int Char;    /* original C++ signature */
    char: int    # imgui_internal.h:1228
class ImGuiInputEventAppFocused:    # imgui_internal.h:1229
    # bool Focused;    /* original C++ signature */
    focused: bool    # imgui_internal.h:1229

class ImGuiInputEvent:    # imgui_internal.h:1231
    # ImGuiInputEventType             Type;    /* original C++ signature */
    type: ImGuiInputEventType      # imgui_internal.h:1233
    # ImGuiInputSource                Source;    /* original C++ signature */
    source: ImGuiInputSource       # imgui_internal.h:1234
    # bool                            AddedByTestEngine;    /* original C++ signature */
    added_by_test_engine: bool     # imgui_internal.h:1245

    # ImGuiInputEvent() { memset(this, 0, sizeof(*this)); }    /* original C++ signature */
    def __init__(self) -> None:    # imgui_internal.h:1247
        pass

class ImGuiNavReadMode(enum.Enum):    # imgui_internal.h:1251
    """ FIXME-NAV: Clarify/expose various repeat delay/rate"""
    # ImGuiNavReadMode_Down,    /* original C++ signature */
    down = enum.auto()        # (= 0)
    # ImGuiNavReadMode_Pressed,    /* original C++ signature */
    pressed = enum.auto()     # (= 1)
    # ImGuiNavReadMode_Released,    /* original C++ signature */
    released = enum.auto()    # (= 2)
    # ImGuiNavReadMode_Repeat,    /* original C++ signature */
    repeat = enum.auto()      # (= 3)
    # ImGuiNavReadMode_RepeatSlow,    /* original C++ signature */
    repeat_slow = enum.auto() # (= 4)
    # ImGuiNavReadMode_RepeatFast    /* original C++ signature */
    # }
    repeat_fast = enum.auto() # (= 5)

#-----------------------------------------------------------------------------
# [SECTION] Clipper support
#-----------------------------------------------------------------------------

class ImGuiListClipperRange:    # imgui_internal.h:1265
    # int     Min;    /* original C++ signature */
    min: int                       # imgui_internal.h:1267
    # int     Max;    /* original C++ signature */
    max: int                       # imgui_internal.h:1268
    # bool    PosToIndexConvert;    /* original C++ signature */
    pos_to_index_convert: bool     # Begin/End are absolute position (will be converted to indices later)    # imgui_internal.h:1269
    # ImS8    PosToIndexOffsetMin;    /* original C++ signature */
    pos_to_index_offset_min: ImS8  # Add to Min after converting to indices    # imgui_internal.h:1270
    # ImS8    PosToIndexOffsetMax;    /* original C++ signature */
    pos_to_index_offset_max: ImS8  # Add to Min after converting to indices    # imgui_internal.h:1271


class ImGuiListClipperData:    # imgui_internal.h:1278
    """ Temporary clipper data, buffers shared/reused between instances"""
    # ImGuiListClipper*               ListClipper;    /* original C++ signature */
    list_clipper: ImGuiListClipper    # imgui_internal.h:1280
    # float                           LossynessOffset;    /* original C++ signature */
    lossyness_offset: float           # imgui_internal.h:1281
    # int                             StepNo;    /* original C++ signature */
    step_no: int                      # imgui_internal.h:1282
    # int                             ItemsFrozen;    /* original C++ signature */
    items_frozen: int                 # imgui_internal.h:1283

    # ImGuiListClipperData()          { memset(this, 0, sizeof(*this)); }    /* original C++ signature */
    def __init__(self) -> None:       # imgui_internal.h:1286
        pass

#-----------------------------------------------------------------------------
# [SECTION] Navigation support
#-----------------------------------------------------------------------------

class ImGuiActivateFlags_(enum.Enum):    # imgui_internal.h:1294
    # ImGuiActivateFlags_None                 = 0,    /* original C++ signature */
    none = enum.auto()                  # (= 0)
    # ImGuiActivateFlags_PreferInput          = 1 << 0,           /* original C++ signature */
    prefer_input = enum.auto()          # (= 1 << 0)  # Favor activation that requires keyboard text input (e.g. for Slider/Drag). Default if keyboard is available.
    # ImGuiActivateFlags_PreferTweak          = 1 << 1,           /* original C++ signature */
    prefer_tweak = enum.auto()          # (= 1 << 1)  # Favor activation for tweaking with arrows or gamepad (e.g. for Slider/Drag). Default if keyboard is not available.
    # ImGuiActivateFlags_TryToPreserveState   = 1 << 2            /* original C++ signature */
    try_to_preserve_state = enum.auto() # (= 1 << 2)  # Request widget to preserve state if it can (e.g. InputText will try to preserve cursor/selection)

class ImGuiScrollFlags_(enum.Enum):    # imgui_internal.h:1303
    """ Early work-in-progress API for ScrollToItem()"""
    # ImGuiScrollFlags_None                   = 0,    /* original C++ signature */
    none = enum.auto()                  # (= 0)
    # ImGuiScrollFlags_KeepVisibleEdgeX       = 1 << 0,           /* original C++ signature */
    keep_visible_edge_x = enum.auto()   # (= 1 << 0)  # If item is not visible: scroll as little as possible on X axis to bring item back into view [default for X axis]
    # ImGuiScrollFlags_KeepVisibleEdgeY       = 1 << 1,           /* original C++ signature */
    keep_visible_edge_y = enum.auto()   # (= 1 << 1)  # If item is not visible: scroll as little as possible on Y axis to bring item back into view [default for Y axis for windows that are already visible]
    # ImGuiScrollFlags_KeepVisibleCenterX     = 1 << 2,           /* original C++ signature */
    keep_visible_center_x = enum.auto() # (= 1 << 2)  # If item is not visible: scroll to make the item centered on X axis [rarely used]
    # ImGuiScrollFlags_KeepVisibleCenterY     = 1 << 3,           /* original C++ signature */
    keep_visible_center_y = enum.auto() # (= 1 << 3)  # If item is not visible: scroll to make the item centered on Y axis
    # ImGuiScrollFlags_AlwaysCenterX          = 1 << 4,           /* original C++ signature */
    always_center_x = enum.auto()       # (= 1 << 4)  # Always center the result item on X axis [rarely used]
    # ImGuiScrollFlags_AlwaysCenterY          = 1 << 5,           /* original C++ signature */
    always_center_y = enum.auto()       # (= 1 << 5)  # Always center the result item on Y axis [default for Y axis for appearing window)
    # ImGuiScrollFlags_NoScrollParent         = 1 << 6,           /* original C++ signature */
    no_scroll_parent = enum.auto()      # (= 1 << 6)  # Disable forwarding scrolling to parent window if required to keep item/rect visible (only scroll window the function was applied to).
    # ImGuiScrollFlags_MaskX_                 = ImGuiScrollFlags_KeepVisibleEdgeX | ImGuiScrollFlags_KeepVisibleCenterX | ImGuiScrollFlags_AlwaysCenterX,    /* original C++ signature */
    mask_x_ = enum.auto()               # (= ImGuiScrollFlags_.keep_visible_edge_x | ImGuiScrollFlags_.keep_visible_center_x | ImGuiScrollFlags_.always_center_x)
    # ImGuiScrollFlags_MaskY_                 = ImGuiScrollFlags_KeepVisibleEdgeY | ImGuiScrollFlags_KeepVisibleCenterY | ImGuiScrollFlags_AlwaysCenterY    /* original C++ signature */
    # }
    mask_y_ = enum.auto()               # (= ImGuiScrollFlags_.keep_visible_edge_y | ImGuiScrollFlags_.keep_visible_center_y | ImGuiScrollFlags_.always_center_y)

class ImGuiNavHighlightFlags_(enum.Enum):    # imgui_internal.h:1317
    # ImGuiNavHighlightFlags_None             = 0,    /* original C++ signature */
    none = enum.auto()         # (= 0)
    # ImGuiNavHighlightFlags_TypeDefault      = 1 << 0,    /* original C++ signature */
    type_default = enum.auto() # (= 1 << 0)
    # ImGuiNavHighlightFlags_TypeThin         = 1 << 1,    /* original C++ signature */
    type_thin = enum.auto()    # (= 1 << 1)
    # ImGuiNavHighlightFlags_AlwaysDraw       = 1 << 2,           /* original C++ signature */
    always_draw = enum.auto()  # (= 1 << 2)  # Draw rectangular highlight if (g.NavId == id) _even_ when using the mouse.
    # ImGuiNavHighlightFlags_NoRounding       = 1 << 3    /* original C++ signature */
    # }
    no_rounding = enum.auto()  # (= 1 << 3)

class ImGuiNavDirSourceFlags_(enum.Enum):    # imgui_internal.h:1326
    # ImGuiNavDirSourceFlags_None             = 0,    /* original C++ signature */
    none = enum.auto()         # (= 0)
    # ImGuiNavDirSourceFlags_RawKeyboard      = 1 << 0,       /* original C++ signature */
    raw_keyboard = enum.auto() # (= 1 << 0)  # Raw keyboard (not pulled from nav), facilitate use of some functions before we can unify nav and keys
    # ImGuiNavDirSourceFlags_Keyboard         = 1 << 1,    /* original C++ signature */
    keyboard = enum.auto()     # (= 1 << 1)
    # ImGuiNavDirSourceFlags_PadDPad          = 1 << 2,    /* original C++ signature */
    pad_d_pad = enum.auto()    # (= 1 << 2)
    # ImGuiNavDirSourceFlags_PadLStick        = 1 << 3    /* original C++ signature */
    # }
    pad_l_stick = enum.auto()  # (= 1 << 3)

class ImGuiNavMoveFlags_(enum.Enum):    # imgui_internal.h:1335
    # ImGuiNavMoveFlags_None                  = 0,    /* original C++ signature */
    none = enum.auto()                   # (= 0)
    # ImGuiNavMoveFlags_LoopX                 = 1 << 0,       /* original C++ signature */
    loop_x = enum.auto()                 # (= 1 << 0)  # On failed request, restart from opposite side
    # ImGuiNavMoveFlags_LoopY                 = 1 << 1,    /* original C++ signature */
    loop_y = enum.auto()                 # (= 1 << 1)
    # ImGuiNavMoveFlags_WrapX                 = 1 << 2,       /* original C++ signature */
    wrap_x = enum.auto()                 # (= 1 << 2)  # On failed request, request from opposite side one line down (when NavDir==right) or one line up (when NavDir==left)
    # ImGuiNavMoveFlags_WrapY                 = 1 << 3,       /* original C++ signature */
    wrap_y = enum.auto()                 # (= 1 << 3)  # This is not super useful but provided for completeness
    # ImGuiNavMoveFlags_AllowCurrentNavId     = 1 << 4,       /* original C++ signature */
    allow_current_nav_id = enum.auto()   # (= 1 << 4)  # Allow scoring and considering the current NavId as a move target candidate. This is used when the move source is offset (e.g. pressing PageDown actually needs to send a Up move request, if we are pressing PageDown from the bottom-most item we need to stay in place)
    # ImGuiNavMoveFlags_AlsoScoreVisibleSet   = 1 << 5,       /* original C++ signature */
    also_score_visible_set = enum.auto() # (= 1 << 5)  # Store alternate result in NavMoveResultLocalVisible that only comprise elements that are already fully visible (used by PageUp/PageDown)
    # ImGuiNavMoveFlags_ScrollToEdgeY         = 1 << 6,       /* original C++ signature */
    scroll_to_edge_y = enum.auto()       # (= 1 << 6)  # Force scrolling to min/max (used by Home/End) // FIXME-NAV: Aim to remove or reword, probably unnecessary
    # ImGuiNavMoveFlags_Forwarded             = 1 << 7,    /* original C++ signature */
    forwarded = enum.auto()              # (= 1 << 7)
    # ImGuiNavMoveFlags_DebugNoResult         = 1 << 8,       /* original C++ signature */
    debug_no_result = enum.auto()        # (= 1 << 8)  # Dummy scoring for debug purpose, don't apply result
    # ImGuiNavMoveFlags_FocusApi              = 1 << 9,    /* original C++ signature */
    focus_api = enum.auto()              # (= 1 << 9)
    # ImGuiNavMoveFlags_Tabbing               = 1 << 10,      /* original C++ signature */
    tabbing = enum.auto()                # (= 1 << 10)  # == Focus + Activate if item is Inputable + DontChangeNavHighlight
    # ImGuiNavMoveFlags_Activate              = 1 << 11,    /* original C++ signature */
    activate = enum.auto()               # (= 1 << 11)
    # ImGuiNavMoveFlags_DontSetNavHighlight   = 1 << 12       /* original C++ signature */
    dont_set_nav_highlight = enum.auto() # (= 1 << 12)  # Do not alter the visible state of keyboard vs mouse nav highlight

class ImGuiNavLayer(enum.Enum):    # imgui_internal.h:1353
    # ImGuiNavLayer_Main  = 0,        /* original C++ signature */
    main = enum.auto()  # (= 0)  # Main scrolling layer
    # ImGuiNavLayer_Menu  = 1,        /* original C++ signature */
    menu = enum.auto()  # (= 1)  # Menu layer (access with Alt/ImGuiNavInput_Menu)
    # ImGuiNavLayer_COUNT    /* original C++ signature */
    # }
    count = enum.auto() # (= 2)

class ImGuiNavItemData:    # imgui_internal.h:1360
    # ImGuiWindow*        Window;    /* original C++ signature */
    window: ImGuiWindow            # Init,Move    // Best candidate window (result->ItemWindow->RootWindowForNav == request->Window)    # imgui_internal.h:1362
    # ImGuiID             ID;    /* original C++ signature */
    id: ImGuiID                    # Init,Move    // Best candidate item ID    # imgui_internal.h:1363
    # ImGuiID             FocusScopeId;    /* original C++ signature */
    focus_scope_id: ImGuiID        # Init,Move    // Best candidate focus scope ID    # imgui_internal.h:1364
    # ImRect              RectRel;    /* original C++ signature */
    rect_rel: ImRect               # Init,Move    // Best candidate bounding box in window relative space    # imgui_internal.h:1365
    # ImGuiItemFlags      InFlags;    /* original C++ signature */
    in_flags: ImGuiItemFlags       # ????,Move    // Best candidate item flags    # imgui_internal.h:1366
    # float               DistBox;    /* original C++ signature */
    dist_box: float                #      Move    // Best candidate box distance to current NavId    # imgui_internal.h:1367
    # float               DistCenter;    /* original C++ signature */
    dist_center: float             #      Move    // Best candidate center distance to current NavId    # imgui_internal.h:1368
    # float               DistAxial;    /* original C++ signature */
    dist_axial: float              #      Move    // Best candidate axial distance to current NavId    # imgui_internal.h:1369

    # ImGuiNavItemData()  { Clear(); }    /* original C++ signature */
    def __init__(self) -> None:    # imgui_internal.h:1371
        pass

#-----------------------------------------------------------------------------
# [SECTION] Columns support
#-----------------------------------------------------------------------------

class ImGuiOldColumnFlags_(enum.Enum):    # imgui_internal.h:1380
    """ Flags for internal's BeginColumns(). Prefix using BeginTable() nowadays!"""
    # ImGuiOldColumnFlags_None                    = 0,    /* original C++ signature */
    none = enum.auto()                      # (= 0)
    # ImGuiOldColumnFlags_NoBorder                = 1 << 0,       /* original C++ signature */
    no_border = enum.auto()                 # (= 1 << 0)  # Disable column dividers
    # ImGuiOldColumnFlags_NoResize                = 1 << 1,       /* original C++ signature */
    no_resize = enum.auto()                 # (= 1 << 1)  # Disable resizing columns when clicking on the dividers
    # ImGuiOldColumnFlags_NoPreserveWidths        = 1 << 2,       /* original C++ signature */
    no_preserve_widths = enum.auto()        # (= 1 << 2)  # Disable column width preservation when adjusting columns
    # ImGuiOldColumnFlags_NoForceWithinWindow     = 1 << 3,       /* original C++ signature */
    no_force_within_window = enum.auto()    # (= 1 << 3)  # Disable forcing columns to fit within window
    # ImGuiOldColumnFlags_GrowParentContentsSize  = 1 << 4        /* original C++ signature */
    grow_parent_contents_size = enum.auto() # (= 1 << 4)
    # (WIP) Restore pre-1.51 behavior of extending the parent window contents size but _without affecting the columns width at all_. Will eventually remove.

    # Obsolete names (will be removed)

class ImGuiOldColumnData:    # imgui_internal.h:1400
    # float               OffsetNorm;    /* original C++ signature */
    offset_norm: float                  # Column start offset, normalized 0.0 (far left) -> 1.0 (far right)    # imgui_internal.h:1402
    # float               OffsetNormBeforeResize;    /* original C++ signature */
    offset_norm_before_resize: float    # imgui_internal.h:1403
    # ImGuiOldColumnFlags Flags;    /* original C++ signature */
    flags: ImGuiOldColumnFlags          # Not exposed    # imgui_internal.h:1404
    # ImRect              ClipRect;    /* original C++ signature */
    clip_rect: ImRect                   # imgui_internal.h:1405

    # ImGuiOldColumnData() { memset(this, 0, sizeof(*this)); }    /* original C++ signature */
    def __init__(self) -> None:         # imgui_internal.h:1407
        pass

class ImGuiOldColumns:    # imgui_internal.h:1410
    # ImGuiID             ID;    /* original C++ signature */
    id: ImGuiID                           # imgui_internal.h:1412
    # ImGuiOldColumnFlags Flags;    /* original C++ signature */
    flags: ImGuiOldColumnFlags            # imgui_internal.h:1413
    # bool                IsFirstFrame;    /* original C++ signature */
    is_first_frame: bool                  # imgui_internal.h:1414
    # bool                IsBeingResized;    /* original C++ signature */
    is_being_resized: bool                # imgui_internal.h:1415
    # int                 Current;    /* original C++ signature */
    current: int                          # imgui_internal.h:1416
    # int                 Count;    /* original C++ signature */
    count: int                            # imgui_internal.h:1417
    # float               OffMinX,     /* original C++ signature */
    off_min_x: float                      # Offsets from HostWorkRect.Min.x    # imgui_internal.h:1418
    # OffMaxX;    /* original C++ signature */
    off_max_x: float                      # Offsets from HostWorkRect.Min.x    # imgui_internal.h:1418
    # float               LineMinY,     /* original C++ signature */
    line_min_y: float                     # imgui_internal.h:1419
    # LineMaxY;    /* original C++ signature */
    line_max_y: float                     # imgui_internal.h:1419
    # float               HostCursorPosY;    /* original C++ signature */
    host_cursor_pos_y: float              # Backup of CursorPos at the time of BeginColumns()    # imgui_internal.h:1420
    # float               HostCursorMaxPosX;    /* original C++ signature */
    host_cursor_max_pos_x: float          # Backup of CursorMaxPos at the time of BeginColumns()    # imgui_internal.h:1421
    # ImRect              HostInitialClipRect;    /* original C++ signature */
    host_initial_clip_rect: ImRect        # Backup of ClipRect at the time of BeginColumns()    # imgui_internal.h:1422
    # ImRect              HostBackupClipRect;    /* original C++ signature */
    host_backup_clip_rect: ImRect         # Backup of ClipRect during PushColumnsBackground()/PopColumnsBackground()    # imgui_internal.h:1423
    # ImRect              HostBackupParentWorkRect;    /* original C++ signature */
    host_backup_parent_work_rect: ImRect  #Backup of WorkRect at the time of BeginColumns()    # imgui_internal.h:1424
    # ImDrawListSplitter  Splitter;    /* original C++ signature */
    splitter: ImDrawListSplitter          # imgui_internal.h:1426

    # ImGuiOldColumns()   { memset(this, 0, sizeof(*this)); }    /* original C++ signature */
    def __init__(self) -> None:           # imgui_internal.h:1428
        pass

#-----------------------------------------------------------------------------
# [SECTION] Multi-select support
#-----------------------------------------------------------------------------


#-----------------------------------------------------------------------------
# [SECTION] Docking support
#-----------------------------------------------------------------------------


class ImGuiDockNodeFlagsPrivate_(enum.Enum):    # imgui_internal.h:1446
    """ Extend ImGuiDockNodeFlags_"""
    # [Internal]
    # ImGuiDockNodeFlags_DockSpace                = 1 << 10,      /* original C++ signature */
    im_gui_dock_node_flags_dock_space = enum.auto()                 # (= 1 << 10)  # Local, Saved  // A dockspace is a node that occupy space within an existing user window. Otherwise the node is floating and create its own window.
    # ImGuiDockNodeFlags_CentralNode              = 1 << 11,      /* original C++ signature */
    im_gui_dock_node_flags_central_node = enum.auto()               # (= 1 << 11)  # Local, Saved  // The central node has 2 main properties: stay visible when empty, only use "remaining" spaces from its neighbor.
    # ImGuiDockNodeFlags_NoTabBar                 = 1 << 12,      /* original C++ signature */
    im_gui_dock_node_flags_no_tab_bar = enum.auto()                 # (= 1 << 12)  # Local, Saved  // Tab bar is completely unavailable. No triangle in the corner to enable it back.
    # ImGuiDockNodeFlags_HiddenTabBar             = 1 << 13,      /* original C++ signature */
    im_gui_dock_node_flags_hidden_tab_bar = enum.auto()             # (= 1 << 13)  # Local, Saved  // Tab bar is hidden, with a triangle in the corner to show it again (NB: actual tab-bar instance may be destroyed as this is only used for single-window tab bar)
    # ImGuiDockNodeFlags_NoWindowMenuButton       = 1 << 14,      /* original C++ signature */
    im_gui_dock_node_flags_no_window_menu_button = enum.auto()      # (= 1 << 14)  # Local, Saved  // Disable window/docking menu (that one that appears instead of the collapse button)
    # ImGuiDockNodeFlags_NoCloseButton            = 1 << 15,      /* original C++ signature */
    im_gui_dock_node_flags_no_close_button = enum.auto()            # (= 1 << 15)  # Local, Saved  //
    # ImGuiDockNodeFlags_NoDocking                = 1 << 16,      /* original C++ signature */
    im_gui_dock_node_flags_no_docking = enum.auto()                 # (= 1 << 16)  # Local, Saved  // Disable any form of docking in this dockspace or individual node. (On a whole dockspace, this pretty much defeat the purpose of using a dockspace at all). Note: when turned on, existing docked nodes will be preserved.
    # ImGuiDockNodeFlags_NoDockingSplitMe         = 1 << 17,      /* original C++ signature */
    im_gui_dock_node_flags_no_docking_split_me = enum.auto()        # (= 1 << 17)  # [EXPERIMENTAL] Prevent another window/node from splitting this node.
    # ImGuiDockNodeFlags_NoDockingSplitOther      = 1 << 18,      /* original C++ signature */
    im_gui_dock_node_flags_no_docking_split_other = enum.auto()     # (= 1 << 18)  # [EXPERIMENTAL] Prevent this node from splitting another window/node.
    # ImGuiDockNodeFlags_NoDockingOverMe          = 1 << 19,      /* original C++ signature */
    im_gui_dock_node_flags_no_docking_over_me = enum.auto()         # (= 1 << 19)  # [EXPERIMENTAL] Prevent another window/node to be docked over this node.
    # ImGuiDockNodeFlags_NoDockingOverOther       = 1 << 20,      /* original C++ signature */
    im_gui_dock_node_flags_no_docking_over_other = enum.auto()      # (= 1 << 20)  # [EXPERIMENTAL] Prevent this node to be docked over another window or non-empty node.
    # ImGuiDockNodeFlags_NoDockingOverEmpty       = 1 << 21,      /* original C++ signature */
    im_gui_dock_node_flags_no_docking_over_empty = enum.auto()      # (= 1 << 21)  # [EXPERIMENTAL] Prevent this node to be docked over an empty node (e.g. DockSpace with no other windows)
    # ImGuiDockNodeFlags_NoResizeX                = 1 << 22,      /* original C++ signature */
    im_gui_dock_node_flags_no_resize_x = enum.auto()                # (= 1 << 22)  # [EXPERIMENTAL]
    # ImGuiDockNodeFlags_NoResizeY                = 1 << 23,      /* original C++ signature */
    im_gui_dock_node_flags_no_resize_y = enum.auto()                # (= 1 << 23)  # [EXPERIMENTAL]
    # ImGuiDockNodeFlags_SharedFlagsInheritMask_  = ~0,    /* original C++ signature */
    im_gui_dock_node_flags_shared_flags_inherit_mask_ = enum.auto() # (= ~0)
    # ImGuiDockNodeFlags_NoResizeFlagsMask_       = ImGuiDockNodeFlags_NoResize | ImGuiDockNodeFlags_NoResizeX | ImGuiDockNodeFlags_NoResizeY,    /* original C++ signature */
    im_gui_dock_node_flags_no_resize_flags_mask_ = enum.auto()      # (= ImGuiDockNodeFlags_.no_resize | ImGuiDockNodeFlagsPrivate_.im_gui_dock_node_flags_no_resize_x | ImGuiDockNodeFlagsPrivate_.im_gui_dock_node_flags_no_resize_y)
    # ImGuiDockNodeFlags_LocalFlagsMask_          = ImGuiDockNodeFlags_NoSplit | ImGuiDockNodeFlags_NoResizeFlagsMask_ | ImGuiDockNodeFlags_AutoHideTabBar | ImGuiDockNodeFlags_DockSpace | ImGuiDockNodeFlags_CentralNode | ImGuiDockNodeFlags_NoTabBar | ImGuiDockNodeFlags_HiddenTabBar | ImGuiDockNodeFlags_NoWindowMenuButton | ImGuiDockNodeFlags_NoCloseButton | ImGuiDockNodeFlags_NoDocking,    /* original C++ signature */
    im_gui_dock_node_flags_local_flags_mask_ = enum.auto()          # (= ImGuiDockNodeFlags_.no_split | ImGuiDockNodeFlagsPrivate_.im_gui_dock_node_flags_no_resize_flags_mask_ | ImGuiDockNodeFlags_.auto_hide_tab_bar | ImGuiDockNodeFlagsPrivate_.im_gui_dock_node_flags_dock_space | ImGuiDockNodeFlagsPrivate_.im_gui_dock_node_flags_central_node | ImGuiDockNodeFlagsPrivate_.im_gui_dock_node_flags_no_tab_bar | ImGuiDockNodeFlagsPrivate_.im_gui_dock_node_flags_hidden_tab_bar | ImGuiDockNodeFlagsPrivate_.im_gui_dock_node_flags_no_window_menu_button | ImGuiDockNodeFlagsPrivate_.im_gui_dock_node_flags_no_close_button | ImGuiDockNodeFlagsPrivate_.im_gui_dock_node_flags_no_docking)
    # ImGuiDockNodeFlags_LocalFlagsTransferMask_  = ImGuiDockNodeFlags_LocalFlagsMask_ & ~ImGuiDockNodeFlags_DockSpace,      /* original C++ signature */
    im_gui_dock_node_flags_local_flags_transfer_mask_ = enum.auto() # (= ImGuiDockNodeFlagsPrivate_.im_gui_dock_node_flags_local_flags_mask_  ~ImGuiDockNodeFlagsPrivate_.im_gui_dock_node_flags_dock_space)  # When splitting those flags are moved to the inheriting child, never duplicated
    # ImGuiDockNodeFlags_SavedFlagsMask_          = ImGuiDockNodeFlags_NoResizeFlagsMask_ | ImGuiDockNodeFlags_DockSpace | ImGuiDockNodeFlags_CentralNode | ImGuiDockNodeFlags_NoTabBar | ImGuiDockNodeFlags_HiddenTabBar | ImGuiDockNodeFlags_NoWindowMenuButton | ImGuiDockNodeFlags_NoCloseButton | ImGuiDockNodeFlags_NoDocking    /* original C++ signature */
    # }
    im_gui_dock_node_flags_saved_flags_mask_ = enum.auto()          # (= ImGuiDockNodeFlagsPrivate_.im_gui_dock_node_flags_no_resize_flags_mask_ | ImGuiDockNodeFlagsPrivate_.im_gui_dock_node_flags_dock_space | ImGuiDockNodeFlagsPrivate_.im_gui_dock_node_flags_central_node | ImGuiDockNodeFlagsPrivate_.im_gui_dock_node_flags_no_tab_bar | ImGuiDockNodeFlagsPrivate_.im_gui_dock_node_flags_hidden_tab_bar | ImGuiDockNodeFlagsPrivate_.im_gui_dock_node_flags_no_window_menu_button | ImGuiDockNodeFlagsPrivate_.im_gui_dock_node_flags_no_close_button | ImGuiDockNodeFlagsPrivate_.im_gui_dock_node_flags_no_docking)

class ImGuiDataAuthority_(enum.Enum):    # imgui_internal.h:1471
    """ Store the source authority (dock node vs window) of a field"""
    # ImGuiDataAuthority_Auto,    /* original C++ signature */
    auto = enum.auto()      # (= 0)
    # ImGuiDataAuthority_DockNode,    /* original C++ signature */
    dock_node = enum.auto() # (= 1)
    # ImGuiDataAuthority_Window    /* original C++ signature */
    # }
    window = enum.auto()    # (= 2)

class ImGuiDockNodeState(enum.Enum):    # imgui_internal.h:1478
    # ImGuiDockNodeState_Unknown,    /* original C++ signature */
    unknown = enum.auto()                                         # (= 0)
    # ImGuiDockNodeState_HostWindowHiddenBecauseSingleWindow,    /* original C++ signature */
    host_window_hidden_because_single_window = enum.auto()        # (= 1)
    # ImGuiDockNodeState_HostWindowHiddenBecauseWindowsAreResizing,    /* original C++ signature */
    host_window_hidden_because_windows_are_resizing = enum.auto() # (= 2)
    # ImGuiDockNodeState_HostWindowVisible    /* original C++ signature */
    # }
    host_window_visible = enum.auto()                             # (= 3)

class ImGuiDockNode:    # imgui_internal.h:1487
    """ sizeof() 156~192"""
    # ImGuiID                 ID;    /* original C++ signature */
    id: ImGuiID                                 # imgui_internal.h:1489
    # ImGuiDockNodeFlags      SharedFlags;    /* original C++ signature */
    shared_flags: ImGuiDockNodeFlags            # (Write) Flags shared by all nodes of a same dockspace hierarchy (inherited from the root node)    # imgui_internal.h:1490
    # ImGuiDockNodeFlags      LocalFlags;    /* original C++ signature */
    local_flags: ImGuiDockNodeFlags             # (Write) Flags specific to this node    # imgui_internal.h:1491
    # ImGuiDockNodeFlags      LocalFlagsInWindows;    /* original C++ signature */
    local_flags_in_windows: ImGuiDockNodeFlags  # (Write) Flags specific to this node, applied from windows    # imgui_internal.h:1492
    # ImGuiDockNodeFlags      MergedFlags;    /* original C++ signature */
    merged_flags: ImGuiDockNodeFlags            # (Read)  Effective flags (== SharedFlags | LocalFlagsInNode | LocalFlagsInWindows)    # imgui_internal.h:1493
    # ImGuiDockNodeState      State;    /* original C++ signature */
    state: ImGuiDockNodeState                   # imgui_internal.h:1494
    # ImGuiDockNode*          ParentNode;    /* original C++ signature */
    parent_node: ImGuiDockNode                  # imgui_internal.h:1495
    # ImGuiTabBar*            TabBar;    /* original C++ signature */
    tab_bar: ImGuiTabBar                        # imgui_internal.h:1498
    # ImVec2                  Pos;    /* original C++ signature */
    pos: ImVec2                                 # Current position    # imgui_internal.h:1499
    # ImVec2                  Size;    /* original C++ signature */
    size: ImVec2                                # Current size    # imgui_internal.h:1500
    # ImVec2                  SizeRef;    /* original C++ signature */
    size_ref: ImVec2                            # [Split node only] Last explicitly written-to size (overridden when using a splitter affecting the node), used to calculate Size.    # imgui_internal.h:1501
    # ImGuiAxis               SplitAxis;    /* original C++ signature */
    split_axis: ImGuiAxis                       # [Split node only] Split axis (X or Y)    # imgui_internal.h:1502
    # ImGuiWindowClass        WindowClass;    /* original C++ signature */
    window_class: ImGuiWindowClass              # [Root node only]    # imgui_internal.h:1503
    # ImU32                   LastBgColor;    /* original C++ signature */
    last_bg_color: ImU32                        # imgui_internal.h:1504

    # ImGuiWindow*            HostWindow;    /* original C++ signature */
    host_window: ImGuiWindow                    # imgui_internal.h:1506
    # ImGuiWindow*            VisibleWindow;    /* original C++ signature */
    visible_window: ImGuiWindow                 # Generally point to window which is ID is == SelectedTabID, but when CTRL+Tabbing this can be a different window.    # imgui_internal.h:1507
    # ImGuiDockNode*          CentralNode;    /* original C++ signature */
    central_node: ImGuiDockNode                 # [Root node only] Pointer to central node.    # imgui_internal.h:1508
    # ImGuiDockNode*          OnlyNodeWithWindows;    /* original C++ signature */
    only_node_with_windows: ImGuiDockNode       # [Root node only] Set when there is a single visible node within the hierarchy.    # imgui_internal.h:1509
    # int                     CountNodeWithWindows;    /* original C++ signature */
    count_node_with_windows: int                # [Root node only]    # imgui_internal.h:1510
    # int                     LastFrameAlive;    /* original C++ signature */
    last_frame_alive: int                       # Last frame number the node was updated or kept alive explicitly with DockSpace() + ImGuiDockNodeFlags_KeepAliveOnly    # imgui_internal.h:1511
    # int                     LastFrameActive;    /* original C++ signature */
    last_frame_active: int                      # Last frame number the node was updated.    # imgui_internal.h:1512
    # int                     LastFrameFocused;    /* original C++ signature */
    last_frame_focused: int                     # Last frame number the node was focused.    # imgui_internal.h:1513
    # ImGuiID                 LastFocusedNodeId;    /* original C++ signature */
    last_focused_node_id: ImGuiID               # [Root node only] Which of our child docking node (any ancestor in the hierarchy) was last focused.    # imgui_internal.h:1514
    # ImGuiID                 SelectedTabId;    /* original C++ signature */
    selected_tab_id: ImGuiID                    # [Leaf node only] Which of our tab/window is selected.    # imgui_internal.h:1515
    # ImGuiID                 WantCloseTabId;    /* original C++ signature */
    want_close_tab_id: ImGuiID                  # [Leaf node only] Set when closing a specific tab/window.    # imgui_internal.h:1516

    # ImGuiDockNode(ImGuiID id);    /* original C++ signature */
    def __init__(self, id: ImGuiID) -> None:    # imgui_internal.h:1532
        pass


class ImGuiWindowDockStyleCol(enum.Enum):    # imgui_internal.h:1553
    """ List of colors that are stored at the time of Begin() into Docked Windows.
     We currently store the packed colors in a simple array window->DockStyle.Colors[].
     A better solution may involve appending into a log of colors in ImGuiContext + store offsets into those arrays in ImGuiWindow,
     but it would be more complex as we'd need to double-buffer both as e.g. drop target may refer to window from last frame.
    """
    # ImGuiWindowDockStyleCol_Text,    /* original C++ signature */
    text = enum.auto()                 # (= 0)
    # ImGuiWindowDockStyleCol_Tab,    /* original C++ signature */
    tab = enum.auto()                  # (= 1)
    # ImGuiWindowDockStyleCol_TabHovered,    /* original C++ signature */
    tab_hovered = enum.auto()          # (= 2)
    # ImGuiWindowDockStyleCol_TabActive,    /* original C++ signature */
    tab_active = enum.auto()           # (= 3)
    # ImGuiWindowDockStyleCol_TabUnfocused,    /* original C++ signature */
    tab_unfocused = enum.auto()        # (= 4)
    # ImGuiWindowDockStyleCol_TabUnfocusedActive,    /* original C++ signature */
    tab_unfocused_active = enum.auto() # (= 5)
    # ImGuiWindowDockStyleCol_COUNT    /* original C++ signature */
    # }
    count = enum.auto()                # (= 6)

class ImGuiWindowDockStyle:    # imgui_internal.h:1564
    pass

class ImGuiDockContext:    # imgui_internal.h:1569
    # ImGuiStorage                    Nodes;    /* original C++ signature */
    nodes: ImGuiStorage            # Map ID -> ImGuiDockNode*: Active nodes    # imgui_internal.h:1571
    # bool                            WantFullRebuild;    /* original C++ signature */
    want_full_rebuild: bool        # imgui_internal.h:1574
    # ImGuiDockContext()              { memset(this, 0, sizeof(*this)); }    /* original C++ signature */
    def __init__(self) -> None:    # imgui_internal.h:1575
        pass


#-----------------------------------------------------------------------------
# [SECTION] Viewport support
#-----------------------------------------------------------------------------

class ImGuiViewportP:    # imgui_internal.h:1586
    """ ImGuiViewport Private/Internals fields (cardinal sin: we are using inheritance!)
     Every instance of ImGuiViewport is in fact a ImGuiViewportP.
    """
    # int                 Idx;    /* original C++ signature */
    idx: int                                # imgui_internal.h:1588
    # int                 LastFrameActive;    /* original C++ signature */
    last_frame_active: int                  # Last frame number this viewport was activated by a window    # imgui_internal.h:1589
    # int                 LastFrontMostStampCount;    /* original C++ signature */
    last_front_most_stamp_count: int        # Last stamp number from when a window hosted by this viewport was made front-most (by comparing this value between two viewport we have an implicit viewport z-order    # imgui_internal.h:1590
    # ImGuiID             LastNameHash;    /* original C++ signature */
    last_name_hash: ImGuiID                 # imgui_internal.h:1591
    # ImVec2              LastPos;    /* original C++ signature */
    last_pos: ImVec2                        # imgui_internal.h:1592
    # float               Alpha;    /* original C++ signature */
    alpha: float                            # Window opacity (when dragging dockable windows/viewports we make them transparent)    # imgui_internal.h:1593
    # float               LastAlpha;    /* original C++ signature */
    last_alpha: float                       # imgui_internal.h:1594
    # short               PlatformMonitor;    /* original C++ signature */
    platform_monitor: int                   # imgui_internal.h:1595
    # bool                PlatformWindowCreated;    /* original C++ signature */
    platform_window_created: bool           # imgui_internal.h:1596
    # ImGuiWindow*        Window;    /* original C++ signature */
    window: ImGuiWindow                     # Set when the viewport is owned by a window (and ImGuiViewportFlags_CanHostOtherWindows is NOT set)    # imgui_internal.h:1597
    # int                 DrawListsLastFrame[2];    /* original C++ signature */
    draw_lists_last_frame: np.ndarray       # ndarray[type=int, size=2]  # Last frame number the background (0) and foreground (1) draw lists were used    # imgui_internal.h:1598
    # ImDrawData          DrawDataP;    /* original C++ signature */
    draw_data_p: ImDrawData                 # imgui_internal.h:1600
    # ImDrawDataBuilder   DrawDataBuilder;    /* original C++ signature */
    draw_data_builder: ImDrawDataBuilder    # imgui_internal.h:1601
    # ImVec2              LastPlatformPos;    /* original C++ signature */
    last_platform_pos: ImVec2               # imgui_internal.h:1602
    # ImVec2              LastPlatformSize;    /* original C++ signature */
    last_platform_size: ImVec2              # imgui_internal.h:1603
    # ImVec2              LastRendererSize;    /* original C++ signature */
    last_renderer_size: ImVec2              # imgui_internal.h:1604
    # ImVec2              WorkOffsetMin;    /* original C++ signature */
    work_offset_min: ImVec2                 # Work Area: Offset from Pos to top-left corner of Work Area. Generally (0,0) or (0,+main_menu_bar_height). Work Area is Full Area but without menu-bars/status-bars (so WorkArea always fit inside Pos/Size!)    # imgui_internal.h:1605
    # ImVec2              WorkOffsetMax;    /* original C++ signature */
    work_offset_max: ImVec2                 # Work Area: Offset from Pos+Size to bottom-right corner of Work Area. Generally (0,0) or (0,-status_bar_height).    # imgui_internal.h:1606
    # ImVec2              BuildWorkOffsetMin;    /* original C++ signature */
    build_work_offset_min: ImVec2           # Work Area: Offset being built during current frame. Generally >= 0.0.    # imgui_internal.h:1607
    # ImVec2              BuildWorkOffsetMax;    /* original C++ signature */
    build_work_offset_max: ImVec2           # Work Area: Offset being built during current frame. Generally <= 0.0.    # imgui_internal.h:1608

    # ImGuiViewportP()                    { Idx = -1; LastFrameActive = DrawListsLastFrame[0] = DrawListsLastFrame[1] = LastFrontMostStampCount = -1; LastNameHash = 0; Alpha = LastAlpha = 1.0f; PlatformMonitor = -1; PlatformWindowCreated = false; Window = NULL; DrawLists[0] = DrawLists[1] = NULL; LastPlatformPos = LastPlatformSize = LastRendererSize = ImVec2(FLT_MAX, FLT_MAX); }    /* original C++ signature */
    def __init__(self) -> None:             # imgui_internal.h:1610
        pass

    # Calculate work rect pos/size given a set of offset (we have 1 pair of offset for rect locked from last frame data, and 1 pair for currently building rect)

    # Helpers to retrieve ImRect (we don't need to store BuildWorkRect as every access tend to change it, hence the code asymmetry)

#-----------------------------------------------------------------------------
# [SECTION] Settings support
#-----------------------------------------------------------------------------

class ImGuiWindowSettings:    # imgui_internal.h:1632
    """ Windows data saved in imgui.ini file
     Because we never destroy or rename ImGuiWindowSettings, we can store the names in a separate buffer easily.
     (this is designed to be stored in a ImChunkStream buffer, with the variable-length Name following our structure)
    """
    # ImGuiID     ID;    /* original C++ signature */
    id: ImGuiID                    # imgui_internal.h:1634
    # ImVec2ih    Pos;    /* original C++ signature */
    pos: ImVec2ih                  # NB: Settings position are stored RELATIVE to the viewport! Whereas runtime ones are absolute positions.    # imgui_internal.h:1635
    # ImVec2ih    Size;    /* original C++ signature */
    size: ImVec2ih                 # imgui_internal.h:1636
    # ImVec2ih    ViewportPos;    /* original C++ signature */
    viewport_pos: ImVec2ih         # imgui_internal.h:1637
    # ImGuiID     ViewportId;    /* original C++ signature */
    viewport_id: ImGuiID           # imgui_internal.h:1638
    # ImGuiID     DockId;    /* original C++ signature */
    dock_id: ImGuiID               # ID of last known DockNode (even if the DockNode is invisible because it has only 1 active window), or 0 if none.    # imgui_internal.h:1639
    # ImGuiID     ClassId;    /* original C++ signature */
    class_id: ImGuiID              # ID of window class if specified    # imgui_internal.h:1640
    # short       DockOrder;    /* original C++ signature */
    dock_order: int                # Order of the last time the window was visible within its DockNode. This is used to reorder windows that are reappearing on the same frame. Same value between windows that were active and windows that were none are possible.    # imgui_internal.h:1641
    # bool        Collapsed;    /* original C++ signature */
    collapsed: bool                # imgui_internal.h:1642
    # bool        WantApply;    /* original C++ signature */
    want_apply: bool               # Set when loaded from .ini data (to enable merging/loading .ini data into an already running context)    # imgui_internal.h:1643

    # ImGuiWindowSettings()       { memset(this, 0, sizeof(*this)); DockOrder = -1; }    /* original C++ signature */
    def __init__(self) -> None:    # imgui_internal.h:1645
        pass

class ImGuiSettingsHandler:    # imgui_internal.h:1649
    # const char* TypeName;    /* original C++ signature */
    type_name: str                 # Short description stored in .ini file. Disallowed characters: '[' ']'    # imgui_internal.h:1651
    # ImGuiID     TypeHash;    /* original C++ signature */
    type_hash: ImGuiID             # == ImHashStr(TypeName)    # imgui_internal.h:1652
    # void*       UserData;    /* original C++ signature */
    user_data: Any                 # imgui_internal.h:1659

    # ImGuiSettingsHandler() { memset(this, 0, sizeof(*this)); }    /* original C++ signature */
    def __init__(self) -> None:    # imgui_internal.h:1661
        pass

#-----------------------------------------------------------------------------
# [SECTION] Metrics, Debug Tools
#-----------------------------------------------------------------------------

class ImGuiDebugLogFlags_(enum.Enum):    # imgui_internal.h:1668
    # Event types
    # ImGuiDebugLogFlags_None             = 0,    /* original C++ signature */
    none = enum.auto()            # (= 0)
    # ImGuiDebugLogFlags_EventActiveId    = 1 << 0,    /* original C++ signature */
    event_active_id = enum.auto() # (= 1 << 0)
    # ImGuiDebugLogFlags_EventFocus       = 1 << 1,    /* original C++ signature */
    event_focus = enum.auto()     # (= 1 << 1)
    # ImGuiDebugLogFlags_EventPopup       = 1 << 2,    /* original C++ signature */
    event_popup = enum.auto()     # (= 1 << 2)
    # ImGuiDebugLogFlags_EventNav         = 1 << 3,    /* original C++ signature */
    event_nav = enum.auto()       # (= 1 << 3)
    # ImGuiDebugLogFlags_EventIO          = 1 << 4,    /* original C++ signature */
    event_io = enum.auto()        # (= 1 << 4)
    # ImGuiDebugLogFlags_EventDocking     = 1 << 5,    /* original C++ signature */
    event_docking = enum.auto()   # (= 1 << 5)
    # ImGuiDebugLogFlags_EventViewport    = 1 << 6,    /* original C++ signature */
    event_viewport = enum.auto()  # (= 1 << 6)
    # ImGuiDebugLogFlags_EventMask_       = ImGuiDebugLogFlags_EventActiveId  | ImGuiDebugLogFlags_EventFocus | ImGuiDebugLogFlags_EventPopup | ImGuiDebugLogFlags_EventNav | ImGuiDebugLogFlags_EventIO | ImGuiDebugLogFlags_EventDocking | ImGuiDebugLogFlags_EventViewport,    /* original C++ signature */
    event_mask_ = enum.auto()     # (= ImGuiDebugLogFlags_.event_active_id  | ImGuiDebugLogFlags_.event_focus | ImGuiDebugLogFlags_.event_popup | ImGuiDebugLogFlags_.event_nav | ImGuiDebugLogFlags_.event_io | ImGuiDebugLogFlags_.event_docking | ImGuiDebugLogFlags_.event_viewport)
    # ImGuiDebugLogFlags_OutputToTTY      = 1 << 10       /* original C++ signature */
    output_to_tty = enum.auto()   # (= 1 << 10)  # Also send output to TTY

class ImGuiMetricsConfig:    # imgui_internal.h:1683
    # bool        ShowDebugLog;    /* original C++ signature */
    show_debug_log: bool                  # imgui_internal.h:1685
    # bool        ShowStackTool;    /* original C++ signature */
    show_stack_tool: bool                 # imgui_internal.h:1686
    # bool        ShowWindowsRects;    /* original C++ signature */
    show_windows_rects: bool              # imgui_internal.h:1687
    # bool        ShowWindowsBeginOrder;    /* original C++ signature */
    show_windows_begin_order: bool        # imgui_internal.h:1688
    # bool        ShowTablesRects;    /* original C++ signature */
    show_tables_rects: bool               # imgui_internal.h:1689
    # bool        ShowDrawCmdMesh;    /* original C++ signature */
    show_draw_cmd_mesh: bool              # imgui_internal.h:1690
    # bool        ShowDrawCmdBoundingBoxes;    /* original C++ signature */
    show_draw_cmd_bounding_boxes: bool    # imgui_internal.h:1691
    # bool        ShowDockingNodes;    /* original C++ signature */
    show_docking_nodes: bool              # imgui_internal.h:1692
    # int         ShowWindowsRectsType;    /* original C++ signature */
    show_windows_rects_type: int          # imgui_internal.h:1693
    # int         ShowTablesRectsType;    /* original C++ signature */
    show_tables_rects_type: int           # imgui_internal.h:1694

    # ImGuiMetricsConfig()    /* original C++ signature */
    #     {
    #         ShowDebugLog = ShowStackTool = ShowWindowsRects = ShowWindowsBeginOrder = ShowTablesRects = false;
    #         ShowDrawCmdMesh = true;
    #         ShowDrawCmdBoundingBoxes = true;
    #         ShowDockingNodes = false;
    #         ShowWindowsRectsType = ShowTablesRectsType = -1;
    #     }
    def __init__(self) -> None:           # imgui_internal.h:1696
        pass

class ImGuiStackLevelInfo:    # imgui_internal.h:1706
    # ImGuiID                 ID;    /* original C++ signature */
    id: ImGuiID                    # imgui_internal.h:1708
    # ImS8                    QueryFrameCount;    /* original C++ signature */
    query_frame_count: ImS8        # >= 1: Query in progress    # imgui_internal.h:1709
    # bool                    QuerySuccess;    /* original C++ signature */
    query_success: bool            # Obtained result from DebugHookIdInfo()    # imgui_internal.h:1710

    # ImGuiStackLevelInfo()   { memset(this, 0, sizeof(*this)); }    /* original C++ signature */
    def __init__(self) -> None:    # imgui_internal.h:1714
        pass

class ImGuiStackTool:    # imgui_internal.h:1718
    """ State for Stack tool queries"""
    # int                     LastActiveFrame;    /* original C++ signature */
    last_active_frame: int                # imgui_internal.h:1720
    # int                     StackLevel;    /* original C++ signature */
    stack_level: int                      # -1: query stack and resize Results, >= 0: individual stack level    # imgui_internal.h:1721
    # ImGuiID                 QueryId;    /* original C++ signature */
    query_id: ImGuiID                     # ID to query details for    # imgui_internal.h:1722
    # bool                    CopyToClipboardOnCtrlC;    /* original C++ signature */
    copy_to_clipboard_on_ctrl_c: bool     # imgui_internal.h:1724
    # float                   CopyToClipboardLastTime;    /* original C++ signature */
    copy_to_clipboard_last_time: float    # imgui_internal.h:1725

    # ImGuiStackTool()        { memset(this, 0, sizeof(*this)); CopyToClipboardLastTime = -FLT_MAX; }    /* original C++ signature */
    def __init__(self) -> None:           # imgui_internal.h:1727
        pass

#-----------------------------------------------------------------------------
# [SECTION] Generic context hooks
#-----------------------------------------------------------------------------

class ImGuiContextHookType(enum.Enum):    # imgui_internal.h:1735
    # ImGuiContextHookType_NewFramePre,     /* original C++ signature */
    new_frame_pre = enum.auto()    # (= 0)
    # ImGuiContextHookType_NewFramePost,     /* original C++ signature */
    new_frame_post = enum.auto()   # (= 1)
    # ImGuiContextHookType_EndFramePre,     /* original C++ signature */
    end_frame_pre = enum.auto()    # (= 2)
    # ImGuiContextHookType_EndFramePost,     /* original C++ signature */
    end_frame_post = enum.auto()   # (= 3)
    # ImGuiContextHookType_RenderPre,     /* original C++ signature */
    render_pre = enum.auto()       # (= 4)
    # ImGuiContextHookType_RenderPost,     /* original C++ signature */
    render_post = enum.auto()      # (= 5)
    # ImGuiContextHookType_Shutdown,     /* original C++ signature */
    shutdown = enum.auto()         # (= 6)
    # ImGuiContextHookType_PendingRemoval_ }    /* original C++ signature */
    pending_removal_ = enum.auto() # (= 7)

class ImGuiContextHook:    # imgui_internal.h:1737
    # ImGuiID                     HookId;    /* original C++ signature */
    hook_id: ImGuiID               # A unique ID assigned by AddContextHook()    # imgui_internal.h:1739
    # ImGuiContextHookType        Type;    /* original C++ signature */
    type: ImGuiContextHookType     # imgui_internal.h:1740
    # ImGuiID                     Owner;    /* original C++ signature */
    owner: ImGuiID                 # imgui_internal.h:1741
    # void*                       UserData;    /* original C++ signature */
    user_data: Any                 # imgui_internal.h:1743

    # ImGuiContextHook()          { memset(this, 0, sizeof(*this)); }    /* original C++ signature */
    def __init__(self) -> None:    # imgui_internal.h:1745
        pass

#-----------------------------------------------------------------------------
# [SECTION] ImGuiContext (main Dear ImGui context)
#-----------------------------------------------------------------------------

class ImGuiContext:    # imgui_internal.h:1752
    # bool                    Initialized;    /* original C++ signature */
    initialized: bool                                              # imgui_internal.h:1754
    # bool                    FontAtlasOwnedByContext;    /* original C++ signature */
    font_atlas_owned_by_context: bool                              # IO.Fonts-> is owned by the ImGuiContext and will be destructed along with it.    # imgui_internal.h:1755
    # ImGuiIO                 IO;    /* original C++ signature */
    io: ImGuiIO                                                    # imgui_internal.h:1756
    # ImGuiPlatformIO         PlatformIO;    /* original C++ signature */
    platform_io: ImGuiPlatformIO                                   # imgui_internal.h:1757
    # ImGuiStyle              Style;    /* original C++ signature */
    style: ImGuiStyle                                              # imgui_internal.h:1760
    # ImGuiConfigFlags        ConfigFlagsCurrFrame;    /* original C++ signature */
    config_flags_curr_frame: ImGuiConfigFlags                      # = g.IO.ConfigFlags at the time of NewFrame()    # imgui_internal.h:1761
    # ImGuiConfigFlags        ConfigFlagsLastFrame;    /* original C++ signature */
    config_flags_last_frame: ImGuiConfigFlags                      # imgui_internal.h:1762
    # ImFont*                 Font;    /* original C++ signature */
    font: ImFont                                                   # (Shortcut) == FontStack.empty() ? IO.Font : FontStack.back()    # imgui_internal.h:1763
    # float                   FontSize;    /* original C++ signature */
    font_size: float                                               # (Shortcut) == FontBaseSize * g.CurrentWindow->FontWindowScale == window->FontSize(). Text height for current window.    # imgui_internal.h:1764
    # float                   FontBaseSize;    /* original C++ signature */
    font_base_size: float                                          # (Shortcut) == IO.FontGlobalScale * Font->Scale * Font->FontSize. Base text height.    # imgui_internal.h:1765
    # ImDrawListSharedData    DrawListSharedData;    /* original C++ signature */
    draw_list_shared_data: ImDrawListSharedData                    # imgui_internal.h:1766
    # double                  Time;    /* original C++ signature */
    time: float                                                    # imgui_internal.h:1767
    # int                     FrameCount;    /* original C++ signature */
    frame_count: int                                               # imgui_internal.h:1768
    # int                     FrameCountEnded;    /* original C++ signature */
    frame_count_ended: int                                         # imgui_internal.h:1769
    # int                     FrameCountPlatformEnded;    /* original C++ signature */
    frame_count_platform_ended: int                                # imgui_internal.h:1770
    # int                     FrameCountRendered;    /* original C++ signature */
    frame_count_rendered: int                                      # imgui_internal.h:1771
    # bool                    WithinFrameScope;    /* original C++ signature */
    within_frame_scope: bool                                       # Set by NewFrame(), cleared by EndFrame()    # imgui_internal.h:1772
    # bool                    WithinFrameScopeWithImplicitWindow;    /* original C++ signature */
    within_frame_scope_with_implicit_window: bool                  # Set by NewFrame(), cleared by EndFrame() when the implicit debug window has been pushed    # imgui_internal.h:1773
    # bool                    WithinEndChild;    /* original C++ signature */
    within_end_child: bool                                         # Set within EndChild()    # imgui_internal.h:1774
    # bool                    GcCompactAll;    /* original C++ signature */
    gc_compact_all: bool                                           # Request full GC    # imgui_internal.h:1775
    # bool                    TestEngineHookItems;    /* original C++ signature */
    test_engine_hook_items: bool                                   # Will call test engine hooks: ImGuiTestEngineHook_ItemAdd(), ImGuiTestEngineHook_ItemInfo(), ImGuiTestEngineHook_Log()    # imgui_internal.h:1776
    # void*                   TestEngine;    /* original C++ signature */
    test_engine: Any                                               # Test engine user data    # imgui_internal.h:1777

    # Windows state
    # ImGuiStorage            WindowsById;    /* original C++ signature */
    windows_by_id: ImGuiStorage                                    # Map window's ImGuiID to ImGuiWindow*    # imgui_internal.h:1784
    # int                     WindowsActiveCount;    /* original C++ signature */
    windows_active_count: int                                      # Number of unique windows submitted by frame    # imgui_internal.h:1785
    # ImVec2                  WindowsHoverPadding;    /* original C++ signature */
    windows_hover_padding: ImVec2                                  # Padding around resizable windows for which hovering on counts as hovering the window == ImMax(style.TouchExtraPadding, WINDOWS_HOVER_PADDING)    # imgui_internal.h:1786
    # ImGuiWindow*            CurrentWindow;    /* original C++ signature */
    current_window: ImGuiWindow                                    # Window being drawn into    # imgui_internal.h:1787
    # ImGuiWindow*            HoveredWindow;    /* original C++ signature */
    hovered_window: ImGuiWindow                                    # Window the mouse is hovering. Will typically catch mouse inputs.    # imgui_internal.h:1788
    # ImGuiWindow*            HoveredWindowUnderMovingWindow;    /* original C++ signature */
    hovered_window_under_moving_window: ImGuiWindow                # Hovered window ignoring MovingWindow. Only set if MovingWindow is set.    # imgui_internal.h:1789
    # ImGuiDockNode*          HoveredDockNode;    /* original C++ signature */
    hovered_dock_node: ImGuiDockNode                               # [Debug] Hovered dock node.    # imgui_internal.h:1790
    # ImGuiWindow*            MovingWindow;    /* original C++ signature */
    moving_window: ImGuiWindow                                     # Track the window we clicked on (in order to preserve focus). The actual window that is moved is generally MovingWindow->RootWindowDockTree.    # imgui_internal.h:1791
    # ImGuiWindow*            WheelingWindow;    /* original C++ signature */
    wheeling_window: ImGuiWindow                                   # Track the window we started mouse-wheeling on. Until a timer elapse or mouse has moved, generally keep scrolling the same window even if during the course of scrolling the mouse ends up hovering a child window.    # imgui_internal.h:1792
    # ImVec2                  WheelingWindowRefMousePos;    /* original C++ signature */
    wheeling_window_ref_mouse_pos: ImVec2                          # imgui_internal.h:1793
    # float                   WheelingWindowTimer;    /* original C++ signature */
    wheeling_window_timer: float                                   # imgui_internal.h:1794

    # Item/widgets state and tracking information
    # ImGuiID                 DebugHookIdInfo;    /* original C++ signature */
    debug_hook_id_info: ImGuiID                                    # Will call core hooks: DebugHookIdInfo() from GetID functions, used by Stack Tool [next HoveredId/ActiveId to not pull in an extra cache-line]    # imgui_internal.h:1797
    # ImGuiID                 HoveredId;    /* original C++ signature */
    hovered_id: ImGuiID                                            # Hovered widget, filled during the frame    # imgui_internal.h:1798
    # ImGuiID                 HoveredIdPreviousFrame;    /* original C++ signature */
    hovered_id_previous_frame: ImGuiID                             # imgui_internal.h:1799
    # bool                    HoveredIdAllowOverlap;    /* original C++ signature */
    hovered_id_allow_overlap: bool                                 # imgui_internal.h:1800
    # bool                    HoveredIdUsingMouseWheel;    /* original C++ signature */
    hovered_id_using_mouse_wheel: bool                             # Hovered widget will use mouse wheel. Blocks scrolling the underlying window.    # imgui_internal.h:1801
    # bool                    HoveredIdPreviousFrameUsingMouseWheel;    /* original C++ signature */
    hovered_id_previous_frame_using_mouse_wheel: bool              # imgui_internal.h:1802
    # bool                    HoveredIdDisabled;    /* original C++ signature */
    hovered_id_disabled: bool                                      # At least one widget passed the rect test, but has been discarded by disabled flag or popup inhibit. May be True even if HoveredId == 0.    # imgui_internal.h:1803
    # float                   HoveredIdTimer;    /* original C++ signature */
    hovered_id_timer: float                                        # Measure contiguous hovering time    # imgui_internal.h:1804
    # float                   HoveredIdNotActiveTimer;    /* original C++ signature */
    hovered_id_not_active_timer: float                             # Measure contiguous hovering time where the item has not been active    # imgui_internal.h:1805
    # ImGuiID                 ActiveId;    /* original C++ signature */
    active_id: ImGuiID                                             # Active widget    # imgui_internal.h:1806
    # ImGuiID                 ActiveIdIsAlive;    /* original C++ signature */
    active_id_is_alive: ImGuiID                                    # Active widget has been seen this frame (we can't use a bool as the ActiveId may change within the frame)    # imgui_internal.h:1807
    # float                   ActiveIdTimer;    /* original C++ signature */
    active_id_timer: float                                         # imgui_internal.h:1808
    # bool                    ActiveIdIsJustActivated;    /* original C++ signature */
    active_id_is_just_activated: bool                              # Set at the time of activation for one frame    # imgui_internal.h:1809
    # bool                    ActiveIdAllowOverlap;    /* original C++ signature */
    active_id_allow_overlap: bool                                  # Active widget allows another widget to steal active id (generally for overlapping widgets, but not always)    # imgui_internal.h:1810
    # bool                    ActiveIdNoClearOnFocusLoss;    /* original C++ signature */
    active_id_no_clear_on_focus_loss: bool                         # Disable losing active id if the active id window gets unfocused.    # imgui_internal.h:1811
    # bool                    ActiveIdHasBeenPressedBefore;    /* original C++ signature */
    active_id_has_been_pressed_before: bool                        # Track whether the active id led to a press (this is to allow changing between PressOnClick and PressOnRelease without pressing twice). Used by range_select branch.    # imgui_internal.h:1812
    # bool                    ActiveIdHasBeenEditedBefore;    /* original C++ signature */
    active_id_has_been_edited_before: bool                         # Was the value associated to the widget Edited over the course of the Active state.    # imgui_internal.h:1813
    # bool                    ActiveIdHasBeenEditedThisFrame;    /* original C++ signature */
    active_id_has_been_edited_this_frame: bool                     # imgui_internal.h:1814
    # ImVec2                  ActiveIdClickOffset;    /* original C++ signature */
    active_id_click_offset: ImVec2                                 # Clicked offset from upper-left corner, if applicable (currently only set by ButtonBehavior)    # imgui_internal.h:1815
    # ImGuiWindow*            ActiveIdWindow;    /* original C++ signature */
    active_id_window: ImGuiWindow                                  # imgui_internal.h:1816
    # ImGuiInputSource        ActiveIdSource;    /* original C++ signature */
    active_id_source: ImGuiInputSource                             # Activating with mouse or nav (gamepad/keyboard)    # imgui_internal.h:1817
    # int                     ActiveIdMouseButton;    /* original C++ signature */
    active_id_mouse_button: int                                    # imgui_internal.h:1818
    # ImGuiID                 ActiveIdPreviousFrame;    /* original C++ signature */
    active_id_previous_frame: ImGuiID                              # imgui_internal.h:1819
    # bool                    ActiveIdPreviousFrameIsAlive;    /* original C++ signature */
    active_id_previous_frame_is_alive: bool                        # imgui_internal.h:1820
    # bool                    ActiveIdPreviousFrameHasBeenEditedBefore;    /* original C++ signature */
    active_id_previous_frame_has_been_edited_before: bool          # imgui_internal.h:1821
    # ImGuiWindow*            ActiveIdPreviousFrameWindow;    /* original C++ signature */
    active_id_previous_frame_window: ImGuiWindow                   # imgui_internal.h:1822
    # ImGuiID                 LastActiveId;    /* original C++ signature */
    last_active_id: ImGuiID                                        # Store the last non-zero ActiveId, useful for animation.    # imgui_internal.h:1823
    # float                   LastActiveIdTimer;    /* original C++ signature */
    last_active_id_timer: float                                    # Store the last non-zero ActiveId timer since the beginning of activation, useful for animation.    # imgui_internal.h:1824

    # Input Ownership
    # bool                    ActiveIdUsingMouseWheel;    /* original C++ signature */
    active_id_using_mouse_wheel: bool                              # Active widget will want to read mouse wheel. Blocks scrolling the underlying window.    # imgui_internal.h:1827
    # ImU32                   ActiveIdUsingNavDirMask;    /* original C++ signature */
    active_id_using_nav_dir_mask: ImU32                            # Active widget will want to read those nav move requests (e.g. can activate a button and move away from it)    # imgui_internal.h:1828
    # ImU32                   ActiveIdUsingNavInputMask;    /* original C++ signature */
    active_id_using_nav_input_mask: ImU32                          # Active widget will want to read those nav inputs.    # imgui_internal.h:1829

    # Next window/item data
    # ImGuiItemFlags          CurrentItemFlags;    /* original C++ signature */
    current_item_flags: ImGuiItemFlags                             # == g.ItemFlagsStack.back()    # imgui_internal.h:1833
    # ImGuiNextItemData       NextItemData;    /* original C++ signature */
    next_item_data: ImGuiNextItemData                              # Storage for SetNextItem** functions    # imgui_internal.h:1834
    # ImGuiLastItemData       LastItemData;    /* original C++ signature */
    last_item_data: ImGuiLastItemData                              # Storage for last submitted item (setup by ItemAdd)    # imgui_internal.h:1835
    # ImGuiNextWindowData     NextWindowData;    /* original C++ signature */
    next_window_data: ImGuiNextWindowData                          # Storage for SetNextWindow** functions    # imgui_internal.h:1836

    # Shared stacks
    # int                     BeginMenuCount;    /* original C++ signature */
    begin_menu_count: int                                          # imgui_internal.h:1847

    # Viewports
    # float                   CurrentDpiScale;    /* original C++ signature */
    current_dpi_scale: float                                       # == CurrentViewport->DpiScale    # imgui_internal.h:1851
    # ImGuiViewportP*         CurrentViewport;    /* original C++ signature */
    current_viewport: ImGuiViewportP                               # We track changes of viewport (happening in Begin) so we can call Platform_OnChangedViewport()    # imgui_internal.h:1852
    # ImGuiViewportP*         MouseViewport;    /* original C++ signature */
    mouse_viewport: ImGuiViewportP                                 # imgui_internal.h:1853
    # ImGuiViewportP*         MouseLastHoveredViewport;    /* original C++ signature */
    mouse_last_hovered_viewport: ImGuiViewportP                    # Last known viewport that was hovered by mouse (even if we are not hovering any viewport any more) + honoring the _NoInputs flag.    # imgui_internal.h:1854
    # ImGuiID                 PlatformLastFocusedViewportId;    /* original C++ signature */
    platform_last_focused_viewport_id: ImGuiID                     # imgui_internal.h:1855
    # ImGuiPlatformMonitor    FallbackMonitor;    /* original C++ signature */
    fallback_monitor: ImGuiPlatformMonitor                         # Virtual monitor used as fallback if backend doesn't provide monitor information.    # imgui_internal.h:1856
    # int                     ViewportFrontMostStampCount;    /* original C++ signature */
    viewport_front_most_stamp_count: int                           # Every time the front-most window changes, we stamp its viewport with an incrementing counter    # imgui_internal.h:1857

    # Gamepad/keyboard Navigation
    # ImGuiWindow*            NavWindow;    /* original C++ signature */
    nav_window: ImGuiWindow                                        # Focused window for navigation. Could be called 'FocusedWindow'    # imgui_internal.h:1860
    # ImGuiID                 NavId;    /* original C++ signature */
    nav_id: ImGuiID                                                # Focused item for navigation    # imgui_internal.h:1861
    # ImGuiID                 NavFocusScopeId;    /* original C++ signature */
    nav_focus_scope_id: ImGuiID                                    # Identify a selection scope (selection code often wants to "clear other items" when landing on an item of the selection set)    # imgui_internal.h:1862
    # ImGuiID                 NavActivateId;    /* original C++ signature */
    nav_activate_id: ImGuiID                                       # ~~ (g.ActiveId == 0) && IsNavInputPressed(ImGuiNavInput_Activate) ? NavId : 0, also set when calling ActivateItem()    # imgui_internal.h:1863
    # ImGuiID                 NavActivateDownId;    /* original C++ signature */
    nav_activate_down_id: ImGuiID                                  # ~~ IsNavInputDown(ImGuiNavInput_Activate) ? NavId : 0    # imgui_internal.h:1864
    # ImGuiID                 NavActivatePressedId;    /* original C++ signature */
    nav_activate_pressed_id: ImGuiID                               # ~~ IsNavInputPressed(ImGuiNavInput_Activate) ? NavId : 0    # imgui_internal.h:1865
    # ImGuiID                 NavActivateInputId;    /* original C++ signature */
    nav_activate_input_id: ImGuiID                                 # ~~ IsNavInputPressed(ImGuiNavInput_Input) ? NavId : 0; ImGuiActivateFlags_PreferInput will be set and NavActivateId will be 0.    # imgui_internal.h:1866
    # ImGuiActivateFlags      NavActivateFlags;    /* original C++ signature */
    nav_activate_flags: ImGuiActivateFlags                         # imgui_internal.h:1867
    # ImGuiID                 NavJustMovedToId;    /* original C++ signature */
    nav_just_moved_to_id: ImGuiID                                  # Just navigated to this id (result of a successfully MoveRequest).    # imgui_internal.h:1868
    # ImGuiID                 NavJustMovedToFocusScopeId;    /* original C++ signature */
    nav_just_moved_to_focus_scope_id: ImGuiID                      # Just navigated to this focus scope id (result of a successfully MoveRequest).    # imgui_internal.h:1869
    # ImGuiModFlags           NavJustMovedToKeyMods;    /* original C++ signature */
    nav_just_moved_to_key_mods: ImGuiModFlags                      # imgui_internal.h:1870
    # ImGuiID                 NavNextActivateId;    /* original C++ signature */
    nav_next_activate_id: ImGuiID                                  # Set by ActivateItem(), queued until next frame.    # imgui_internal.h:1871
    # ImGuiActivateFlags      NavNextActivateFlags;    /* original C++ signature */
    nav_next_activate_flags: ImGuiActivateFlags                    # imgui_internal.h:1872
    # ImGuiInputSource        NavInputSource;    /* original C++ signature */
    nav_input_source: ImGuiInputSource                             # Keyboard or Gamepad mode? THIS WILL ONLY BE None or NavGamepad or NavKeyboard.    # imgui_internal.h:1873
    # ImGuiNavLayer           NavLayer;    /* original C++ signature */
    nav_layer: ImGuiNavLayer                                       # Layer we are navigating on. For now the system is hard-coded for 0=main contents and 1=menu/title bar, may expose layers later.    # imgui_internal.h:1874
    # bool                    NavIdIsAlive;    /* original C++ signature */
    nav_id_is_alive: bool                                          # Nav widget has been seen this frame ~~ NavRectRel is valid    # imgui_internal.h:1875
    # bool                    NavMousePosDirty;    /* original C++ signature */
    nav_mouse_pos_dirty: bool                                      # When set we will update mouse position if (io.ConfigFlags & ImGuiConfigFlags_NavEnableSetMousePos) if set (NB: this not enabled by default)    # imgui_internal.h:1876
    # bool                    NavDisableHighlight;    /* original C++ signature */
    nav_disable_highlight: bool                                    # When user starts using mouse, we hide gamepad/keyboard highlight (NB: but they are still available, which is why NavDisableHighlight isn't always != NavDisableMouseHover)    # imgui_internal.h:1877
    # bool                    NavDisableMouseHover;    /* original C++ signature */
    nav_disable_mouse_hover: bool                                  # When user starts using gamepad/keyboard, we hide mouse hovering highlight until mouse is touched again.    # imgui_internal.h:1878

    # Navigation: Init & Move Requests
    # bool                    NavAnyRequest;    /* original C++ signature */
    nav_any_request: bool                                          # ~~ NavMoveRequest || NavInitRequest this is to perform early out in ItemAdd()    # imgui_internal.h:1881
    # bool                    NavInitRequest;    /* original C++ signature */
    nav_init_request: bool                                         # Init request for appearing window to select first item    # imgui_internal.h:1882
    # bool                    NavInitRequestFromMove;    /* original C++ signature */
    nav_init_request_from_move: bool                               # imgui_internal.h:1883
    # ImGuiID                 NavInitResultId;    /* original C++ signature */
    nav_init_result_id: ImGuiID                                    # Init request result (first item of the window, or one for which SetItemDefaultFocus() was called)    # imgui_internal.h:1884
    # ImRect                  NavInitResultRectRel;    /* original C++ signature */
    nav_init_result_rect_rel: ImRect                               # Init request result rectangle (relative to parent window)    # imgui_internal.h:1885
    # bool                    NavMoveSubmitted;    /* original C++ signature */
    nav_move_submitted: bool                                       # Move request submitted, will process result on next NewFrame()    # imgui_internal.h:1886
    # bool                    NavMoveScoringItems;    /* original C++ signature */
    nav_move_scoring_items: bool                                   # Move request submitted, still scoring incoming items    # imgui_internal.h:1887
    # bool                    NavMoveForwardToNextFrame;    /* original C++ signature */
    nav_move_forward_to_next_frame: bool                           # imgui_internal.h:1888
    # ImGuiNavMoveFlags       NavMoveFlags;    /* original C++ signature */
    nav_move_flags: ImGuiNavMoveFlags                              # imgui_internal.h:1889
    # ImGuiScrollFlags        NavMoveScrollFlags;    /* original C++ signature */
    nav_move_scroll_flags: ImGuiScrollFlags                        # imgui_internal.h:1890
    # ImGuiModFlags           NavMoveKeyMods;    /* original C++ signature */
    nav_move_key_mods: ImGuiModFlags                               # imgui_internal.h:1891
    # ImGuiDir                NavMoveDir;    /* original C++ signature */
    nav_move_dir: ImGuiDir                                         # Direction of the move request (left/right/up/down)    # imgui_internal.h:1892
    # ImGuiDir                NavMoveDirForDebug;    /* original C++ signature */
    nav_move_dir_for_debug: ImGuiDir                               # imgui_internal.h:1893
    # ImGuiDir                NavMoveClipDir;    /* original C++ signature */
    nav_move_clip_dir: ImGuiDir                                    # FIXME-NAV: Describe the purpose of this better. Might want to rename?    # imgui_internal.h:1894
    # ImRect                  NavScoringRect;    /* original C++ signature */
    nav_scoring_rect: ImRect                                       # Rectangle used for scoring, in screen space. Based of window->NavRectRel[], modified for directional navigation scoring.    # imgui_internal.h:1895
    # ImRect                  NavScoringNoClipRect;    /* original C++ signature */
    nav_scoring_no_clip_rect: ImRect                               # Some nav operations (such as PageUp/PageDown) enforce a region which clipper will attempt to always keep submitted    # imgui_internal.h:1896
    # int                     NavScoringDebugCount;    /* original C++ signature */
    nav_scoring_debug_count: int                                   # Metrics for debugging    # imgui_internal.h:1897
    # int                     NavTabbingDir;    /* original C++ signature */
    nav_tabbing_dir: int                                           # Generally -1 or +1, 0 when tabbing without a nav id    # imgui_internal.h:1898
    # int                     NavTabbingCounter;    /* original C++ signature */
    nav_tabbing_counter: int                                       # >0 when counting items for tabbing    # imgui_internal.h:1899
    # ImGuiNavItemData        NavMoveResultLocal;    /* original C++ signature */
    nav_move_result_local: ImGuiNavItemData                        # Best move request candidate within NavWindow    # imgui_internal.h:1900
    # ImGuiNavItemData        NavMoveResultLocalVisible;    /* original C++ signature */
    nav_move_result_local_visible: ImGuiNavItemData                # Best move request candidate within NavWindow that are mostly visible (when using ImGuiNavMoveFlags_AlsoScoreVisibleSet flag)    # imgui_internal.h:1901
    # ImGuiNavItemData        NavMoveResultOther;    /* original C++ signature */
    nav_move_result_other: ImGuiNavItemData                        # Best move request candidate within NavWindow's flattened hierarchy (when using ImGuiWindowFlags_NavFlattened flag)    # imgui_internal.h:1902
    # ImGuiNavItemData        NavTabbingResultFirst;    /* original C++ signature */
    nav_tabbing_result_first: ImGuiNavItemData                     # First tabbing request candidate within NavWindow and flattened hierarchy    # imgui_internal.h:1903

    # Navigation: Windowing (CTRL+TAB for list, or Menu button + keys or directional pads to move/resize)
    # ImGuiWindow*            NavWindowingTarget;    /* original C++ signature */
    nav_windowing_target: ImGuiWindow                              # Target window when doing CTRL+Tab (or Pad Menu + FocusPrev/Next), this window is temporarily displayed top-most!    # imgui_internal.h:1906
    # ImGuiWindow*            NavWindowingTargetAnim;    /* original C++ signature */
    nav_windowing_target_anim: ImGuiWindow                         # Record of last valid NavWindowingTarget until DimBgRatio and NavWindowingHighlightAlpha becomes 0.0, so the fade-out can stay on it.    # imgui_internal.h:1907
    # ImGuiWindow*            NavWindowingListWindow;    /* original C++ signature */
    nav_windowing_list_window: ImGuiWindow                         # Internal window actually listing the CTRL+Tab contents    # imgui_internal.h:1908
    # float                   NavWindowingTimer;    /* original C++ signature */
    nav_windowing_timer: float                                     # imgui_internal.h:1909
    # float                   NavWindowingHighlightAlpha;    /* original C++ signature */
    nav_windowing_highlight_alpha: float                           # imgui_internal.h:1910
    # bool                    NavWindowingToggleLayer;    /* original C++ signature */
    nav_windowing_toggle_layer: bool                               # imgui_internal.h:1911

    # Render
    # float                   DimBgRatio;    /* original C++ signature */
    dim_bg_ratio: float                                            # 0.0..1.0 animation when fading in a dimming background (for modal window and CTRL+TAB list)    # imgui_internal.h:1914
    # ImGuiMouseCursor        MouseCursor;    /* original C++ signature */
    mouse_cursor: ImGuiMouseCursor                                 # imgui_internal.h:1915

    # Drag and Drop
    # bool                    DragDropActive;    /* original C++ signature */
    drag_drop_active: bool                                         # imgui_internal.h:1918
    # bool                    DragDropWithinSource;    /* original C++ signature */
    drag_drop_within_source: bool                                  # Set when within a BeginDragDropXXX/EndDragDropXXX block for a drag source.    # imgui_internal.h:1919
    # bool                    DragDropWithinTarget;    /* original C++ signature */
    drag_drop_within_target: bool                                  # Set when within a BeginDragDropXXX/EndDragDropXXX block for a drag target.    # imgui_internal.h:1920
    # ImGuiDragDropFlags      DragDropSourceFlags;    /* original C++ signature */
    drag_drop_source_flags: ImGuiDragDropFlags                     # imgui_internal.h:1921
    # int                     DragDropSourceFrameCount;    /* original C++ signature */
    drag_drop_source_frame_count: int                              # imgui_internal.h:1922
    # int                     DragDropMouseButton;    /* original C++ signature */
    drag_drop_mouse_button: int                                    # imgui_internal.h:1923
    # ImGuiPayload            DragDropPayload;    /* original C++ signature */
    drag_drop_payload: ImGuiPayload                                # imgui_internal.h:1924
    # ImRect                  DragDropTargetRect;    /* original C++ signature */
    drag_drop_target_rect: ImRect                                  # Store rectangle of current target candidate (we favor small targets when overlapping)    # imgui_internal.h:1925
    # ImGuiID                 DragDropTargetId;    /* original C++ signature */
    drag_drop_target_id: ImGuiID                                   # imgui_internal.h:1926
    # ImGuiDragDropFlags      DragDropAcceptFlags;    /* original C++ signature */
    drag_drop_accept_flags: ImGuiDragDropFlags                     # imgui_internal.h:1927
    # float                   DragDropAcceptIdCurrRectSurface;    /* original C++ signature */
    drag_drop_accept_id_curr_rect_surface: float                   # Target item surface (we resolve overlapping targets by prioritizing the smaller surface)    # imgui_internal.h:1928
    # ImGuiID                 DragDropAcceptIdCurr;    /* original C++ signature */
    drag_drop_accept_id_curr: ImGuiID                              # Target item id (set at the time of accepting the payload)    # imgui_internal.h:1929
    # ImGuiID                 DragDropAcceptIdPrev;    /* original C++ signature */
    drag_drop_accept_id_prev: ImGuiID                              # Target item id from previous frame (we need to store this to allow for overlapping drag and drop targets)    # imgui_internal.h:1930
    # int                     DragDropAcceptFrameCount;    /* original C++ signature */
    drag_drop_accept_frame_count: int                              # Last time a target expressed a desire to accept the source    # imgui_internal.h:1931
    # ImGuiID                 DragDropHoldJustPressedId;    /* original C++ signature */
    drag_drop_hold_just_pressed_id: ImGuiID                        # Set when holding a payload just made ButtonBehavior() return a press.    # imgui_internal.h:1932

    # Clipper
    # int                             ClipperTempDataStacked;    /* original C++ signature */
    clipper_temp_data_stacked: int                                 # imgui_internal.h:1937

    # Tables
    # ImGuiTable*                     CurrentTable;    /* original C++ signature */
    current_table: ImGuiTable                                      # imgui_internal.h:1941
    # int                             TablesTempDataStacked;    /* original C++ signature */
    tables_temp_data_stacked: int                                  # Temporary table data size (because we leave previous instances undestructed, we generally don't use TablesTempData.Size)    # imgui_internal.h:1942

    # Tab bars
    # ImGuiTabBar*                    CurrentTabBar;    /* original C++ signature */
    current_tab_bar: ImGuiTabBar                                   # imgui_internal.h:1949

    # Widget state
    # ImVec2                  MouseLastValidPos;    /* original C++ signature */
    mouse_last_valid_pos: ImVec2                                   # imgui_internal.h:1955
    # ImGuiInputTextState     InputTextState;    /* original C++ signature */
    input_text_state: ImGuiInputTextState                          # imgui_internal.h:1956
    # ImFont                  InputTextPasswordFont;    /* original C++ signature */
    input_text_password_font: ImFont                               # imgui_internal.h:1957
    # ImGuiID                 TempInputId;    /* original C++ signature */
    temp_input_id: ImGuiID                                         # Temporary text input when CTRL+clicking on a slider, etc.    # imgui_internal.h:1958
    # ImGuiColorEditFlags     ColorEditOptions;    /* original C++ signature */
    color_edit_options: ImGuiColorEditFlags                        # Store user options for color edit widgets    # imgui_internal.h:1959
    # float                   ColorEditLastHue;    /* original C++ signature */
    color_edit_last_hue: float                                     # Backup of last Hue associated to LastColor, so we can restore Hue in lossy RGB<>HSV round trips    # imgui_internal.h:1960
    # float                   ColorEditLastSat;    /* original C++ signature */
    color_edit_last_sat: float                                     # Backup of last Saturation associated to LastColor, so we can restore Saturation in lossy RGB<>HSV round trips    # imgui_internal.h:1961
    # ImU32                   ColorEditLastColor;    /* original C++ signature */
    color_edit_last_color: ImU32                                   # RGB value with alpha set to 0.    # imgui_internal.h:1962
    # ImVec4                  ColorPickerRef;    /* original C++ signature */
    color_picker_ref: ImVec4                                       # Initial/reference color at the time of opening the color picker.    # imgui_internal.h:1963
    # ImGuiComboPreviewData   ComboPreviewData;    /* original C++ signature */
    combo_preview_data: ImGuiComboPreviewData                      # imgui_internal.h:1964
    # float                   SliderGrabClickOffset;    /* original C++ signature */
    slider_grab_click_offset: float                                # imgui_internal.h:1965
    # float                   SliderCurrentAccum;    /* original C++ signature */
    slider_current_accum: float                                    # Accumulated slider delta when using navigation controls.    # imgui_internal.h:1966
    # bool                    SliderCurrentAccumDirty;    /* original C++ signature */
    slider_current_accum_dirty: bool                               # Has the accumulated slider delta changed since last time we tried to apply it?    # imgui_internal.h:1967
    # bool                    DragCurrentAccumDirty;    /* original C++ signature */
    drag_current_accum_dirty: bool                                 # imgui_internal.h:1968
    # float                   DragCurrentAccum;    /* original C++ signature */
    drag_current_accum: float                                      # Accumulator for dragging modification. Always high-precision, not rounded by end-user precision settings    # imgui_internal.h:1969
    # float                   DragSpeedDefaultRatio;    /* original C++ signature */
    drag_speed_default_ratio: float                                # If speed == 0.0, uses (max-min) * DragSpeedDefaultRatio    # imgui_internal.h:1970
    # float                   ScrollbarClickDeltaToGrabCenter;    /* original C++ signature */
    scrollbar_click_delta_to_grab_center: float                    # Distance between mouse and center of grab box, normalized in parent space. Use storage?    # imgui_internal.h:1971
    # float                   DisabledAlphaBackup;    /* original C++ signature */
    disabled_alpha_backup: float                                   # Backup for style.Alpha for BeginDisabled()    # imgui_internal.h:1972
    # short                   DisabledStackSize;    /* original C++ signature */
    disabled_stack_size: int                                       # imgui_internal.h:1973
    # short                   TooltipOverrideCount;    /* original C++ signature */
    tooltip_override_count: int                                    # imgui_internal.h:1974
    # float                   TooltipSlowDelay;    /* original C++ signature */
    tooltip_slow_delay: float                                      # Time before slow tooltips appears (FIXME: This is temporary until we merge in tooltip timer+priority work)    # imgui_internal.h:1975

    # Platform support
    # ImGuiPlatformImeData    PlatformImeData;    /* original C++ signature */
    platform_ime_data: ImGuiPlatformImeData                        # Data updated by current frame    # imgui_internal.h:1980
    # ImGuiPlatformImeData    PlatformImeDataPrev;    /* original C++ signature */
    platform_ime_data_prev: ImGuiPlatformImeData                   # Previous frame data (when changing we will call io.SetPlatformImeDataFn    # imgui_internal.h:1981
    # ImGuiID                 PlatformImeViewport;    /* original C++ signature */
    platform_ime_viewport: ImGuiID                                 # imgui_internal.h:1982
    # char                    PlatformLocaleDecimalPoint;    /* original C++ signature */
    platform_locale_decimal_point: int                             # '.' or *localeconv()->decimal_point    # imgui_internal.h:1983

    # ImGuiDockContext        DockContext;    /* original C++ signature */
    # Extensions
    # FIXME: We could provide an API to register one slot in an array held in ImGuiContext?
    dock_context: ImGuiDockContext                                 # imgui_internal.h:1987

    # Settings
    # bool                    SettingsLoaded;    /* original C++ signature */
    settings_loaded: bool                                          # imgui_internal.h:1990
    # float                   SettingsDirtyTimer;    /* original C++ signature */
    settings_dirty_timer: float                                    # Save .ini Settings to memory when time reaches zero    # imgui_internal.h:1991
    # ImGuiTextBuffer         SettingsIniData;    /* original C++ signature */
    settings_ini_data: ImGuiTextBuffer                             # In memory .ini settings    # imgui_internal.h:1992
    # ImGuiID                             HookIdNext;    /* original C++ signature */
    hook_id_next: ImGuiID                                          # Next available HookId    # imgui_internal.h:1997

    # Capture/Logging
    # bool                    LogEnabled;    /* original C++ signature */
    log_enabled: bool                                              # Currently capturing    # imgui_internal.h:2000
    # ImGuiLogType            LogType;    /* original C++ signature */
    log_type: ImGuiLogType                                         # Capture target    # imgui_internal.h:2001
    # ImFileHandle            LogFile;    /* original C++ signature */
    log_file: ImFileHandle                                         # If != None log to stdout/ file    # imgui_internal.h:2002
    # ImGuiTextBuffer         LogBuffer;    /* original C++ signature */
    log_buffer: ImGuiTextBuffer                                    # Accumulation buffer when log to clipboard. This is pointer so our GImGui static constructor doesn't call heap allocators.    # imgui_internal.h:2003
    # const char*             LogNextPrefix;    /* original C++ signature */
    log_next_prefix: str                                           # imgui_internal.h:2004
    # const char*             LogNextSuffix;    /* original C++ signature */
    log_next_suffix: str                                           # imgui_internal.h:2005
    # float                   LogLinePosY;    /* original C++ signature */
    log_line_pos_y: float                                          # imgui_internal.h:2006
    # bool                    LogLineFirstItem;    /* original C++ signature */
    log_line_first_item: bool                                      # imgui_internal.h:2007
    # int                     LogDepthRef;    /* original C++ signature */
    log_depth_ref: int                                             # imgui_internal.h:2008
    # int                     LogDepthToExpand;    /* original C++ signature */
    log_depth_to_expand: int                                       # imgui_internal.h:2009
    # int                     LogDepthToExpandDefault;    /* original C++ signature */
    log_depth_to_expand_default: int                               # Default/stored value for LogDepthMaxExpand if not specified in the LogXXX function call.    # imgui_internal.h:2010

    # Debug Tools
    # ImGuiDebugLogFlags      DebugLogFlags;    /* original C++ signature */
    debug_log_flags: ImGuiDebugLogFlags                            # imgui_internal.h:2013
    # ImGuiTextBuffer         DebugLogBuf;    /* original C++ signature */
    debug_log_buf: ImGuiTextBuffer                                 # imgui_internal.h:2014
    # bool                    DebugItemPickerActive;    /* original C++ signature */
    debug_item_picker_active: bool                                 # Item picker is active (started with DebugStartItemPicker())    # imgui_internal.h:2015
    # ImGuiID                 DebugItemPickerBreakId;    /* original C++ signature */
    debug_item_picker_break_id: ImGuiID                            # Will call IM_DEBUG_BREAK() when encountering this ID    # imgui_internal.h:2016
    # ImGuiMetricsConfig      DebugMetricsConfig;    /* original C++ signature */
    debug_metrics_config: ImGuiMetricsConfig                       # imgui_internal.h:2017
    # ImGuiStackTool          DebugStackTool;    /* original C++ signature */
    debug_stack_tool: ImGuiStackTool                               # imgui_internal.h:2018

    # Misc
    # float                   FramerateSecPerFrame[120];    /* original C++ signature */
    framerate_sec_per_frame: np.ndarray                            # ndarray[type=float, size=120]  # Calculate estimate of framerate for user over the last 2 seconds.    # imgui_internal.h:2021
    # int                     FramerateSecPerFrameIdx;    /* original C++ signature */
    framerate_sec_per_frame_idx: int                               # imgui_internal.h:2022
    # int                     FramerateSecPerFrameCount;    /* original C++ signature */
    framerate_sec_per_frame_count: int                             # imgui_internal.h:2023
    # float                   FramerateSecPerFrameAccum;    /* original C++ signature */
    framerate_sec_per_frame_accum: float                           # imgui_internal.h:2024
    # int                     WantCaptureMouseNextFrame;    /* original C++ signature */
    want_capture_mouse_next_frame: int                             # Explicit capture override via SetNextFrameWantCaptureMouse()/SetNextFrameWantCaptureKeyboard(). Default to -1.    # imgui_internal.h:2025
    # int                     WantCaptureKeyboardNextFrame;    /* original C++ signature */
    want_capture_keyboard_next_frame: int                          # "    # imgui_internal.h:2026
    # int                     WantTextInputNextFrame;    /* original C++ signature */
    want_text_input_next_frame: int                                # imgui_internal.h:2027

    # ImGuiContext(ImFontAtlas* shared_font_atlas)    /* original C++ signature */
    #     {
    #         Initialized = false;
    #         ConfigFlagsCurrFrame = ConfigFlagsLastFrame = ImGuiConfigFlags_None;
    #         FontAtlasOwnedByContext = shared_font_atlas ? false : true;
    #         Font = NULL;
    #         FontSize = FontBaseSize = 0.0f;
    #         IO.Fonts = shared_font_atlas ? shared_font_atlas : IM_NEW(ImFontAtlas)();
    #         Time = 0.0f;
    #         FrameCount = 0;
    #         FrameCountEnded = FrameCountPlatformEnded = FrameCountRendered = -1;
    #         WithinFrameScope = WithinFrameScopeWithImplicitWindow = WithinEndChild = false;
    #         GcCompactAll = false;
    #         TestEngineHookItems = false;
    #         TestEngine = NULL;
    # // _SRCML_EMPTY_LINE_
    #         WindowsActiveCount = 0;
    #         CurrentWindow = NULL;
    #         HoveredWindow = NULL;
    #         HoveredWindowUnderMovingWindow = NULL;
    #         HoveredDockNode = NULL;
    #         MovingWindow = NULL;
    #         WheelingWindow = NULL;
    #         WheelingWindowTimer = 0.0f;
    # // _SRCML_EMPTY_LINE_
    #         DebugHookIdInfo = 0;
    #         HoveredId = HoveredIdPreviousFrame = 0;
    #         HoveredIdAllowOverlap = false;
    #         HoveredIdUsingMouseWheel = HoveredIdPreviousFrameUsingMouseWheel = false;
    #         HoveredIdDisabled = false;
    #         HoveredIdTimer = HoveredIdNotActiveTimer = 0.0f;
    #         ActiveId = 0;
    #         ActiveIdIsAlive = 0;
    #         ActiveIdTimer = 0.0f;
    #         ActiveIdIsJustActivated = false;
    #         ActiveIdAllowOverlap = false;
    #         ActiveIdNoClearOnFocusLoss = false;
    #         ActiveIdHasBeenPressedBefore = false;
    #         ActiveIdHasBeenEditedBefore = false;
    #         ActiveIdHasBeenEditedThisFrame = false;
    #         ActiveIdClickOffset = ImVec2(-1, -1);
    #         ActiveIdWindow = NULL;
    #         ActiveIdSource = ImGuiInputSource_None;
    #         ActiveIdMouseButton = -1;
    #         ActiveIdPreviousFrame = 0;
    #         ActiveIdPreviousFrameIsAlive = false;
    #         ActiveIdPreviousFrameHasBeenEditedBefore = false;
    #         ActiveIdPreviousFrameWindow = NULL;
    #         LastActiveId = 0;
    #         LastActiveIdTimer = 0.0f;
    # // _SRCML_EMPTY_LINE_
    #         ActiveIdUsingMouseWheel = false;
    #         ActiveIdUsingNavDirMask = 0x00;
    #         ActiveIdUsingNavInputMask = 0x00;
    #         ActiveIdUsingKeyInputMask.ClearAllBits();
    # // _SRCML_EMPTY_LINE_
    #         CurrentItemFlags = ImGuiItemFlags_None;
    #         BeginMenuCount = 0;
    # // _SRCML_EMPTY_LINE_
    #         CurrentDpiScale = 0.0f;
    #         CurrentViewport = NULL;
    #         MouseViewport = MouseLastHoveredViewport = NULL;
    #         PlatformLastFocusedViewportId = 0;
    #         ViewportFrontMostStampCount = 0;
    # // _SRCML_EMPTY_LINE_
    #         NavWindow = NULL;
    #         NavId = NavFocusScopeId = NavActivateId = NavActivateDownId = NavActivatePressedId = NavActivateInputId = 0;
    #         NavJustMovedToId = NavJustMovedToFocusScopeId = NavNextActivateId = 0;
    #         NavActivateFlags = NavNextActivateFlags = ImGuiActivateFlags_None;
    #         NavJustMovedToKeyMods = ImGuiModFlags_None;
    #         NavInputSource = ImGuiInputSource_None;
    #         NavLayer = ImGuiNavLayer_Main;
    #         NavIdIsAlive = false;
    #         NavMousePosDirty = false;
    #         NavDisableHighlight = true;
    #         NavDisableMouseHover = false;
    #         NavAnyRequest = false;
    #         NavInitRequest = false;
    #         NavInitRequestFromMove = false;
    #         NavInitResultId = 0;
    #         NavMoveSubmitted = false;
    #         NavMoveScoringItems = false;
    #         NavMoveForwardToNextFrame = false;
    #         NavMoveFlags = ImGuiNavMoveFlags_None;
    #         NavMoveScrollFlags = ImGuiScrollFlags_None;
    #         NavMoveKeyMods = ImGuiModFlags_None;
    #         NavMoveDir = NavMoveDirForDebug = NavMoveClipDir = ImGuiDir_None;
    #         NavScoringDebugCount = 0;
    #         NavTabbingDir = 0;
    #         NavTabbingCounter = 0;
    # // _SRCML_EMPTY_LINE_
    #         NavWindowingTarget = NavWindowingTargetAnim = NavWindowingListWindow = NULL;
    #         NavWindowingTimer = NavWindowingHighlightAlpha = 0.0f;
    #         NavWindowingToggleLayer = false;
    # // _SRCML_EMPTY_LINE_
    #         DimBgRatio = 0.0f;
    #         MouseCursor = ImGuiMouseCursor_Arrow;
    # // _SRCML_EMPTY_LINE_
    #         DragDropActive = DragDropWithinSource = DragDropWithinTarget = false;
    #         DragDropSourceFlags = ImGuiDragDropFlags_None;
    #         DragDropSourceFrameCount = -1;
    #         DragDropMouseButton = -1;
    #         DragDropTargetId = 0;
    #         DragDropAcceptFlags = ImGuiDragDropFlags_None;
    #         DragDropAcceptIdCurrRectSurface = 0.0f;
    #         DragDropAcceptIdPrev = DragDropAcceptIdCurr = 0;
    #         DragDropAcceptFrameCount = -1;
    #         DragDropHoldJustPressedId = 0;
    #         memset(DragDropPayloadBufLocal, 0, sizeof(DragDropPayloadBufLocal));
    # // _SRCML_EMPTY_LINE_
    #         ClipperTempDataStacked = 0;
    # // _SRCML_EMPTY_LINE_
    #         CurrentTable = NULL;
    #         TablesTempDataStacked = 0;
    #         CurrentTabBar = NULL;
    # // _SRCML_EMPTY_LINE_
    #         TempInputId = 0;
    #         ColorEditOptions = ImGuiColorEditFlags_DefaultOptions_;
    #         ColorEditLastHue = ColorEditLastSat = 0.0f;
    #         ColorEditLastColor = 0;
    #         SliderGrabClickOffset = 0.0f;
    #         SliderCurrentAccum = 0.0f;
    #         SliderCurrentAccumDirty = false;
    #         DragCurrentAccumDirty = false;
    #         DragCurrentAccum = 0.0f;
    #         DragSpeedDefaultRatio = 1.0f / 100.0f;
    #         DisabledAlphaBackup = 0.0f;
    #         DisabledStackSize = 0;
    #         ScrollbarClickDeltaToGrabCenter = 0.0f;
    #         TooltipOverrideCount = 0;
    #         TooltipSlowDelay = 0.50f;
    # // _SRCML_EMPTY_LINE_
    #         PlatformImeData.InputPos = ImVec2(0.0f, 0.0f);
    #         PlatformImeDataPrev.InputPos = ImVec2(-1.0f, -1.0f); // Different to ensure initial submission
    #         PlatformImeViewport = 0;
    #         PlatformLocaleDecimalPoint = '.';
    # // _SRCML_EMPTY_LINE_
    #         SettingsLoaded = false;
    #         SettingsDirtyTimer = 0.0f;
    #         HookIdNext = 0;
    # // _SRCML_EMPTY_LINE_
    #         LogEnabled = false;
    #         LogType = ImGuiLogType_None;
    #         LogNextPrefix = LogNextSuffix = NULL;
    #         LogFile = NULL;
    #         LogLinePosY = FLT_MAX;
    #         LogLineFirstItem = false;
    #         LogDepthRef = 0;
    #         LogDepthToExpand = LogDepthToExpandDefault = 2;
    # // _SRCML_EMPTY_LINE_
    #         DebugLogFlags = ImGuiDebugLogFlags_OutputToTTY;
    #         DebugItemPickerActive = false;
    #         DebugItemPickerBreakId = 0;
    # // _SRCML_EMPTY_LINE_
    #         memset(FramerateSecPerFrame, 0, sizeof(FramerateSecPerFrame));
    #         FramerateSecPerFrameIdx = FramerateSecPerFrameCount = 0;
    #         FramerateSecPerFrameAccum = 0.0f;
    #         WantCaptureMouseNextFrame = WantCaptureKeyboardNextFrame = WantTextInputNextFrame = -1;
    #     }
    def __init__(self, shared_font_atlas: ImFontAtlas) -> None:    # imgui_internal.h:2030
        pass

#-----------------------------------------------------------------------------
# [SECTION] ImGuiWindowTempData, ImGuiWindow
#-----------------------------------------------------------------------------

class ImGuiWindowTempData:    # imgui_internal.h:2198
    """ Transient per-window data, reset at the beginning of the frame. This used to be called ImGuiDrawContext, hence the DC variable name in ImGuiWindow.
     (That's theory, in practice the delimitation between ImGuiWindow and ImGuiWindowTempData is quite tenuous and could be reconsidered..)
     (This doesn't need a constructor because we zero-clear it as part of ImGuiWindow and all frame-temporary data are setup on Begin)
    """
    # Layout
    # ImVec2                  CursorPos;    /* original C++ signature */
    cursor_pos: ImVec2                      # Current emitting position, in absolute coordinates.    # imgui_internal.h:2201
    # ImVec2                  CursorPosPrevLine;    /* original C++ signature */
    cursor_pos_prev_line: ImVec2            # imgui_internal.h:2202
    # ImVec2                  CursorStartPos;    /* original C++ signature */
    cursor_start_pos: ImVec2                # Initial position after Begin(), generally ~ window position + WindowPadding.    # imgui_internal.h:2203
    # ImVec2                  CursorMaxPos;    /* original C++ signature */
    cursor_max_pos: ImVec2                  # Used to implicitly calculate ContentSize at the beginning of next frame, for scrolling range and auto-resize. Always growing during the frame.    # imgui_internal.h:2204
    # ImVec2                  IdealMaxPos;    /* original C++ signature */
    ideal_max_pos: ImVec2                   # Used to implicitly calculate ContentSizeIdeal at the beginning of next frame, for auto-resize only. Always growing during the frame.    # imgui_internal.h:2205
    # ImVec2                  CurrLineSize;    /* original C++ signature */
    curr_line_size: ImVec2                  # imgui_internal.h:2206
    # ImVec2                  PrevLineSize;    /* original C++ signature */
    prev_line_size: ImVec2                  # imgui_internal.h:2207
    # float                   CurrLineTextBaseOffset;    /* original C++ signature */
    curr_line_text_base_offset: float       # Baseline offset (0.0 by default on a new line, generally == style.FramePadding.y when a framed item has been added).    # imgui_internal.h:2208
    # float                   PrevLineTextBaseOffset;    /* original C++ signature */
    prev_line_text_base_offset: float       # imgui_internal.h:2209
    # bool                    IsSameLine;    /* original C++ signature */
    is_same_line: bool                      # imgui_internal.h:2210
    # ImVec1                  Indent;    /* original C++ signature */
    indent: ImVec1                          # Indentation / start position from left of window (increased by TreePush/TreePop, etc.)    # imgui_internal.h:2211
    # ImVec1                  ColumnsOffset;    /* original C++ signature */
    columns_offset: ImVec1                  # Offset to the current column (if ColumnsCurrent > 0). FIXME: This and the above should be a stack to allow use cases like Tree->Column->Tree. Need revamp columns API.    # imgui_internal.h:2212
    # ImVec1                  GroupOffset;    /* original C++ signature */
    group_offset: ImVec1                    # imgui_internal.h:2213
    # ImVec2                  CursorStartPosLossyness;    /* original C++ signature */
    cursor_start_pos_lossyness: ImVec2      # Record the loss of precision of CursorStartPos due to really large scrolling amount. This is used by clipper to compensentate and fix the most common use case of large scroll area.    # imgui_internal.h:2214

    # Keyboard/Gamepad navigation
    # ImGuiNavLayer           NavLayerCurrent;    /* original C++ signature */
    nav_layer_current: ImGuiNavLayer        # Current layer, 0..31 (we currently only use 0..1)    # imgui_internal.h:2217
    # short                   NavLayersActiveMask;    /* original C++ signature */
    nav_layers_active_mask: int             # Which layers have been written to (result from previous frame)    # imgui_internal.h:2218
    # short                   NavLayersActiveMaskNext;    /* original C++ signature */
    nav_layers_active_mask_next: int        # Which layers have been written to (accumulator for current frame)    # imgui_internal.h:2219
    # ImGuiID                 NavFocusScopeIdCurrent;    /* original C++ signature */
    nav_focus_scope_id_current: ImGuiID     # Current focus scope ID while appending    # imgui_internal.h:2220
    # bool                    NavHideHighlightOneFrame;    /* original C++ signature */
    nav_hide_highlight_one_frame: bool      # imgui_internal.h:2221
    # bool                    NavHasScroll;    /* original C++ signature */
    nav_has_scroll: bool                    # Set when scrolling can be used (ScrollMax > 0.0)    # imgui_internal.h:2222

    # Miscellaneous
    # bool                    MenuBarAppending;    /* original C++ signature */
    menu_bar_appending: bool                # FIXME: Remove this    # imgui_internal.h:2225
    # ImVec2                  MenuBarOffset;    /* original C++ signature */
    menu_bar_offset: ImVec2                 # MenuBarOffset.x is sort of equivalent of a per-layer CursorPos.x, saved/restored as we switch to the menu bar. The only situation when MenuBarOffset.y is > 0 if when (SafeAreaPadding.y > FramePadding.y), often used on TVs.    # imgui_internal.h:2226
    # ImGuiMenuColumns        MenuColumns;    /* original C++ signature */
    menu_columns: ImGuiMenuColumns          # Simplified columns storage for menu items measurement    # imgui_internal.h:2227
    # int                     TreeDepth;    /* original C++ signature */
    tree_depth: int                         # Current tree depth.    # imgui_internal.h:2228
    # ImU32                   TreeJumpToParentOnPopMask;    /* original C++ signature */
    tree_jump_to_parent_on_pop_mask: ImU32  # Store a copy of !g.NavIdIsAlive for TreeDepth 0..31.. Could be turned into a ImU64 if necessary.    # imgui_internal.h:2229
    # ImGuiStorage*           StateStorage;    /* original C++ signature */
    state_storage: ImGuiStorage             # Current persistent per-window storage (store e.g. tree node open/close state)    # imgui_internal.h:2231
    # ImGuiOldColumns*        CurrentColumns;    /* original C++ signature */
    current_columns: ImGuiOldColumns        # Current columns set    # imgui_internal.h:2232
    # int                     CurrentTableIdx;    /* original C++ signature */
    current_table_idx: int                  # Current table index (into g.Tables)    # imgui_internal.h:2233
    # ImGuiLayoutType         LayoutType;    /* original C++ signature */
    layout_type: ImGuiLayoutType            # imgui_internal.h:2234
    # ImGuiLayoutType         ParentLayoutType;    /* original C++ signature */
    parent_layout_type: ImGuiLayoutType     # Layout type of parent window at the time of Begin()    # imgui_internal.h:2235

    # Local parameters stacks
    # We store the current settings outside of the vectors to increase memory locality (reduce cache misses). The vectors are rarely modified. Also it allows us to not heap allocate for short-lived windows which are not using those settings.
    # float                   ItemWidth;    /* original C++ signature */
    item_width: float                       # Current item width (>0.0: width in pixels, <0.0: align xx pixels to the right of window).    # imgui_internal.h:2239
    # float                   TextWrapPos;    /* original C++ signature */
    text_wrap_pos: float                    # Current text wrap pos.    # imgui_internal.h:2240

class ImGuiWindow:    # imgui_internal.h:2246
    """ Storage for one window"""
    # ImGuiID                 ID;    /* original C++ signature */
    id: ImGuiID                                                      # == ImHashStr(Name)    # imgui_internal.h:2249
    # ImGuiWindowFlags        Flags,     /* original C++ signature */
    flags: ImGuiWindowFlags                                          # See enum ImGuiWindowFlags_    # imgui_internal.h:2250
    # FlagsPreviousFrame;    /* original C++ signature */
    flags_previous_frame: ImGuiWindowFlags                           # See enum ImGuiWindowFlags_    # imgui_internal.h:2250
    # ImGuiWindowClass        WindowClass;    /* original C++ signature */
    window_class: ImGuiWindowClass                                   # Advanced users only. Set with SetNextWindowClass()    # imgui_internal.h:2251
    # ImGuiViewportP*         Viewport;    /* original C++ signature */
    viewport: ImGuiViewportP                                         # Always set in Begin(). Inactive windows may have a None value here if their viewport was discarded.    # imgui_internal.h:2252
    # ImGuiID                 ViewportId;    /* original C++ signature */
    viewport_id: ImGuiID                                             # We backup the viewport id (since the viewport may disappear or never be created if the window is inactive)    # imgui_internal.h:2253
    # ImVec2                  ViewportPos;    /* original C++ signature */
    viewport_pos: ImVec2                                             # We backup the viewport position (since the viewport may disappear or never be created if the window is inactive)    # imgui_internal.h:2254
    # int                     ViewportAllowPlatformMonitorExtend;    /* original C++ signature */
    viewport_allow_platform_monitor_extend: int                      # Reset to -1 every frame (index is guaranteed to be valid between NewFrame..EndFrame), only used in the Appearing frame of a tooltip/popup to enforce clamping to a given monitor    # imgui_internal.h:2255
    # ImVec2                  Pos;    /* original C++ signature */
    pos: ImVec2                                                      # Position (always rounded-up to nearest pixel)    # imgui_internal.h:2256
    # ImVec2                  Size;    /* original C++ signature */
    size: ImVec2                                                     # Current size (==SizeFull or collapsed title bar size)    # imgui_internal.h:2257
    # ImVec2                  SizeFull;    /* original C++ signature */
    size_full: ImVec2                                                # Size when non collapsed    # imgui_internal.h:2258
    # ImVec2                  ContentSize;    /* original C++ signature */
    content_size: ImVec2                                             # Size of contents/scrollable client area (calculated from the extents reach of the cursor) from previous frame. Does not include window decoration or window padding.    # imgui_internal.h:2259
    # ImVec2                  ContentSizeIdeal;    /* original C++ signature */
    content_size_ideal: ImVec2                                       # imgui_internal.h:2260
    # ImVec2                  ContentSizeExplicit;    /* original C++ signature */
    content_size_explicit: ImVec2                                    # Size of contents/scrollable client area explicitly request by the user via SetNextWindowContentSize().    # imgui_internal.h:2261
    # ImVec2                  WindowPadding;    /* original C++ signature */
    window_padding: ImVec2                                           # Window padding at the time of Begin().    # imgui_internal.h:2262
    # float                   WindowRounding;    /* original C++ signature */
    window_rounding: float                                           # Window rounding at the time of Begin(). May be clamped lower to avoid rendering artifacts with title bar, menu bar etc.    # imgui_internal.h:2263
    # float                   WindowBorderSize;    /* original C++ signature */
    window_border_size: float                                        # Window border size at the time of Begin().    # imgui_internal.h:2264
    # int                     NameBufLen;    /* original C++ signature */
    name_buf_len: int                                                # Size of buffer storing Name. May be larger than strlen(Name)!    # imgui_internal.h:2265
    # ImGuiID                 MoveId;    /* original C++ signature */
    move_id: ImGuiID                                                 # == window->GetID("#MOVE")    # imgui_internal.h:2266
    # ImGuiID                 TabId;    /* original C++ signature */
    tab_id: ImGuiID                                                  # == window->GetID("#TAB")    # imgui_internal.h:2267
    # ImGuiID                 ChildId;    /* original C++ signature */
    child_id: ImGuiID                                                # ID of corresponding item in parent window (for navigation to return from child window to parent window)    # imgui_internal.h:2268
    # ImVec2                  Scroll;    /* original C++ signature */
    scroll: ImVec2                                                   # imgui_internal.h:2269
    # ImVec2                  ScrollMax;    /* original C++ signature */
    scroll_max: ImVec2                                               # imgui_internal.h:2270
    # ImVec2                  ScrollTarget;    /* original C++ signature */
    scroll_target: ImVec2                                            # target scroll position. stored as cursor position with scrolling canceled out, so the highest point is always 0.0. (FLT_MAX for no change)    # imgui_internal.h:2271
    # ImVec2                  ScrollTargetCenterRatio;    /* original C++ signature */
    scroll_target_center_ratio: ImVec2                               # 0.0 = scroll so that target position is at top, 0.5 = scroll so that target position is centered    # imgui_internal.h:2272
    # ImVec2                  ScrollTargetEdgeSnapDist;    /* original C++ signature */
    scroll_target_edge_snap_dist: ImVec2                             # 0.0 = no snapping, >0.0 snapping threshold    # imgui_internal.h:2273
    # ImVec2                  ScrollbarSizes;    /* original C++ signature */
    scrollbar_sizes: ImVec2                                          # Size taken by each scrollbars on their smaller axis. Pay attention! ScrollbarSizes.x == width of the vertical scrollbar, ScrollbarSizes.y = height of the horizontal scrollbar.    # imgui_internal.h:2274
    # bool                    ScrollbarX,     /* original C++ signature */
    scrollbar_x: bool                                                # Are scrollbars visible?    # imgui_internal.h:2275
    # ScrollbarY;    /* original C++ signature */
    scrollbar_y: bool                                                # Are scrollbars visible?    # imgui_internal.h:2275
    # bool                    ViewportOwned;    /* original C++ signature */
    viewport_owned: bool                                             # imgui_internal.h:2276
    # bool                    Active;    /* original C++ signature */
    active: bool                                                     # Set to True on Begin(), unless Collapsed    # imgui_internal.h:2277
    # bool                    WasActive;    /* original C++ signature */
    was_active: bool                                                 # imgui_internal.h:2278
    # bool                    WriteAccessed;    /* original C++ signature */
    write_accessed: bool                                             # Set to True when any widget access the current window    # imgui_internal.h:2279
    # bool                    Collapsed;    /* original C++ signature */
    collapsed: bool                                                  # Set when collapsing window to become only title-bar    # imgui_internal.h:2280
    # bool                    WantCollapseToggle;    /* original C++ signature */
    want_collapse_toggle: bool                                       # imgui_internal.h:2281
    # bool                    SkipItems;    /* original C++ signature */
    skip_items: bool                                                 # Set when items can safely be all clipped (e.g. window not visible or collapsed)    # imgui_internal.h:2282
    # bool                    Appearing;    /* original C++ signature */
    appearing: bool                                                  # Set during the frame where the window is appearing (or re-appearing)    # imgui_internal.h:2283
    # bool                    Hidden;    /* original C++ signature */
    hidden: bool                                                     # Do not display (== HiddenFrames*** > 0)    # imgui_internal.h:2284
    # bool                    IsFallbackWindow;    /* original C++ signature */
    is_fallback_window: bool                                         # Set on the "Debug##Default" window.    # imgui_internal.h:2285
    # bool                    IsExplicitChild;    /* original C++ signature */
    is_explicit_child: bool                                          # Set when passed _ChildWindow, left to False by BeginDocked()    # imgui_internal.h:2286
    # bool                    HasCloseButton;    /* original C++ signature */
    has_close_button: bool                                           # Set when the window has a close button (p_open != None)    # imgui_internal.h:2287
    # signed char             ResizeBorderHeld;    /* original C++ signature */
    resize_border_held: int                                          # Current border being held for resize (-1: none, otherwise 0-3)    # imgui_internal.h:2288
    # short                   BeginCount;    /* original C++ signature */
    begin_count: int                                                 # Number of Begin() during the current frame (generally 0 or 1, 1+ if appending via multiple Begin/End pairs)    # imgui_internal.h:2289
    # short                   BeginOrderWithinParent;    /* original C++ signature */
    begin_order_within_parent: int                                   # Begin() order within immediate parent window, if we are a child window. Otherwise 0.    # imgui_internal.h:2290
    # short                   BeginOrderWithinContext;    /* original C++ signature */
    begin_order_within_context: int                                  # Begin() order within entire imgui context. This is mostly used for debugging submission order related issues.    # imgui_internal.h:2291
    # short                   FocusOrder;    /* original C++ signature */
    focus_order: int                                                 # Order within WindowsFocusOrder[], altered when windows are focused.    # imgui_internal.h:2292
    # ImGuiID                 PopupId;    /* original C++ signature */
    popup_id: ImGuiID                                                # ID in the popup stack when this window is used as a popup/menu (because we use generic Name/ID for recycling)    # imgui_internal.h:2293
    # ImS8                    AutoFitFramesX,     /* original C++ signature */
    auto_fit_frames_x: ImS8                                          # imgui_internal.h:2294
    # AutoFitFramesY;    /* original C++ signature */
    auto_fit_frames_y: ImS8                                          # imgui_internal.h:2294
    # ImS8                    AutoFitChildAxises;    /* original C++ signature */
    auto_fit_child_axises: ImS8                                      # imgui_internal.h:2295
    # bool                    AutoFitOnlyGrows;    /* original C++ signature */
    auto_fit_only_grows: bool                                        # imgui_internal.h:2296
    # ImGuiDir                AutoPosLastDirection;    /* original C++ signature */
    auto_pos_last_direction: ImGuiDir                                # imgui_internal.h:2297
    # ImS8                    HiddenFramesCanSkipItems;    /* original C++ signature */
    hidden_frames_can_skip_items: ImS8                               # Hide the window for N frames    # imgui_internal.h:2298
    # ImS8                    HiddenFramesCannotSkipItems;    /* original C++ signature */
    hidden_frames_cannot_skip_items: ImS8                            # Hide the window for N frames while allowing items to be submitted so we can measure their size    # imgui_internal.h:2299
    # ImS8                    HiddenFramesForRenderOnly;    /* original C++ signature */
    hidden_frames_for_render_only: ImS8                              # Hide the window until frame N at Render() time only    # imgui_internal.h:2300
    # ImS8                    DisableInputsFrames;    /* original C++ signature */
    disable_inputs_frames: ImS8                                      # Disable window interactions for N frames    # imgui_internal.h:2301
    # ImVec2                  SetWindowPosVal;    /* original C++ signature */
    set_window_pos_val: ImVec2                                       # store window position when using a non-zero Pivot (position set needs to be processed when we know the window size)    # imgui_internal.h:2306
    # ImVec2                  SetWindowPosPivot;    /* original C++ signature */
    set_window_pos_pivot: ImVec2                                     # store window pivot for positioning. ImVec2(0, 0) when positioning from top-left corner; ImVec2(0.5, 0.5) for centering; ImVec2(1, 1) for bottom right.    # imgui_internal.h:2307

    # ImGuiWindowTempData     DC;    /* original C++ signature */
    dc: ImGuiWindowTempData                                          # Temporary per-window data, reset at the beginning of the frame. This used to be called ImGuiDrawContext, hence the "DC" variable name.    # imgui_internal.h:2310

    # The best way to understand what those rectangles are is to use the 'Metrics->Tools->Show Windows Rectangles' viewer.
    # The main 'OuterRect', omitted as a field, is window->Rect().
    # ImRect                  OuterRectClipped;    /* original C++ signature */
    outer_rect_clipped: ImRect                                       # == Window->Rect() just after setup in Begin(). == window->Rect() for root window.    # imgui_internal.h:2314
    # ImRect                  InnerRect;    /* original C++ signature */
    inner_rect: ImRect                                               # Inner rectangle (omit title bar, menu bar, scroll bar)    # imgui_internal.h:2315
    # ImRect                  InnerClipRect;    /* original C++ signature */
    inner_clip_rect: ImRect                                          # == InnerRect shrunk by WindowPadding*0.5 on each side, clipped within viewport or parent clip rect.    # imgui_internal.h:2316
    # ImRect                  WorkRect;    /* original C++ signature */
    work_rect: ImRect                                                # Initially covers the whole scrolling region. Reduced by containers e.g columns/tables when active. Shrunk by WindowPadding*1.0 on each side. This is meant to replace ContentRegionRect over time (from 1.71+ onward).    # imgui_internal.h:2317
    # ImRect                  ParentWorkRect;    /* original C++ signature */
    parent_work_rect: ImRect                                         # Backup of WorkRect before entering a container such as columns/tables. Used by e.g. SpanAllColumns functions to easily access. Stacked containers are responsible for maintaining this. // FIXME-WORKRECT: Could be a stack?    # imgui_internal.h:2318
    # ImRect                  ClipRect;    /* original C++ signature */
    clip_rect: ImRect                                                # Current clipping/scissoring rectangle, evolve as we are using PushClipRect(), etc. == DrawList->clip_rect_stack.back().    # imgui_internal.h:2319
    # ImRect                  ContentRegionRect;    /* original C++ signature */
    content_region_rect: ImRect                                      # FIXME: This is currently confusing/misleading. It is essentially WorkRect but not handling of scrolling. We currently rely on it as right/bottom aligned sizing operation need some size to rely on.    # imgui_internal.h:2320
    # ImVec2ih                HitTestHoleSize;    /* original C++ signature */
    hit_test_hole_size: ImVec2ih                                     # Define an optional rectangular hole where mouse will pass-through the window.    # imgui_internal.h:2321
    # ImVec2ih                HitTestHoleOffset;    /* original C++ signature */
    hit_test_hole_offset: ImVec2ih                                   # imgui_internal.h:2322

    # int                     LastFrameActive;    /* original C++ signature */
    last_frame_active: int                                           # Last frame number the window was Active.    # imgui_internal.h:2324
    # int                     LastFrameJustFocused;    /* original C++ signature */
    last_frame_just_focused: int                                     # Last frame number the window was made Focused.    # imgui_internal.h:2325
    # float                   LastTimeActive;    /* original C++ signature */
    last_time_active: float                                          # Last timestamp the window was Active (using float as we don't need high precision there)    # imgui_internal.h:2326
    # float                   ItemWidthDefault;    /* original C++ signature */
    item_width_default: float                                        # imgui_internal.h:2327
    # ImGuiStorage            StateStorage;    /* original C++ signature */
    state_storage: ImGuiStorage                                      # imgui_internal.h:2328
    # float                   FontWindowScale;    /* original C++ signature */
    font_window_scale: float                                         # User scale multiplier per-window, via SetWindowFontScale()    # imgui_internal.h:2330
    # float                   FontDpiScale;    /* original C++ signature */
    font_dpi_scale: float                                            # imgui_internal.h:2331
    # int                     SettingsOffset;    /* original C++ signature */
    settings_offset: int                                             # Offset into SettingsWindows[] (offsets are always valid as we only grow the array from the back)    # imgui_internal.h:2332

    # ImDrawList*             DrawList;    /* original C++ signature */
    draw_list: ImDrawList                                            # == &DrawListInst (for backward compatibility reason with code using imgui_internal.h we keep this a pointer)    # imgui_internal.h:2334
    # ImDrawList              DrawListInst;    /* original C++ signature */
    draw_list_inst: ImDrawList                                       # imgui_internal.h:2335
    # ImGuiWindow*            ParentWindow;    /* original C++ signature */
    parent_window: ImGuiWindow                                       # If we are a child _or_ popup _or_ docked window, this is pointing to our parent. Otherwise None.    # imgui_internal.h:2336
    # ImGuiWindow*            ParentWindowInBeginStack;    /* original C++ signature */
    parent_window_in_begin_stack: ImGuiWindow                        # imgui_internal.h:2337
    # ImGuiWindow*            RootWindow;    /* original C++ signature */
    root_window: ImGuiWindow                                         # Point to ourself or first ancestor that is not a child window. Doesn't cross through popups/dock nodes.    # imgui_internal.h:2338
    # ImGuiWindow*            RootWindowPopupTree;    /* original C++ signature */
    root_window_popup_tree: ImGuiWindow                              # Point to ourself or first ancestor that is not a child window. Cross through popups parent<>child.    # imgui_internal.h:2339
    # ImGuiWindow*            RootWindowDockTree;    /* original C++ signature */
    root_window_dock_tree: ImGuiWindow                               # Point to ourself or first ancestor that is not a child window. Cross through dock nodes.    # imgui_internal.h:2340
    # ImGuiWindow*            RootWindowForTitleBarHighlight;    /* original C++ signature */
    root_window_for_title_bar_highlight: ImGuiWindow                 # Point to ourself or first ancestor which will display TitleBgActive color when this window is active.    # imgui_internal.h:2341
    # ImGuiWindow*            RootWindowForNav;    /* original C++ signature */
    root_window_for_nav: ImGuiWindow                                 # Point to ourself or first ancestor which doesn't have the NavFlattened flag.    # imgui_internal.h:2342

    # ImGuiWindow*            NavLastChildNavWindow;    /* original C++ signature */
    nav_last_child_nav_window: ImGuiWindow                           # When going to the menu bar, we remember the child window we came from. (This could probably be made implicit if we kept g.Windows sorted by last focused including child window.)    # imgui_internal.h:2344

    # int                     MemoryDrawListIdxCapacity;    /* original C++ signature */
    memory_draw_list_idx_capacity: int                               # Backup of last idx/vtx count, so when waking up the window we can preallocate and avoid iterative alloc/copy    # imgui_internal.h:2348
    # int                     MemoryDrawListVtxCapacity;    /* original C++ signature */
    memory_draw_list_vtx_capacity: int                               # imgui_internal.h:2349
    # bool                    MemoryCompacted;    /* original C++ signature */
    memory_compacted: bool                                           # Set when window extraneous data have been garbage collected    # imgui_internal.h:2350

    # Docking
    # short                   DockOrder;    /* original C++ signature */
    dock_order: int                                                  # Order of the last time the window was visible within its DockNode. This is used to reorder windows that are reappearing on the same frame. Same value between windows that were active and windows that were none are possible.    # imgui_internal.h:2357
    # ImGuiWindowDockStyle    DockStyle;    /* original C++ signature */
    dock_style: ImGuiWindowDockStyle                                 # imgui_internal.h:2358
    # ImGuiDockNode*          DockNode;    /* original C++ signature */
    dock_node: ImGuiDockNode                                         # Which node are we docked into. Important: Prefer testing DockIsActive in many cases as this will still be set when the dock node is hidden.    # imgui_internal.h:2359
    # ImGuiDockNode*          DockNodeAsHost;    /* original C++ signature */
    dock_node_as_host: ImGuiDockNode                                 # Which node are we owning (for parent windows)    # imgui_internal.h:2360
    # ImGuiID                 DockId;    /* original C++ signature */
    dock_id: ImGuiID                                                 # Backup of last valid DockNode->ID, so single window remember their dock node id even when they are not bound any more    # imgui_internal.h:2361
    # ImGuiItemStatusFlags    DockTabItemStatusFlags;    /* original C++ signature */
    dock_tab_item_status_flags: ImGuiItemStatusFlags                 # imgui_internal.h:2362
    # ImRect                  DockTabItemRect;    /* original C++ signature */
    dock_tab_item_rect: ImRect                                       # imgui_internal.h:2363

    # ImGuiWindow(ImGuiContext* context, const char* name);    /* original C++ signature */
    def __init__(self, context: ImGuiContext, name: str) -> None:    # imgui_internal.h:2366
        pass


    # We don't use g.FontSize because the window may be != g.CurrentWidow.

#-----------------------------------------------------------------------------
# [SECTION] Tab bar, Tab item support
#-----------------------------------------------------------------------------

class ImGuiTabBarFlagsPrivate_(enum.Enum):    # imgui_internal.h:2388
    """ Extend ImGuiTabBarFlags_"""
    # ImGuiTabBarFlags_DockNode                   = 1 << 20,      /* original C++ signature */
    im_gui_tab_bar_flags_dock_node = enum.auto()     # (= 1 << 20)  # Part of a dock node [we don't use this in the master branch but it facilitate branch syncing to keep this around]
    # ImGuiTabBarFlags_IsFocused                  = 1 << 21,    /* original C++ signature */
    im_gui_tab_bar_flags_is_focused = enum.auto()    # (= 1 << 21)
    # ImGuiTabBarFlags_SaveSettings               = 1 << 22       /* original C++ signature */
    im_gui_tab_bar_flags_save_settings = enum.auto() # (= 1 << 22)  # FIXME: Settings are handled by the docking system, this only request the tab bar to mark settings dirty when reordering tabs

class ImGuiTabItemFlagsPrivate_(enum.Enum):    # imgui_internal.h:2396
    """ Extend ImGuiTabItemFlags_"""
    # ImGuiTabItemFlags_SectionMask_              = ImGuiTabItemFlags_Leading | ImGuiTabItemFlags_Trailing,    /* original C++ signature */
    im_gui_tab_item_flags_section_mask_ = enum.auto()   # (= ImGuiTabItemFlags_.leading | ImGuiTabItemFlags_.trailing)
    # ImGuiTabItemFlags_NoCloseButton             = 1 << 20,      /* original C++ signature */
    im_gui_tab_item_flags_no_close_button = enum.auto() # (= 1 << 20)  # Track whether p_open was set or not (we'll need this info on the next frame to recompute ContentWidth during layout)
    # ImGuiTabItemFlags_Button                    = 1 << 21,      /* original C++ signature */
    im_gui_tab_item_flags_button = enum.auto()          # (= 1 << 21)  # Used by TabItemButton, change the tab item behavior to mimic a button
    # ImGuiTabItemFlags_Unsorted                  = 1 << 22,      /* original C++ signature */
    im_gui_tab_item_flags_unsorted = enum.auto()        # (= 1 << 22)  # [Docking] Trailing tabs with the _Unsorted flag will be sorted based on the DockOrder of their Window.
    # ImGuiTabItemFlags_Preview                   = 1 << 23       /* original C++ signature */
    im_gui_tab_item_flags_preview = enum.auto()         # (= 1 << 23)  # [Docking] Display tab shape for docking preview (height is adjusted slightly to compensate for the yet missing tab bar)

class ImGuiTabItem:    # imgui_internal.h:2406
    """ Storage for one active tab item (sizeof() 48 bytes)"""
    # ImGuiID             ID;    /* original C++ signature */
    id: ImGuiID                    # imgui_internal.h:2408
    # ImGuiTabItemFlags   Flags;    /* original C++ signature */
    flags: ImGuiTabItemFlags       # imgui_internal.h:2409
    # ImGuiWindow*        Window;    /* original C++ signature */
    window: ImGuiWindow            # When TabItem is part of a DockNode's TabBar, we hold on to a window.    # imgui_internal.h:2410
    # int                 LastFrameVisible;    /* original C++ signature */
    last_frame_visible: int        # imgui_internal.h:2411
    # int                 LastFrameSelected;    /* original C++ signature */
    last_frame_selected: int       # This allows us to infer an ordered list of the last activated tabs with little maintenance    # imgui_internal.h:2412
    # float               Offset;    /* original C++ signature */
    offset: float                  # Position relative to beginning of tab    # imgui_internal.h:2413
    # float               Width;    /* original C++ signature */
    width: float                   # Width currently displayed    # imgui_internal.h:2414
    # float               ContentWidth;    /* original C++ signature */
    content_width: float           # Width of label, stored during BeginTabItem() call    # imgui_internal.h:2415
    # float               RequestedWidth;    /* original C++ signature */
    requested_width: float         # Width optionally requested by caller, -1.0 is unused    # imgui_internal.h:2416
    # ImS32               NameOffset;    /* original C++ signature */
    name_offset: ImS32             # When Window==None, offset to name within parent ImGuiTabBar::TabsNames    # imgui_internal.h:2417
    # ImS16               BeginOrder;    /* original C++ signature */
    begin_order: ImS16             # BeginTabItem() order, used to re-order tabs after toggling ImGuiTabBarFlags_Reorderable    # imgui_internal.h:2418
    # ImS16               IndexDuringLayout;    /* original C++ signature */
    index_during_layout: ImS16     # Index only used during TabBarLayout()    # imgui_internal.h:2419
    # bool                WantClose;    /* original C++ signature */
    want_close: bool               # Marked as closed by SetTabItemClosed()    # imgui_internal.h:2420

    # ImGuiTabItem()      { memset(this, 0, sizeof(*this)); LastFrameVisible = LastFrameSelected = -1; NameOffset = -1; BeginOrder = IndexDuringLayout = -1; }    /* original C++ signature */
    def __init__(self) -> None:    # imgui_internal.h:2422
        pass

class ImGuiTabBar:    # imgui_internal.h:2426
    """ Storage for a tab bar (sizeof() 152 bytes)"""
    # ImGuiTabBarFlags    Flags;    /* original C++ signature */
    flags: ImGuiTabBarFlags                       # imgui_internal.h:2429
    # ImGuiID             ID;    /* original C++ signature */
    id: ImGuiID                                   # Zero for tab-bars used by docking    # imgui_internal.h:2430
    # ImGuiID             SelectedTabId;    /* original C++ signature */
    selected_tab_id: ImGuiID                      # Selected tab/window    # imgui_internal.h:2431
    # ImGuiID             NextSelectedTabId;    /* original C++ signature */
    next_selected_tab_id: ImGuiID                 # Next selected tab/window. Will also trigger a scrolling animation    # imgui_internal.h:2432
    # ImGuiID             VisibleTabId;    /* original C++ signature */
    visible_tab_id: ImGuiID                       # Can occasionally be != SelectedTabId (e.g. when previewing contents for CTRL+TAB preview)    # imgui_internal.h:2433
    # int                 CurrFrameVisible;    /* original C++ signature */
    curr_frame_visible: int                       # imgui_internal.h:2434
    # int                 PrevFrameVisible;    /* original C++ signature */
    prev_frame_visible: int                       # imgui_internal.h:2435
    # ImRect              BarRect;    /* original C++ signature */
    bar_rect: ImRect                              # imgui_internal.h:2436
    # float               CurrTabsContentsHeight;    /* original C++ signature */
    curr_tabs_contents_height: float              # imgui_internal.h:2437
    # float               PrevTabsContentsHeight;    /* original C++ signature */
    prev_tabs_contents_height: float              # Record the height of contents submitted below the tab bar    # imgui_internal.h:2438
    # float               WidthAllTabs;    /* original C++ signature */
    width_all_tabs: float                         # Actual width of all tabs (locked during layout)    # imgui_internal.h:2439
    # float               WidthAllTabsIdeal;    /* original C++ signature */
    width_all_tabs_ideal: float                   # Ideal width if all tabs were visible and not clipped    # imgui_internal.h:2440
    # float               ScrollingAnim;    /* original C++ signature */
    scrolling_anim: float                         # imgui_internal.h:2441
    # float               ScrollingTarget;    /* original C++ signature */
    scrolling_target: float                       # imgui_internal.h:2442
    # float               ScrollingTargetDistToVisibility;    /* original C++ signature */
    scrolling_target_dist_to_visibility: float    # imgui_internal.h:2443
    # float               ScrollingSpeed;    /* original C++ signature */
    scrolling_speed: float                        # imgui_internal.h:2444
    # float               ScrollingRectMinX;    /* original C++ signature */
    scrolling_rect_min_x: float                   # imgui_internal.h:2445
    # float               ScrollingRectMaxX;    /* original C++ signature */
    scrolling_rect_max_x: float                   # imgui_internal.h:2446
    # ImGuiID             ReorderRequestTabId;    /* original C++ signature */
    reorder_request_tab_id: ImGuiID               # imgui_internal.h:2447
    # ImS16               ReorderRequestOffset;    /* original C++ signature */
    reorder_request_offset: ImS16                 # imgui_internal.h:2448
    # ImS8                BeginCount;    /* original C++ signature */
    begin_count: ImS8                             # imgui_internal.h:2449
    # bool                WantLayout;    /* original C++ signature */
    want_layout: bool                             # imgui_internal.h:2450
    # bool                VisibleTabWasSubmitted;    /* original C++ signature */
    visible_tab_was_submitted: bool               # imgui_internal.h:2451
    # bool                TabsAddedNew;    /* original C++ signature */
    tabs_added_new: bool                          # Set to True when a new tab item or button has been added to the tab bar during last frame    # imgui_internal.h:2452
    # ImS16               TabsActiveCount;    /* original C++ signature */
    tabs_active_count: ImS16                      # Number of tabs submitted this frame.    # imgui_internal.h:2453
    # ImS16               LastTabItemIdx;    /* original C++ signature */
    last_tab_item_idx: ImS16                      # Index of last BeginTabItem() tab for use by EndTabItem()    # imgui_internal.h:2454
    # float               ItemSpacingY;    /* original C++ signature */
    item_spacing_y: float                         # imgui_internal.h:2455
    # ImVec2              FramePadding;    /* original C++ signature */
    frame_padding: ImVec2                         # style.FramePadding locked at the time of BeginTabBar()    # imgui_internal.h:2456
    # ImVec2              BackupCursorPos;    /* original C++ signature */
    backup_cursor_pos: ImVec2                     # imgui_internal.h:2457
    # ImGuiTextBuffer     TabsNames;    /* original C++ signature */
    tabs_names: ImGuiTextBuffer                   # For non-docking tab bar we re-append names in a contiguous buffer.    # imgui_internal.h:2458

    # ImGuiTabBar();    /* original C++ signature */
    def __init__(self) -> None:                   # imgui_internal.h:2460
        pass

#-----------------------------------------------------------------------------
# [SECTION] Table support
#-----------------------------------------------------------------------------


# Our current column maximum is 64 but we may raise that in the future.

class ImGuiTableColumn:    # imgui_internal.h:2487
    """ [Internal] sizeof() ~ 104
     We use the terminology "Enabled" to refer to a column that is not Hidden by user/api.
     We use the terminology "Clipped" to refer to a column that is out of sight because of scrolling/clipping.
     This is in contrast with some user-facing api such as IsItemVisible() / IsRectVisible() which use "Visible" to mean "not clipped".
    """
    # ImGuiTableColumnFlags   Flags;    /* original C++ signature */
    flags: ImGuiTableColumnFlags                     # Flags after some patching (not directly same as provided by user). See ImGuiTableColumnFlags_    # imgui_internal.h:2489
    # float                   WidthGiven;    /* original C++ signature */
    width_given: float                               # Final/actual width visible == (MaxX - MinX), locked in TableUpdateLayout(). May be > WidthRequest to honor minimum width, may be < WidthRequest to honor shrinking columns down in tight space.    # imgui_internal.h:2490
    # float                   MinX;    /* original C++ signature */
    min_x: float                                     # Absolute positions    # imgui_internal.h:2491
    # float                   MaxX;    /* original C++ signature */
    max_x: float                                     # imgui_internal.h:2492
    # float                   WidthRequest;    /* original C++ signature */
    width_request: float                             # Master width absolute value when !(Flags & _WidthStretch). When Stretch this is derived every frame from StretchWeight in TableUpdateLayout()    # imgui_internal.h:2493
    # float                   WidthAuto;    /* original C++ signature */
    width_auto: float                                # Automatic width    # imgui_internal.h:2494
    # float                   StretchWeight;    /* original C++ signature */
    stretch_weight: float                            # Master width weight when (Flags & _WidthStretch). Often around ~1.0 initially.    # imgui_internal.h:2495
    # float                   InitStretchWeightOrWidth;    /* original C++ signature */
    init_stretch_weight_or_width: float              # Value passed to TableSetupColumn(). For Width it is a content width (_without padding_).    # imgui_internal.h:2496
    # ImRect                  ClipRect;    /* original C++ signature */
    clip_rect: ImRect                                # Clipping rectangle for the column    # imgui_internal.h:2497
    # ImGuiID                 UserID;    /* original C++ signature */
    user_id: ImGuiID                                 # Optional, value passed to TableSetupColumn()    # imgui_internal.h:2498
    # float                   WorkMinX;    /* original C++ signature */
    work_min_x: float                                # Contents region min ~(MinX + CellPaddingX + CellSpacingX1) == cursor start position when entering column    # imgui_internal.h:2499
    # float                   WorkMaxX;    /* original C++ signature */
    work_max_x: float                                # Contents region max ~(MaxX - CellPaddingX - CellSpacingX2)    # imgui_internal.h:2500
    # float                   ItemWidth;    /* original C++ signature */
    item_width: float                                # Current item width for the column, preserved across rows    # imgui_internal.h:2501
    # float                   ContentMaxXFrozen;    /* original C++ signature */
    content_max_x_frozen: float                      # Contents maximum position for frozen rows (apart from headers), from which we can infer content width.    # imgui_internal.h:2502
    # float                   ContentMaxXUnfrozen;    /* original C++ signature */
    content_max_x_unfrozen: float                    # imgui_internal.h:2503
    # float                   ContentMaxXHeadersUsed;    /* original C++ signature */
    content_max_x_headers_used: float                # Contents maximum position for headers rows (regardless of freezing). TableHeader() automatically softclip itself + report ideal desired size, to avoid creating extraneous draw calls    # imgui_internal.h:2504
    # float                   ContentMaxXHeadersIdeal;    /* original C++ signature */
    content_max_x_headers_ideal: float               # imgui_internal.h:2505
    # ImS16                   NameOffset;    /* original C++ signature */
    name_offset: ImS16                               # Offset into parent ColumnsNames[]    # imgui_internal.h:2506
    # ImGuiTableColumnIdx     DisplayOrder;    /* original C++ signature */
    display_order: ImGuiTableColumnIdx               # Index within Table's IndexToDisplayOrder[] (column may be reordered by users)    # imgui_internal.h:2507
    # ImGuiTableColumnIdx     IndexWithinEnabledSet;    /* original C++ signature */
    index_within_enabled_set: ImGuiTableColumnIdx    # Index within enabled/visible set (<= IndexToDisplayOrder)    # imgui_internal.h:2508
    # ImGuiTableColumnIdx     PrevEnabledColumn;    /* original C++ signature */
    prev_enabled_column: ImGuiTableColumnIdx         # Index of prev enabled/visible column within Columns[], -1 if first enabled/visible column    # imgui_internal.h:2509
    # ImGuiTableColumnIdx     NextEnabledColumn;    /* original C++ signature */
    next_enabled_column: ImGuiTableColumnIdx         # Index of next enabled/visible column within Columns[], -1 if last enabled/visible column    # imgui_internal.h:2510
    # ImGuiTableColumnIdx     SortOrder;    /* original C++ signature */
    sort_order: ImGuiTableColumnIdx                  # Index of this column within sort specs, -1 if not sorting on this column, 0 for single-sort, may be >0 on multi-sort    # imgui_internal.h:2511
    # ImGuiTableDrawChannelIdx DrawChannelCurrent;    /* original C++ signature */
    draw_channel_current: ImGuiTableDrawChannelIdx   # Index within DrawSplitter.Channels[]    # imgui_internal.h:2512
    # ImGuiTableDrawChannelIdx DrawChannelFrozen;    /* original C++ signature */
    draw_channel_frozen: ImGuiTableDrawChannelIdx    # Draw channels for frozen rows (often headers)    # imgui_internal.h:2513
    # ImGuiTableDrawChannelIdx DrawChannelUnfrozen;    /* original C++ signature */
    draw_channel_unfrozen: ImGuiTableDrawChannelIdx  # Draw channels for unfrozen rows    # imgui_internal.h:2514
    # bool                    IsEnabled;    /* original C++ signature */
    is_enabled: bool                                 # IsUserEnabled && (Flags & ImGuiTableColumnFlags_Disabled) == 0    # imgui_internal.h:2515
    # bool                    IsUserEnabled;    /* original C++ signature */
    is_user_enabled: bool                            # Is the column not marked Hidden by the user? (unrelated to being off view, e.g. clipped by scrolling).    # imgui_internal.h:2516
    # bool                    IsUserEnabledNextFrame;    /* original C++ signature */
    is_user_enabled_next_frame: bool                 # imgui_internal.h:2517
    # bool                    IsVisibleX;    /* original C++ signature */
    is_visible_x: bool                               # Is actually in view (e.g. overlapping the host window clipping rectangle, not scrolled).    # imgui_internal.h:2518
    # bool                    IsVisibleY;    /* original C++ signature */
    is_visible_y: bool                               # imgui_internal.h:2519
    # bool                    IsRequestOutput;    /* original C++ signature */
    is_request_output: bool                          # Return value for TableSetColumnIndex() / TableNextColumn(): whether we request user to output contents or not.    # imgui_internal.h:2520
    # bool                    IsSkipItems;    /* original C++ signature */
    is_skip_items: bool                              # Do we want item submissions to this column to be completely ignored (no layout will happen).    # imgui_internal.h:2521
    # bool                    IsPreserveWidthAuto;    /* original C++ signature */
    is_preserve_width_auto: bool                     # imgui_internal.h:2522
    # ImS8                    NavLayerCurrent;    /* original C++ signature */
    nav_layer_current: ImS8                          # ImGuiNavLayer in 1 byte    # imgui_internal.h:2523
    # ImU8                    AutoFitQueue;    /* original C++ signature */
    auto_fit_queue: ImU8                             # Queue of 8 values for the next 8 frames to request auto-fit    # imgui_internal.h:2524
    # ImU8                    CannotSkipItemsQueue;    /* original C++ signature */
    cannot_skip_items_queue: ImU8                    # Queue of 8 values for the next 8 frames to disable Clipped/SkipItem    # imgui_internal.h:2525
    # ImU8                    SortDirectionsAvailList;    /* original C++ signature */
    sort_directions_avail_list: ImU8                 # Ordered of available sort directions (2-bits each)    # imgui_internal.h:2529

    # ImGuiTableColumn()    /* original C++ signature */
    #     {
    #         memset(this, 0, sizeof(*this));
    #         StretchWeight = WidthRequest = -1.0f;
    #         NameOffset = -1;
    #         DisplayOrder = IndexWithinEnabledSet = -1;
    #         PrevEnabledColumn = NextEnabledColumn = -1;
    #         SortOrder = -1;
    #         SortDirection = ImGuiSortDirection_None;
    #         DrawChannelCurrent = DrawChannelFrozen = DrawChannelUnfrozen = (ImU8)-1;
    #     }
    def __init__(self) -> None:                      # imgui_internal.h:2531
        pass

class ImGuiTableCellData:    # imgui_internal.h:2546
    """ Transient cell data stored per row.
     sizeof() ~ 6
    """
    # ImU32                       BgColor;    /* original C++ signature */
    bg_color: ImU32              # Actual color    # imgui_internal.h:2548
    # ImGuiTableColumnIdx         Column;    /* original C++ signature */
    column: ImGuiTableColumnIdx  # Column number    # imgui_internal.h:2549

class ImGuiTableInstanceData:    # imgui_internal.h:2553
    """ Per-instance data that needs preserving across frames (seemingly most others do not need to be preserved aside from debug needs, does that needs they could be moved to ImGuiTableTempData ?)"""
    # float                       LastOuterHeight;    /* original C++ signature */
    last_outer_height: float       # Outer height from last frame // FIXME: multi-instance issue (#3955)    # imgui_internal.h:2555
    # float                       LastFirstRowHeight;    /* original C++ signature */
    last_first_row_height: float   # Height of first row from last frame // FIXME: possible multi-instance issue?    # imgui_internal.h:2556

    # ImGuiTableInstanceData()    { LastOuterHeight = LastFirstRowHeight = 0.0f; }    /* original C++ signature */
    def __init__(self) -> None:    # imgui_internal.h:2558
        pass

class ImGuiTable:    # imgui_internal.h:2562
    """ FIXME-TABLE: more transient data could be stored in a per-stacked table structure: DrawSplitter, SortSpecs, incoming RowData"""
    # ImGuiID                     ID;    /* original C++ signature */
    id: ImGuiID                                            # imgui_internal.h:2564
    # ImGuiTableFlags             Flags;    /* original C++ signature */
    flags: ImGuiTableFlags                                 # imgui_internal.h:2565
    # void*                       RawData;    /* original C++ signature */
    raw_data: Any                                          # Single allocation to hold Columns[], DisplayOrderToIndex[] and RowCellData[]    # imgui_internal.h:2566
    # ImGuiTableTempData*         TempData;    /* original C++ signature */
    temp_data: ImGuiTableTempData                          # Transient data while table is active. Point within g.CurrentTableStack[]    # imgui_internal.h:2567
    # ImU64                       EnabledMaskByDisplayOrder;    /* original C++ signature */
    enabled_mask_by_display_order: ImU64                   # Column DisplayOrder -> IsEnabled map    # imgui_internal.h:2571
    # ImU64                       EnabledMaskByIndex;    /* original C++ signature */
    enabled_mask_by_index: ImU64                           # Column Index -> IsEnabled map (== not hidden by user/api) in a format adequate for iterating column without touching cold data    # imgui_internal.h:2572
    # ImU64                       VisibleMaskByIndex;    /* original C++ signature */
    visible_mask_by_index: ImU64                           # Column Index -> IsVisibleX|IsVisibleY map (== not hidden by user/api && not hidden by scrolling/cliprect)    # imgui_internal.h:2573
    # ImU64                       RequestOutputMaskByIndex;    /* original C++ signature */
    request_output_mask_by_index: ImU64                    # Column Index -> IsVisible || AutoFit (== expect user to submit items)    # imgui_internal.h:2574
    # ImGuiTableFlags             SettingsLoadedFlags;    /* original C++ signature */
    settings_loaded_flags: ImGuiTableFlags                 # Which data were loaded from the .ini file (e.g. when order is not altered we won't save order)    # imgui_internal.h:2575
    # int                         SettingsOffset;    /* original C++ signature */
    settings_offset: int                                   # Offset in g.SettingsTables    # imgui_internal.h:2576
    # int                         LastFrameActive;    /* original C++ signature */
    last_frame_active: int                                 # imgui_internal.h:2577
    # int                         ColumnsCount;    /* original C++ signature */
    columns_count: int                                     # Number of columns declared in BeginTable()    # imgui_internal.h:2578
    # int                         CurrentRow;    /* original C++ signature */
    current_row: int                                       # imgui_internal.h:2579
    # int                         CurrentColumn;    /* original C++ signature */
    current_column: int                                    # imgui_internal.h:2580
    # ImS16                       InstanceCurrent;    /* original C++ signature */
    instance_current: ImS16                                # Count of BeginTable() calls with same ID in the same frame (generally 0). This is a little bit similar to BeginCount for a window, but multiple table with same ID look are multiple tables, they are just synched.    # imgui_internal.h:2581
    # ImS16                       InstanceInteracted;    /* original C++ signature */
    instance_interacted: ImS16                             # Mark which instance (generally 0) of the same ID is being interacted with    # imgui_internal.h:2582
    # float                       RowPosY1;    /* original C++ signature */
    row_pos_y1: float                                      # imgui_internal.h:2583
    # float                       RowPosY2;    /* original C++ signature */
    row_pos_y2: float                                      # imgui_internal.h:2584
    # float                       RowMinHeight;    /* original C++ signature */
    row_min_height: float                                  # Height submitted to TableNextRow()    # imgui_internal.h:2585
    # float                       RowTextBaseline;    /* original C++ signature */
    row_text_baseline: float                               # imgui_internal.h:2586
    # float                       RowIndentOffsetX;    /* original C++ signature */
    row_indent_offset_x: float                             # imgui_internal.h:2587
    # int                         RowBgColorCounter;    /* original C++ signature */
    row_bg_color_counter: int                              # Counter for alternating background colors (can be fast-forwarded by e.g clipper), not same as CurrentRow because header rows typically don't increase this.    # imgui_internal.h:2590
    # ImU32                       RowBgColor[2];    /* original C++ signature */
    row_bg_color: np.ndarray                               # ndarray[type=ImU32, size=2]  # Background color override for current row.    # imgui_internal.h:2591
    # ImU32                       BorderColorStrong;    /* original C++ signature */
    border_color_strong: ImU32                             # imgui_internal.h:2592
    # ImU32                       BorderColorLight;    /* original C++ signature */
    border_color_light: ImU32                              # imgui_internal.h:2593
    # float                       BorderX1;    /* original C++ signature */
    border_x1: float                                       # imgui_internal.h:2594
    # float                       BorderX2;    /* original C++ signature */
    border_x2: float                                       # imgui_internal.h:2595
    # float                       HostIndentX;    /* original C++ signature */
    host_indent_x: float                                   # imgui_internal.h:2596
    # float                       MinColumnWidth;    /* original C++ signature */
    min_column_width: float                                # imgui_internal.h:2597
    # float                       OuterPaddingX;    /* original C++ signature */
    outer_padding_x: float                                 # imgui_internal.h:2598
    # float                       CellPaddingX;    /* original C++ signature */
    cell_padding_x: float                                  # Padding from each borders    # imgui_internal.h:2599
    # float                       CellPaddingY;    /* original C++ signature */
    cell_padding_y: float                                  # imgui_internal.h:2600
    # float                       CellSpacingX1;    /* original C++ signature */
    cell_spacing_x1: float                                 # Spacing between non-bordered cells    # imgui_internal.h:2601
    # float                       CellSpacingX2;    /* original C++ signature */
    cell_spacing_x2: float                                 # imgui_internal.h:2602
    # float                       InnerWidth;    /* original C++ signature */
    inner_width: float                                     # User value passed to BeginTable(), see comments at the top of BeginTable() for details.    # imgui_internal.h:2603
    # float                       ColumnsGivenWidth;    /* original C++ signature */
    columns_given_width: float                             # Sum of current column width    # imgui_internal.h:2604
    # float                       ColumnsAutoFitWidth;    /* original C++ signature */
    columns_auto_fit_width: float                          # Sum of ideal column width in order nothing to be clipped, used for auto-fitting and content width submission in outer window    # imgui_internal.h:2605
    # float                       ColumnsStretchSumWeights;    /* original C++ signature */
    columns_stretch_sum_weights: float                     # Sum of weight of all enabled stretching columns    # imgui_internal.h:2606
    # float                       ResizedColumnNextWidth;    /* original C++ signature */
    resized_column_next_width: float                       # imgui_internal.h:2607
    # float                       ResizeLockMinContentsX2;    /* original C++ signature */
    resize_lock_min_contents_x2: float                     # Lock minimum contents width while resizing down in order to not create feedback loops. But we allow growing the table.    # imgui_internal.h:2608
    # float                       RefScale;    /* original C++ signature */
    ref_scale: float                                       # Reference scale to be able to rescale columns on font/dpi changes.    # imgui_internal.h:2609
    # ImRect                      OuterRect;    /* original C++ signature */
    outer_rect: ImRect                                     # Note: for non-scrolling table, OuterRect.Max.y is often FLT_MAX until EndTable(), unless a height has been specified in BeginTable().    # imgui_internal.h:2610
    # ImRect                      InnerRect;    /* original C++ signature */
    inner_rect: ImRect                                     # InnerRect but without decoration. As with OuterRect, for non-scrolling tables, InnerRect.Max.y is    # imgui_internal.h:2611
    # ImRect                      WorkRect;    /* original C++ signature */
    work_rect: ImRect                                      # imgui_internal.h:2612
    # ImRect                      InnerClipRect;    /* original C++ signature */
    inner_clip_rect: ImRect                                # imgui_internal.h:2613
    # ImRect                      BgClipRect;    /* original C++ signature */
    bg_clip_rect: ImRect                                   # We use this to cpu-clip cell background color fill, evolve during the frame as we cross frozen rows boundaries    # imgui_internal.h:2614
    # ImRect                      Bg0ClipRectForDrawCmd;    /* original C++ signature */
    bg0_clip_rect_for_draw_cmd: ImRect                     # Actual ImDrawCmd clip rect for BG0/1 channel. This tends to be == OuterWindow->ClipRect at BeginTable() because output in BG0/BG1 is cpu-clipped    # imgui_internal.h:2615
    # ImRect                      Bg2ClipRectForDrawCmd;    /* original C++ signature */
    bg2_clip_rect_for_draw_cmd: ImRect                     # Actual ImDrawCmd clip rect for BG2 channel. This tends to be a correct, tight-fit, because output to BG2 are done by widgets relying on regular ClipRect.    # imgui_internal.h:2616
    # ImRect                      HostClipRect;    /* original C++ signature */
    host_clip_rect: ImRect                                 # This is used to check if we can eventually merge our columns draw calls into the current draw call of the current window.    # imgui_internal.h:2617
    # ImRect                      HostBackupInnerClipRect;    /* original C++ signature */
    host_backup_inner_clip_rect: ImRect                    # Backup of InnerWindow->ClipRect during PushTableBackground()/PopTableBackground()    # imgui_internal.h:2618
    # ImGuiWindow*                OuterWindow;    /* original C++ signature */
    outer_window: ImGuiWindow                              # Parent window for the table    # imgui_internal.h:2619
    # ImGuiWindow*                InnerWindow;    /* original C++ signature */
    inner_window: ImGuiWindow                              # Window holding the table data (== OuterWindow or a child window)    # imgui_internal.h:2620
    # ImGuiTextBuffer             ColumnsNames;    /* original C++ signature */
    columns_names: ImGuiTextBuffer                         # Contiguous buffer holding columns names    # imgui_internal.h:2621
    # ImDrawListSplitter*         DrawSplitter;    /* original C++ signature */
    draw_splitter: ImDrawListSplitter                      # Shortcut to TempData->DrawSplitter while in table. Isolate draw commands per columns to avoid switching clip rect constantly    # imgui_internal.h:2622
    # ImGuiTableInstanceData      InstanceDataFirst;    /* original C++ signature */
    instance_data_first: ImGuiTableInstanceData            # imgui_internal.h:2623
    # ImGuiTableColumnSortSpecs   SortSpecsSingle;    /* original C++ signature */
    sort_specs_single: ImGuiTableColumnSortSpecs           # imgui_internal.h:2625
    # ImGuiTableSortSpecs         SortSpecs;    /* original C++ signature */
    sort_specs: ImGuiTableSortSpecs                        # Public facing sorts specs, this is what we return in TableGetSortSpecs()    # imgui_internal.h:2627
    # ImGuiTableColumnIdx         SortSpecsCount;    /* original C++ signature */
    sort_specs_count: ImGuiTableColumnIdx                  # imgui_internal.h:2628
    # ImGuiTableColumnIdx         ColumnsEnabledCount;    /* original C++ signature */
    columns_enabled_count: ImGuiTableColumnIdx             # Number of enabled columns (<= ColumnsCount)    # imgui_internal.h:2629
    # ImGuiTableColumnIdx         ColumnsEnabledFixedCount;    /* original C++ signature */
    columns_enabled_fixed_count: ImGuiTableColumnIdx       # Number of enabled columns (<= ColumnsCount)    # imgui_internal.h:2630
    # ImGuiTableColumnIdx         DeclColumnsCount;    /* original C++ signature */
    decl_columns_count: ImGuiTableColumnIdx                # Count calls to TableSetupColumn()    # imgui_internal.h:2631
    # ImGuiTableColumnIdx         HoveredColumnBody;    /* original C++ signature */
    hovered_column_body: ImGuiTableColumnIdx               # Index of column whose visible region is being hovered. Important: == ColumnsCount when hovering empty region after the right-most column!    # imgui_internal.h:2632
    # ImGuiTableColumnIdx         HoveredColumnBorder;    /* original C++ signature */
    hovered_column_border: ImGuiTableColumnIdx             # Index of column whose right-border is being hovered (for resizing).    # imgui_internal.h:2633
    # ImGuiTableColumnIdx         AutoFitSingleColumn;    /* original C++ signature */
    auto_fit_single_column: ImGuiTableColumnIdx            # Index of single column requesting auto-fit.    # imgui_internal.h:2634
    # ImGuiTableColumnIdx         ResizedColumn;    /* original C++ signature */
    resized_column: ImGuiTableColumnIdx                    # Index of column being resized. Reset when InstanceCurrent==0.    # imgui_internal.h:2635
    # ImGuiTableColumnIdx         LastResizedColumn;    /* original C++ signature */
    last_resized_column: ImGuiTableColumnIdx               # Index of column being resized from previous frame.    # imgui_internal.h:2636
    # ImGuiTableColumnIdx         HeldHeaderColumn;    /* original C++ signature */
    held_header_column: ImGuiTableColumnIdx                # Index of column header being held.    # imgui_internal.h:2637
    # ImGuiTableColumnIdx         ReorderColumn;    /* original C++ signature */
    reorder_column: ImGuiTableColumnIdx                    # Index of column being reordered. (not cleared)    # imgui_internal.h:2638
    # ImGuiTableColumnIdx         ReorderColumnDir;    /* original C++ signature */
    reorder_column_dir: ImGuiTableColumnIdx                # -1 or +1    # imgui_internal.h:2639
    # ImGuiTableColumnIdx         LeftMostEnabledColumn;    /* original C++ signature */
    left_most_enabled_column: ImGuiTableColumnIdx          # Index of left-most non-hidden column.    # imgui_internal.h:2640
    # ImGuiTableColumnIdx         RightMostEnabledColumn;    /* original C++ signature */
    right_most_enabled_column: ImGuiTableColumnIdx         # Index of right-most non-hidden column.    # imgui_internal.h:2641
    # ImGuiTableColumnIdx         LeftMostStretchedColumn;    /* original C++ signature */
    left_most_stretched_column: ImGuiTableColumnIdx        # Index of left-most stretched column.    # imgui_internal.h:2642
    # ImGuiTableColumnIdx         RightMostStretchedColumn;    /* original C++ signature */
    right_most_stretched_column: ImGuiTableColumnIdx       # Index of right-most stretched column.    # imgui_internal.h:2643
    # ImGuiTableColumnIdx         ContextPopupColumn;    /* original C++ signature */
    context_popup_column: ImGuiTableColumnIdx              # Column right-clicked on, of -1 if opening context menu from a neutral/empty spot    # imgui_internal.h:2644
    # ImGuiTableColumnIdx         FreezeRowsRequest;    /* original C++ signature */
    freeze_rows_request: ImGuiTableColumnIdx               # Requested frozen rows count    # imgui_internal.h:2645
    # ImGuiTableColumnIdx         FreezeRowsCount;    /* original C++ signature */
    freeze_rows_count: ImGuiTableColumnIdx                 # Actual frozen row count (== FreezeRowsRequest, or == 0 when no scrolling offset)    # imgui_internal.h:2646
    # ImGuiTableColumnIdx         FreezeColumnsRequest;    /* original C++ signature */
    freeze_columns_request: ImGuiTableColumnIdx            # Requested frozen columns count    # imgui_internal.h:2647
    # ImGuiTableColumnIdx         FreezeColumnsCount;    /* original C++ signature */
    freeze_columns_count: ImGuiTableColumnIdx              # Actual frozen columns count (== FreezeColumnsRequest, or == 0 when no scrolling offset)    # imgui_internal.h:2648
    # ImGuiTableColumnIdx         RowCellDataCurrent;    /* original C++ signature */
    row_cell_data_current: ImGuiTableColumnIdx             # Index of current RowCellData[] entry in current row    # imgui_internal.h:2649
    # ImGuiTableDrawChannelIdx    DummyDrawChannel;    /* original C++ signature */
    dummy_draw_channel: ImGuiTableDrawChannelIdx           # Redirect non-visible columns here.    # imgui_internal.h:2650
    # ImGuiTableDrawChannelIdx    Bg2DrawChannelCurrent;    /* original C++ signature */
    bg2_draw_channel_current: ImGuiTableDrawChannelIdx     # For Selectable() and other widgets drawing across columns after the freezing line. Index within DrawSplitter.Channels[]    # imgui_internal.h:2651
    # ImGuiTableDrawChannelIdx    Bg2DrawChannelUnfrozen;    /* original C++ signature */
    bg2_draw_channel_unfrozen: ImGuiTableDrawChannelIdx    # imgui_internal.h:2652
    # bool                        IsLayoutLocked;    /* original C++ signature */
    is_layout_locked: bool                                 # Set by TableUpdateLayout() which is called when beginning the first row.    # imgui_internal.h:2653
    # bool                        IsInsideRow;    /* original C++ signature */
    is_inside_row: bool                                    # Set when inside TableBeginRow()/TableEndRow().    # imgui_internal.h:2654
    # bool                        IsInitializing;    /* original C++ signature */
    is_initializing: bool                                  # imgui_internal.h:2655
    # bool                        IsSortSpecsDirty;    /* original C++ signature */
    is_sort_specs_dirty: bool                              # imgui_internal.h:2656
    # bool                        IsUsingHeaders;    /* original C++ signature */
    is_using_headers: bool                                 # Set when the first row had the ImGuiTableRowFlags_Headers flag.    # imgui_internal.h:2657
    # bool                        IsContextPopupOpen;    /* original C++ signature */
    is_context_popup_open: bool                            # Set when default context menu is open (also see: ContextPopupColumn, InstanceInteracted).    # imgui_internal.h:2658
    # bool                        IsSettingsRequestLoad;    /* original C++ signature */
    is_settings_request_load: bool                         # imgui_internal.h:2659
    # bool                        IsSettingsDirty;    /* original C++ signature */
    is_settings_dirty: bool                                # Set when table settings have changed and needs to be reported into ImGuiTableSetttings data.    # imgui_internal.h:2660
    # bool                        IsDefaultDisplayOrder;    /* original C++ signature */
    is_default_display_order: bool                         # Set when display order is unchanged from default (DisplayOrder contains 0...Count-1)    # imgui_internal.h:2661
    # bool                        IsResetAllRequest;    /* original C++ signature */
    is_reset_all_request: bool                             # imgui_internal.h:2662
    # bool                        IsResetDisplayOrderRequest;    /* original C++ signature */
    is_reset_display_order_request: bool                   # imgui_internal.h:2663
    # bool                        IsUnfrozenRows;    /* original C++ signature */
    is_unfrozen_rows: bool                                 # Set when we got past the frozen row.    # imgui_internal.h:2664
    # bool                        IsDefaultSizingPolicy;    /* original C++ signature */
    is_default_sizing_policy: bool                         # Set if user didn't explicitly set a sizing policy in BeginTable()    # imgui_internal.h:2665
    # bool                        MemoryCompacted;    /* original C++ signature */
    memory_compacted: bool                                 # imgui_internal.h:2666
    # bool                        HostSkipItems;    /* original C++ signature */
    host_skip_items: bool                                  # Backup of InnerWindow->SkipItem at the end of BeginTable(), because we will overwrite InnerWindow->SkipItem on a per-column basis    # imgui_internal.h:2667

    # ImGuiTable()                { memset(this, 0, sizeof(*this)); LastFrameActive = -1; }    /* original C++ signature */
    def __init__(self) -> None:                            # imgui_internal.h:2669
        pass

class ImGuiTableTempData:    # imgui_internal.h:2676
    """ Transient data that are only needed between BeginTable() and EndTable(), those buffers are shared (1 per level of stacked table).
     - Accessing those requires chasing an extra pointer so for very frequently used data we leave them in the main table structure.
     - We also leave out of this structure data that tend to be particularly useful for debugging/metrics.
    """
    # int                         TableIndex;    /* original C++ signature */
    table_index: int                        # Index in g.Tables.Buf[] pool    # imgui_internal.h:2678
    # float                       LastTimeActive;    /* original C++ signature */
    last_time_active: float                 # Last timestamp this structure was used    # imgui_internal.h:2679

    # ImVec2                      UserOuterSize;    /* original C++ signature */
    user_outer_size: ImVec2                 # outer_size.x passed to BeginTable()    # imgui_internal.h:2681
    # ImDrawListSplitter          DrawSplitter;    /* original C++ signature */
    draw_splitter: ImDrawListSplitter       # imgui_internal.h:2682

    # ImRect                      HostBackupWorkRect;    /* original C++ signature */
    host_backup_work_rect: ImRect           # Backup of InnerWindow->WorkRect at the end of BeginTable()    # imgui_internal.h:2684
    # ImRect                      HostBackupParentWorkRect;    /* original C++ signature */
    host_backup_parent_work_rect: ImRect    # Backup of InnerWindow->ParentWorkRect at the end of BeginTable()    # imgui_internal.h:2685
    # ImVec2                      HostBackupPrevLineSize;    /* original C++ signature */
    host_backup_prev_line_size: ImVec2      # Backup of InnerWindow->DC.PrevLineSize at the end of BeginTable()    # imgui_internal.h:2686
    # ImVec2                      HostBackupCurrLineSize;    /* original C++ signature */
    host_backup_curr_line_size: ImVec2      # Backup of InnerWindow->DC.CurrLineSize at the end of BeginTable()    # imgui_internal.h:2687
    # ImVec2                      HostBackupCursorMaxPos;    /* original C++ signature */
    host_backup_cursor_max_pos: ImVec2      # Backup of InnerWindow->DC.CursorMaxPos at the end of BeginTable()    # imgui_internal.h:2688
    # ImVec1                      HostBackupColumnsOffset;    /* original C++ signature */
    host_backup_columns_offset: ImVec1      # Backup of OuterWindow->DC.ColumnsOffset at the end of BeginTable()    # imgui_internal.h:2689
    # float                       HostBackupItemWidth;    /* original C++ signature */
    host_backup_item_width: float           # Backup of OuterWindow->DC.ItemWidth at the end of BeginTable()    # imgui_internal.h:2690
    # int                         HostBackupItemWidthStackSize;    /* original C++ signature */
    host_backup_item_width_stack_size: int  #Backup of OuterWindow->DC.ItemWidthStack.Size at the end of BeginTable()    # imgui_internal.h:2691

    # ImGuiTableTempData()        { memset(this, 0, sizeof(*this)); LastTimeActive = -1.0f; }    /* original C++ signature */
    def __init__(self) -> None:             # imgui_internal.h:2693
        pass

class ImGuiTableColumnSettings:    # imgui_internal.h:2697
    """ sizeof() ~ 12"""
    # float                   WidthOrWeight;    /* original C++ signature */
    width_or_weight: float                # imgui_internal.h:2699
    # ImGuiID                 UserID;    /* original C++ signature */
    user_id: ImGuiID                      # imgui_internal.h:2700
    # ImGuiTableColumnIdx     Index;    /* original C++ signature */
    index: ImGuiTableColumnIdx            # imgui_internal.h:2701
    # ImGuiTableColumnIdx     DisplayOrder;    /* original C++ signature */
    display_order: ImGuiTableColumnIdx    # imgui_internal.h:2702
    # ImGuiTableColumnIdx     SortOrder;    /* original C++ signature */
    sort_order: ImGuiTableColumnIdx       # imgui_internal.h:2703

    # ImGuiTableColumnSettings()    /* original C++ signature */
    #     {
    #         WidthOrWeight = 0.0f;
    #         UserID = 0;
    #         Index = -1;
    #         DisplayOrder = SortOrder = -1;
    #         SortDirection = ImGuiSortDirection_None;
    #         IsEnabled = 1;
    #         IsStretch = 0;
    #     }
    def __init__(self) -> None:           # imgui_internal.h:2708
        pass

class ImGuiTableSettings:    # imgui_internal.h:2721
    """ This is designed to be stored in a single ImChunkStream (1 header followed by N ImGuiTableColumnSettings, etc.)"""
    # ImGuiID                     ID;    /* original C++ signature */
    id: ImGuiID                             # Set to 0 to invalidate/delete the setting    # imgui_internal.h:2723
    # ImGuiTableFlags             SaveFlags;    /* original C++ signature */
    save_flags: ImGuiTableFlags             # Indicate data we want to save using the Resizable/Reorderable/Sortable/Hideable flags (could be using its own flags..)    # imgui_internal.h:2724
    # float                       RefScale;    /* original C++ signature */
    ref_scale: float                        # Reference scale to be able to rescale columns on font/dpi changes.    # imgui_internal.h:2725
    # ImGuiTableColumnIdx         ColumnsCount;    /* original C++ signature */
    columns_count: ImGuiTableColumnIdx      # imgui_internal.h:2726
    # ImGuiTableColumnIdx         ColumnsCountMax;    /* original C++ signature */
    columns_count_max: ImGuiTableColumnIdx  # Maximum number of columns this settings instance can store, we can recycle a settings instance with lower number of columns but not higher    # imgui_internal.h:2727
    # bool                        WantApply;    /* original C++ signature */
    want_apply: bool                        # Set when loaded from .ini data (to enable merging/loading .ini data into an already running context)    # imgui_internal.h:2728

    # ImGuiTableSettings()        { memset(this, 0, sizeof(*this)); }    /* original C++ signature */
    def __init__(self) -> None:             # imgui_internal.h:2730
        pass

#-----------------------------------------------------------------------------
# [SECTION] ImGui internal API
# No guarantee of forward compatibility here!
#-----------------------------------------------------------------------------

""" namespace ImGui"""
# Windows
# We should always have a CurrentWindow in the stack (there is an implicit "Debug" window)
# If this ever crash because g.CurrentWindow is None it means that either
# - ImGui::NewFrame() has never been called, which is illegal.
# - You are calling ImGui functions after ImGui::EndFrame()/ImGui::Render() and before the next ImGui::NewFrame(), which is also illegal.
# IMGUI_API ImGuiWindow*  FindWindowByID(ImGuiID id);    /* original C++ signature */
def find_window_by_id(id: ImGuiID) -> ImGuiWindow:    # imgui_internal.h:2748
    pass
# IMGUI_API ImGuiWindow*  FindWindowByName(const char* name);    /* original C++ signature */
def find_window_by_name(name: str) -> ImGuiWindow:    # imgui_internal.h:2749
    pass
# IMGUI_API void          UpdateWindowParentAndRootLinks(ImGuiWindow* window, ImGuiWindowFlags flags, ImGuiWindow* parent_window);    /* original C++ signature */
def update_window_parent_and_root_links(window: ImGuiWindow, flags: ImGuiWindowFlags, parent_window: ImGuiWindow) -> None:    # imgui_internal.h:2750
    pass
# IMGUI_API ImVec2        CalcWindowNextAutoFitSize(ImGuiWindow* window);    /* original C++ signature */
def calc_window_next_auto_fit_size(window: ImGuiWindow) -> ImVec2:    # imgui_internal.h:2751
    pass
# IMGUI_API bool          IsWindowChildOf(ImGuiWindow* window, ImGuiWindow* potential_parent, bool popup_hierarchy, bool dock_hierarchy);    /* original C++ signature */
def is_window_child_of(window: ImGuiWindow, potential_parent: ImGuiWindow, popup_hierarchy: bool, dock_hierarchy: bool) -> bool:    # imgui_internal.h:2752
    pass
# IMGUI_API bool          IsWindowWithinBeginStackOf(ImGuiWindow* window, ImGuiWindow* potential_parent);    /* original C++ signature */
def is_window_within_begin_stack_of(window: ImGuiWindow, potential_parent: ImGuiWindow) -> bool:    # imgui_internal.h:2753
    pass
# IMGUI_API bool          IsWindowAbove(ImGuiWindow* potential_above, ImGuiWindow* potential_below);    /* original C++ signature */
def is_window_above(potential_above: ImGuiWindow, potential_below: ImGuiWindow) -> bool:    # imgui_internal.h:2754
    pass
# IMGUI_API bool          IsWindowNavFocusable(ImGuiWindow* window);    /* original C++ signature */
def is_window_nav_focusable(window: ImGuiWindow) -> bool:    # imgui_internal.h:2755
    pass
# IMGUI_API void          SetWindowPos(ImGuiWindow* window, const ImVec2& pos, ImGuiCond cond = 0);    /* original C++ signature */
def set_window_pos(window: ImGuiWindow, pos: ImVec2, cond: ImGuiCond = 0) -> None:    # imgui_internal.h:2756
    pass
# IMGUI_API void          SetWindowSize(ImGuiWindow* window, const ImVec2& size, ImGuiCond cond = 0);    /* original C++ signature */
def set_window_size(window: ImGuiWindow, size: ImVec2, cond: ImGuiCond = 0) -> None:    # imgui_internal.h:2757
    pass
# IMGUI_API void          SetWindowCollapsed(ImGuiWindow* window, bool collapsed, ImGuiCond cond = 0);    /* original C++ signature */
def set_window_collapsed(window: ImGuiWindow, collapsed: bool, cond: ImGuiCond = 0) -> None:    # imgui_internal.h:2758
    pass
# IMGUI_API void          SetWindowHitTestHole(ImGuiWindow* window, const ImVec2& pos, const ImVec2& size);    /* original C++ signature */
def set_window_hit_test_hole(window: ImGuiWindow, pos: ImVec2, size: ImVec2) -> None:    # imgui_internal.h:2759
    pass

# Windows: Display Order and Focus Order
# IMGUI_API void          FocusWindow(ImGuiWindow* window);    /* original C++ signature */
def focus_window(window: ImGuiWindow) -> None:    # imgui_internal.h:2764
    pass
# IMGUI_API void          FocusTopMostWindowUnderOne(ImGuiWindow* under_this_window, ImGuiWindow* ignore_window);    /* original C++ signature */
def focus_top_most_window_under_one(under_this_window: ImGuiWindow, ignore_window: ImGuiWindow) -> None:    # imgui_internal.h:2765
    pass
# IMGUI_API void          BringWindowToFocusFront(ImGuiWindow* window);    /* original C++ signature */
def bring_window_to_focus_front(window: ImGuiWindow) -> None:    # imgui_internal.h:2766
    pass
# IMGUI_API void          BringWindowToDisplayFront(ImGuiWindow* window);    /* original C++ signature */
def bring_window_to_display_front(window: ImGuiWindow) -> None:    # imgui_internal.h:2767
    pass
# IMGUI_API void          BringWindowToDisplayBack(ImGuiWindow* window);    /* original C++ signature */
def bring_window_to_display_back(window: ImGuiWindow) -> None:    # imgui_internal.h:2768
    pass
# IMGUI_API void          BringWindowToDisplayBehind(ImGuiWindow* window, ImGuiWindow* above_window);    /* original C++ signature */
def bring_window_to_display_behind(window: ImGuiWindow, above_window: ImGuiWindow) -> None:    # imgui_internal.h:2769
    pass
# IMGUI_API int           FindWindowDisplayIndex(ImGuiWindow* window);    /* original C++ signature */
def find_window_display_index(window: ImGuiWindow) -> int:    # imgui_internal.h:2770
    pass
# IMGUI_API ImGuiWindow*  FindBottomMostVisibleWindowWithinBeginStack(ImGuiWindow* window);    /* original C++ signature */
def find_bottom_most_visible_window_within_begin_stack(window: ImGuiWindow) -> ImGuiWindow:    # imgui_internal.h:2771
    pass

# IMGUI_API void          SetCurrentFont(ImFont* font);    /* original C++ signature */
def set_current_font(font: ImFont) -> None:    # imgui_internal.h:2774
    """ Fonts, drawing"""
    pass

# Init
# IMGUI_API void          Initialize();    /* original C++ signature */
def initialize() -> None:    # imgui_internal.h:2779
    pass
# IMGUI_API void          Shutdown();        /* original C++ signature */
def shutdown() -> None:    # imgui_internal.h:2780
    """ Since 1.60 this is a _private_ function. You can call DestroyContext() to destroy the context created by CreateContext()."""
    pass

# NewFrame
# IMGUI_API void          UpdateInputEvents(bool trickle_fast_inputs);    /* original C++ signature */
def update_input_events(trickle_fast_inputs: bool) -> None:    # imgui_internal.h:2783
    pass
# IMGUI_API void          UpdateHoveredWindowAndCaptureFlags();    /* original C++ signature */
def update_hovered_window_and_capture_flags() -> None:    # imgui_internal.h:2784
    pass
# IMGUI_API void          StartMouseMovingWindow(ImGuiWindow* window);    /* original C++ signature */
def start_mouse_moving_window(window: ImGuiWindow) -> None:    # imgui_internal.h:2785
    pass
# IMGUI_API void          StartMouseMovingWindowOrNode(ImGuiWindow* window, ImGuiDockNode* node, bool undock_floating_node);    /* original C++ signature */
def start_mouse_moving_window_or_node(window: ImGuiWindow, node: ImGuiDockNode, undock_floating_node: bool) -> None:    # imgui_internal.h:2786
    pass
# IMGUI_API void          UpdateMouseMovingWindowNewFrame();    /* original C++ signature */
def update_mouse_moving_window_new_frame() -> None:    # imgui_internal.h:2787
    pass
# IMGUI_API void          UpdateMouseMovingWindowEndFrame();    /* original C++ signature */
def update_mouse_moving_window_end_frame() -> None:    # imgui_internal.h:2788
    pass

# Generic context hooks
# IMGUI_API ImGuiID       AddContextHook(ImGuiContext* context, const ImGuiContextHook* hook);    /* original C++ signature */
def add_context_hook(context: ImGuiContext, hook: ImGuiContextHook) -> ImGuiID:    # imgui_internal.h:2791
    pass
# IMGUI_API void          RemoveContextHook(ImGuiContext* context, ImGuiID hook_to_remove);    /* original C++ signature */
def remove_context_hook(context: ImGuiContext, hook_to_remove: ImGuiID) -> None:    # imgui_internal.h:2792
    pass
# IMGUI_API void          CallContextHooks(ImGuiContext* context, ImGuiContextHookType type);    /* original C++ signature */
def call_context_hooks(context: ImGuiContext, type: ImGuiContextHookType) -> None:    # imgui_internal.h:2793
    pass

# Viewports
# IMGUI_API void          TranslateWindowsInViewport(ImGuiViewportP* viewport, const ImVec2& old_pos, const ImVec2& new_pos);    /* original C++ signature */
def translate_windows_in_viewport(viewport: ImGuiViewportP, old_pos: ImVec2, new_pos: ImVec2) -> None:    # imgui_internal.h:2796
    pass
# IMGUI_API void          ScaleWindowsInViewport(ImGuiViewportP* viewport, float scale);    /* original C++ signature */
def scale_windows_in_viewport(viewport: ImGuiViewportP, scale: float) -> None:    # imgui_internal.h:2797
    pass
# IMGUI_API void          DestroyPlatformWindow(ImGuiViewportP* viewport);    /* original C++ signature */
def destroy_platform_window(viewport: ImGuiViewportP) -> None:    # imgui_internal.h:2798
    pass
# IMGUI_API void          SetWindowViewport(ImGuiWindow* window, ImGuiViewportP* viewport);    /* original C++ signature */
def set_window_viewport(window: ImGuiWindow, viewport: ImGuiViewportP) -> None:    # imgui_internal.h:2799
    pass
# IMGUI_API void          SetCurrentViewport(ImGuiWindow* window, ImGuiViewportP* viewport);    /* original C++ signature */
def set_current_viewport(window: ImGuiWindow, viewport: ImGuiViewportP) -> None:    # imgui_internal.h:2800
    pass
# IMGUI_API const ImGuiPlatformMonitor*   GetViewportPlatformMonitor(ImGuiViewport* viewport);    /* original C++ signature */
def get_viewport_platform_monitor(viewport: ImGuiViewport) -> ImGuiPlatformMonitor:    # imgui_internal.h:2801
    pass
# IMGUI_API ImGuiViewportP*               FindHoveredViewportFromPlatformWindowStack(const ImVec2& mouse_platform_pos);    /* original C++ signature */
def find_hovered_viewport_from_platform_window_stack(mouse_platform_pos: ImVec2) -> ImGuiViewportP:    # imgui_internal.h:2802
    pass

# Settings
# IMGUI_API void                  MarkIniSettingsDirty();    /* original C++ signature */
def mark_ini_settings_dirty() -> None:    # imgui_internal.h:2805
    pass
# IMGUI_API void                  MarkIniSettingsDirty(ImGuiWindow* window);    /* original C++ signature */
def mark_ini_settings_dirty(window: ImGuiWindow) -> None:    # imgui_internal.h:2806
    pass
# IMGUI_API void                  ClearIniSettings();    /* original C++ signature */
def clear_ini_settings() -> None:    # imgui_internal.h:2807
    pass
# IMGUI_API ImGuiWindowSettings*  CreateNewWindowSettings(const char* name);    /* original C++ signature */
def create_new_window_settings(name: str) -> ImGuiWindowSettings:    # imgui_internal.h:2808
    pass
# IMGUI_API ImGuiWindowSettings*  FindWindowSettings(ImGuiID id);    /* original C++ signature */
def find_window_settings(id: ImGuiID) -> ImGuiWindowSettings:    # imgui_internal.h:2809
    pass
# IMGUI_API ImGuiWindowSettings*  FindOrCreateWindowSettings(const char* name);    /* original C++ signature */
def find_or_create_window_settings(name: str) -> ImGuiWindowSettings:    # imgui_internal.h:2810
    pass
# IMGUI_API void                  AddSettingsHandler(const ImGuiSettingsHandler* handler);    /* original C++ signature */
def add_settings_handler(handler: ImGuiSettingsHandler) -> None:    # imgui_internal.h:2811
    pass
# IMGUI_API void                  RemoveSettingsHandler(const char* type_name);    /* original C++ signature */
def remove_settings_handler(type_name: str) -> None:    # imgui_internal.h:2812
    pass
# IMGUI_API ImGuiSettingsHandler* FindSettingsHandler(const char* type_name);    /* original C++ signature */
def find_settings_handler(type_name: str) -> ImGuiSettingsHandler:    # imgui_internal.h:2813
    pass

# Scrolling
# IMGUI_API void          SetNextWindowScroll(const ImVec2& scroll);     /* original C++ signature */
def set_next_window_scroll(scroll: ImVec2) -> None:    # imgui_internal.h:2816
    """ Use -1.0 on one axis to leave as-is"""
    pass
# IMGUI_API void          SetScrollX(ImGuiWindow* window, float scroll_x);    /* original C++ signature */
def set_scroll_x(window: ImGuiWindow, scroll_x: float) -> None:    # imgui_internal.h:2817
    pass
# IMGUI_API void          SetScrollY(ImGuiWindow* window, float scroll_y);    /* original C++ signature */
def set_scroll_y(window: ImGuiWindow, scroll_y: float) -> None:    # imgui_internal.h:2818
    pass
# IMGUI_API void          SetScrollFromPosX(ImGuiWindow* window, float local_x, float center_x_ratio);    /* original C++ signature */
def set_scroll_from_pos_x(window: ImGuiWindow, local_x: float, center_x_ratio: float) -> None:    # imgui_internal.h:2819
    pass
# IMGUI_API void          SetScrollFromPosY(ImGuiWindow* window, float local_y, float center_y_ratio);    /* original C++ signature */
def set_scroll_from_pos_y(window: ImGuiWindow, local_y: float, center_y_ratio: float) -> None:    # imgui_internal.h:2820
    pass

# Early work-in-progress API (ScrollToItem() will become public)
# IMGUI_API void          ScrollToItem(ImGuiScrollFlags flags = 0);    /* original C++ signature */
def scroll_to_item(flags: ImGuiScrollFlags = 0) -> None:    # imgui_internal.h:2823
    pass
# IMGUI_API void          ScrollToRect(ImGuiWindow* window, const ImRect& rect, ImGuiScrollFlags flags = 0);    /* original C++ signature */
def scroll_to_rect(window: ImGuiWindow, rect: ImRect, flags: ImGuiScrollFlags = 0) -> None:    # imgui_internal.h:2824
    pass
# IMGUI_API ImVec2        ScrollToRectEx(ImGuiWindow* window, const ImRect& rect, ImGuiScrollFlags flags = 0);    /* original C++ signature */
def scroll_to_rect_ex(window: ImGuiWindow, rect: ImRect, flags: ImGuiScrollFlags = 0) -> ImVec2:    # imgui_internal.h:2825
    pass
##endif

# Basic Accessors
# IMGUI_API void          SetActiveID(ImGuiID id, ImGuiWindow* window);    /* original C++ signature */
def set_active_id(id: ImGuiID, window: ImGuiWindow) -> None:    # imgui_internal.h:2836
    pass
# IMGUI_API void          SetFocusID(ImGuiID id, ImGuiWindow* window);    /* original C++ signature */
def set_focus_id(id: ImGuiID, window: ImGuiWindow) -> None:    # imgui_internal.h:2837
    pass
# IMGUI_API void          ClearActiveID();    /* original C++ signature */
def clear_active_id() -> None:    # imgui_internal.h:2838
    pass
# IMGUI_API ImGuiID       GetHoveredID();    /* original C++ signature */
def get_hovered_id() -> ImGuiID:    # imgui_internal.h:2839
    pass
# IMGUI_API void          SetHoveredID(ImGuiID id);    /* original C++ signature */
def set_hovered_id(id: ImGuiID) -> None:    # imgui_internal.h:2840
    pass
# IMGUI_API void          KeepAliveID(ImGuiID id);    /* original C++ signature */
def keep_alive_id(id: ImGuiID) -> None:    # imgui_internal.h:2841
    pass
# IMGUI_API void          MarkItemEdited(ImGuiID id);         /* original C++ signature */
def mark_item_edited(id: ImGuiID) -> None:    # imgui_internal.h:2842
    """ Mark data associated to given item as "edited", used by IsItemDeactivatedAfterEdit() function."""
    pass
# IMGUI_API void          PushOverrideID(ImGuiID id);         /* original C++ signature */
def push_override_id(id: ImGuiID) -> None:    # imgui_internal.h:2843
    """ Push given value as-is at the top of the ID stack (whereas PushID combines old and new hashes)"""
    pass
# IMGUI_API ImGuiID       GetIDWithSeed(const char* str_id_begin, const char* str_id_end, ImGuiID seed);    /* original C++ signature */
def get_id_with_seed(str_id_begin: str, str_id_end: str, seed: ImGuiID) -> ImGuiID:    # imgui_internal.h:2844
    pass

# IMGUI_API void          ItemSize(const ImVec2& size, float text_baseline_y = -1.0f);    /* original C++ signature */
def item_size(size: ImVec2, text_baseline_y: float = -1.0) -> None:    # imgui_internal.h:2847
    """ Basic Helpers for widget code"""
    pass
# IMGUI_API bool          ItemAdd(const ImRect& bb, ImGuiID id, const ImRect* nav_bb = NULL, ImGuiItemFlags extra_flags = 0);    /* original C++ signature */
def item_add(bb: ImRect, id: ImGuiID, nav_bb: ImRect = None, extra_flags: ImGuiItemFlags = 0) -> bool:    # imgui_internal.h:2849
    pass
# IMGUI_API bool          ItemHoverable(const ImRect& bb, ImGuiID id);    /* original C++ signature */
def item_hoverable(bb: ImRect, id: ImGuiID) -> bool:    # imgui_internal.h:2850
    pass
# IMGUI_API bool          IsClippedEx(const ImRect& bb, ImGuiID id);    /* original C++ signature */
def is_clipped_ex(bb: ImRect, id: ImGuiID) -> bool:    # imgui_internal.h:2851
    pass
# IMGUI_API void          SetLastItemData(ImGuiID item_id, ImGuiItemFlags in_flags, ImGuiItemStatusFlags status_flags, const ImRect& item_rect);    /* original C++ signature */
def set_last_item_data(item_id: ImGuiID, in_flags: ImGuiItemFlags, status_flags: ImGuiItemStatusFlags, item_rect: ImRect) -> None:    # imgui_internal.h:2852
    pass
# IMGUI_API ImVec2        CalcItemSize(ImVec2 size, float default_w, float default_h);    /* original C++ signature */
def calc_item_size(size: ImVec2, default_w: float, default_h: float) -> ImVec2:    # imgui_internal.h:2853
    pass
# IMGUI_API float         CalcWrapWidthForPos(const ImVec2& pos, float wrap_pos_x);    /* original C++ signature */
def calc_wrap_width_for_pos(pos: ImVec2, wrap_pos_x: float) -> float:    # imgui_internal.h:2854
    pass
# IMGUI_API void          PushMultiItemsWidths(int components, float width_full);    /* original C++ signature */
def push_multi_items_widths(components: int, width_full: float) -> None:    # imgui_internal.h:2855
    pass
# IMGUI_API bool          IsItemToggledSelection();                                       /* original C++ signature */
def is_item_toggled_selection() -> bool:    # imgui_internal.h:2856
    """ Was the last item selection toggled? (after Selectable(), TreeNode() etc. We only returns toggle _event_ in order to handle clipping correctly)"""
    pass
# IMGUI_API ImVec2        GetContentRegionMaxAbs();    /* original C++ signature */
def get_content_region_max_abs() -> ImVec2:    # imgui_internal.h:2857
    pass
# IMGUI_API void          ShrinkWidths(ImGuiShrinkWidthItem* items, int count, float width_excess);    /* original C++ signature */
def shrink_widths(items: ImGuiShrinkWidthItem, count: int, width_excess: float) -> None:    # imgui_internal.h:2858
    pass

# Parameter stacks
# IMGUI_API void          PushItemFlag(ImGuiItemFlags option, bool enabled);    /* original C++ signature */
def push_item_flag(option: ImGuiItemFlags, enabled: bool) -> None:    # imgui_internal.h:2861
    pass
# IMGUI_API void          PopItemFlag();    /* original C++ signature */
def pop_item_flag() -> None:    # imgui_internal.h:2862
    pass


# Logging/Capture
# IMGUI_API void          LogBegin(ImGuiLogType type, int auto_open_depth);               /* original C++ signature */
def log_begin(type: ImGuiLogType, auto_open_depth: int) -> None:    # imgui_internal.h:2876
    """ -> BeginCapture() when we design v2 api, for now stay under the radar by using the old name."""
    pass
# IMGUI_API void          LogToBuffer(int auto_open_depth = -1);                          /* original C++ signature */
def log_to_buffer(auto_open_depth: int = -1) -> None:    # imgui_internal.h:2877
    """ Start logging/capturing to internal buffer"""
    pass
# IMGUI_API void          LogRenderedText(const ImVec2* ref_pos, const char* text, const char* text_end = NULL);    /* original C++ signature */
def log_rendered_text(ref_pos: ImVec2, text: str, text_end: str = None) -> None:    # imgui_internal.h:2878
    pass
# IMGUI_API void          LogSetNextTextDecoration(const char* prefix, const char* suffix);    /* original C++ signature */
def log_set_next_text_decoration(prefix: str, suffix: str) -> None:    # imgui_internal.h:2879
    pass

# Popups, Modals, Tooltips
# IMGUI_API bool          BeginChildEx(const char* name, ImGuiID id, const ImVec2& size_arg, bool border, ImGuiWindowFlags flags);    /* original C++ signature */
def begin_child_ex(name: str, id: ImGuiID, size_arg: ImVec2, border: bool, flags: ImGuiWindowFlags) -> bool:    # imgui_internal.h:2882
    pass
# IMGUI_API void          OpenPopupEx(ImGuiID id, ImGuiPopupFlags popup_flags = ImGuiPopupFlags_None);    /* original C++ signature */
def open_popup_ex(id: ImGuiID, popup_flags: ImGuiPopupFlags = ImGuiPopupFlags_.none) -> None:    # imgui_internal.h:2883
    pass
# IMGUI_API void          ClosePopupToLevel(int remaining, bool restore_focus_to_window_under_popup);    /* original C++ signature */
def close_popup_to_level(remaining: int, restore_focus_to_window_under_popup: bool) -> None:    # imgui_internal.h:2884
    pass
# IMGUI_API void          ClosePopupsOverWindow(ImGuiWindow* ref_window, bool restore_focus_to_window_under_popup);    /* original C++ signature */
def close_popups_over_window(ref_window: ImGuiWindow, restore_focus_to_window_under_popup: bool) -> None:    # imgui_internal.h:2885
    pass
# IMGUI_API void          ClosePopupsExceptModals();    /* original C++ signature */
def close_popups_except_modals() -> None:    # imgui_internal.h:2886
    pass
# IMGUI_API bool          IsPopupOpen(ImGuiID id, ImGuiPopupFlags popup_flags);    /* original C++ signature */
def is_popup_open(id: ImGuiID, popup_flags: ImGuiPopupFlags) -> bool:    # imgui_internal.h:2887
    pass
# IMGUI_API bool          BeginPopupEx(ImGuiID id, ImGuiWindowFlags extra_flags);    /* original C++ signature */
def begin_popup_ex(id: ImGuiID, extra_flags: ImGuiWindowFlags) -> bool:    # imgui_internal.h:2888
    pass
# IMGUI_API void          BeginTooltipEx(ImGuiTooltipFlags tooltip_flags, ImGuiWindowFlags extra_window_flags);    /* original C++ signature */
def begin_tooltip_ex(tooltip_flags: ImGuiTooltipFlags, extra_window_flags: ImGuiWindowFlags) -> None:    # imgui_internal.h:2889
    pass
# IMGUI_API ImRect        GetPopupAllowedExtentRect(ImGuiWindow* window);    /* original C++ signature */
def get_popup_allowed_extent_rect(window: ImGuiWindow) -> ImRect:    # imgui_internal.h:2890
    pass
# IMGUI_API ImGuiWindow*  GetTopMostPopupModal();    /* original C++ signature */
def get_top_most_popup_modal() -> ImGuiWindow:    # imgui_internal.h:2891
    pass
# IMGUI_API ImGuiWindow*  GetTopMostAndVisiblePopupModal();    /* original C++ signature */
def get_top_most_and_visible_popup_modal() -> ImGuiWindow:    # imgui_internal.h:2892
    pass
# IMGUI_API ImVec2        FindBestWindowPosForPopup(ImGuiWindow* window);    /* original C++ signature */
def find_best_window_pos_for_popup(window: ImGuiWindow) -> ImVec2:    # imgui_internal.h:2893
    pass
# IMGUI_API ImVec2        FindBestWindowPosForPopupEx(const ImVec2& ref_pos, const ImVec2& size, ImGuiDir* last_dir, const ImRect& r_outer, const ImRect& r_avoid, ImGuiPopupPositionPolicy policy);    /* original C++ signature */
def find_best_window_pos_for_popup_ex(ref_pos: ImVec2, size: ImVec2, last_dir: ImGuiDir, r_outer: ImRect, r_avoid: ImRect, policy: ImGuiPopupPositionPolicy) -> ImVec2:    # imgui_internal.h:2894
    pass

# Menus
# IMGUI_API bool          BeginViewportSideBar(const char* name, ImGuiViewport* viewport, ImGuiDir dir, float size, ImGuiWindowFlags window_flags);    /* original C++ signature */
def begin_viewport_side_bar(name: str, viewport: ImGuiViewport, dir: ImGuiDir, size: float, window_flags: ImGuiWindowFlags) -> bool:    # imgui_internal.h:2897
    pass
# IMGUI_API bool          BeginMenuEx(const char* label, const char* icon, bool enabled = true);    /* original C++ signature */
def begin_menu_ex(label: str, icon: str, enabled: bool = True) -> bool:    # imgui_internal.h:2898
    pass
# IMGUI_API bool          MenuItemEx(const char* label, const char* icon, const char* shortcut = NULL, bool selected = false, bool enabled = true);    /* original C++ signature */
def menu_item_ex(label: str, icon: str, shortcut: str = None, selected: bool = False, enabled: bool = True) -> bool:    # imgui_internal.h:2899
    pass

# Combos
# IMGUI_API bool          BeginComboPopup(ImGuiID popup_id, const ImRect& bb, ImGuiComboFlags flags);    /* original C++ signature */
def begin_combo_popup(popup_id: ImGuiID, bb: ImRect, flags: ImGuiComboFlags) -> bool:    # imgui_internal.h:2902
    pass
# IMGUI_API bool          BeginComboPreview();    /* original C++ signature */
def begin_combo_preview() -> bool:    # imgui_internal.h:2903
    pass
# IMGUI_API void          EndComboPreview();    /* original C++ signature */
def end_combo_preview() -> None:    # imgui_internal.h:2904
    pass

# Gamepad/Keyboard Navigation
# IMGUI_API void          NavInitWindow(ImGuiWindow* window, bool force_reinit);    /* original C++ signature */
def nav_init_window(window: ImGuiWindow, force_reinit: bool) -> None:    # imgui_internal.h:2907
    pass
# IMGUI_API void          NavInitRequestApplyResult();    /* original C++ signature */
def nav_init_request_apply_result() -> None:    # imgui_internal.h:2908
    pass
# IMGUI_API bool          NavMoveRequestButNoResultYet();    /* original C++ signature */
def nav_move_request_but_no_result_yet() -> bool:    # imgui_internal.h:2909
    pass
# IMGUI_API void          NavMoveRequestSubmit(ImGuiDir move_dir, ImGuiDir clip_dir, ImGuiNavMoveFlags move_flags, ImGuiScrollFlags scroll_flags);    /* original C++ signature */
def nav_move_request_submit(move_dir: ImGuiDir, clip_dir: ImGuiDir, move_flags: ImGuiNavMoveFlags, scroll_flags: ImGuiScrollFlags) -> None:    # imgui_internal.h:2910
    pass
# IMGUI_API void          NavMoveRequestForward(ImGuiDir move_dir, ImGuiDir clip_dir, ImGuiNavMoveFlags move_flags, ImGuiScrollFlags scroll_flags);    /* original C++ signature */
def nav_move_request_forward(move_dir: ImGuiDir, clip_dir: ImGuiDir, move_flags: ImGuiNavMoveFlags, scroll_flags: ImGuiScrollFlags) -> None:    # imgui_internal.h:2911
    pass
# IMGUI_API void          NavMoveRequestResolveWithLastItem(ImGuiNavItemData* result);    /* original C++ signature */
def nav_move_request_resolve_with_last_item(result: ImGuiNavItemData) -> None:    # imgui_internal.h:2912
    pass
# IMGUI_API void          NavMoveRequestCancel();    /* original C++ signature */
def nav_move_request_cancel() -> None:    # imgui_internal.h:2913
    pass
# IMGUI_API void          NavMoveRequestApplyResult();    /* original C++ signature */
def nav_move_request_apply_result() -> None:    # imgui_internal.h:2914
    pass
# IMGUI_API void          NavMoveRequestTryWrapping(ImGuiWindow* window, ImGuiNavMoveFlags move_flags);    /* original C++ signature */
def nav_move_request_try_wrapping(window: ImGuiWindow, move_flags: ImGuiNavMoveFlags) -> None:    # imgui_internal.h:2915
    pass
# IMGUI_API const char*   GetNavInputName(ImGuiNavInput n);    /* original C++ signature */
def get_nav_input_name(n: ImGuiNavInput) -> str:    # imgui_internal.h:2916
    pass
# IMGUI_API float         GetNavInputAmount(ImGuiNavInput n, ImGuiNavReadMode mode);    /* original C++ signature */
def get_nav_input_amount(n: ImGuiNavInput, mode: ImGuiNavReadMode) -> float:    # imgui_internal.h:2917
    pass
# IMGUI_API ImVec2        GetNavInputAmount2d(ImGuiNavDirSourceFlags dir_sources, ImGuiNavReadMode mode, float slow_factor = 0.0f, float fast_factor = 0.0f);    /* original C++ signature */
def get_nav_input_amount2d(dir_sources: ImGuiNavDirSourceFlags, mode: ImGuiNavReadMode, slow_factor: float = 0.0, fast_factor: float = 0.0) -> ImVec2:    # imgui_internal.h:2918
    pass
# IMGUI_API int           CalcTypematicRepeatAmount(float t0, float t1, float repeat_delay, float repeat_rate);    /* original C++ signature */
def calc_typematic_repeat_amount(t0: float, t1: float, repeat_delay: float, repeat_rate: float) -> int:    # imgui_internal.h:2919
    pass
# IMGUI_API void          ActivateItem(ImGuiID id);       /* original C++ signature */
def activate_item(id: ImGuiID) -> None:    # imgui_internal.h:2920
    """ Remotely activate a button, checkbox, tree node etc. given its unique ID. activation is queued and processed on the next frame when the item is encountered again."""
    pass
# IMGUI_API void          SetNavWindow(ImGuiWindow* window);    /* original C++ signature */
def set_nav_window(window: ImGuiWindow) -> None:    # imgui_internal.h:2921
    pass
# IMGUI_API void          SetNavID(ImGuiID id, ImGuiNavLayer nav_layer, ImGuiID focus_scope_id, const ImRect& rect_rel);    /* original C++ signature */
def set_nav_id(id: ImGuiID, nav_layer: ImGuiNavLayer, focus_scope_id: ImGuiID, rect_rel: ImRect) -> None:    # imgui_internal.h:2922
    pass

# Focus Scope (WIP)
# This is generally used to identify a selection set (multiple of which may be in the same window), as selection
# patterns generally need to react (e.g. clear selection) when landing on an item of the set.
# IMGUI_API void          PushFocusScope(ImGuiID id);    /* original C++ signature */
def push_focus_scope(id: ImGuiID) -> None:    # imgui_internal.h:2927
    pass
# IMGUI_API void          PopFocusScope();    /* original C++ signature */
def pop_focus_scope() -> None:    # imgui_internal.h:2928
    pass

# Inputs
# FIXME: Eventually we should aim to move e.g. IsActiveIdUsingKey() into IsKeyXXX functions.
# IMGUI_API ImGuiKeyData* GetKeyData(ImGuiKey key);    /* original C++ signature */
def get_key_data(key: ImGuiKey) -> ImGuiKeyData:    # imgui_internal.h:2937
    pass
# IMGUI_API void          SetItemUsingMouseWheel();    /* original C++ signature */
def set_item_using_mouse_wheel() -> None:    # imgui_internal.h:2938
    pass
# IMGUI_API void          SetActiveIdUsingNavAndKeys();    /* original C++ signature */
def set_active_id_using_nav_and_keys() -> None:    # imgui_internal.h:2939
    pass
# IMGUI_API bool          IsMouseDragPastThreshold(ImGuiMouseButton button, float lock_threshold = -1.0f);    /* original C++ signature */
def is_mouse_drag_past_threshold(button: ImGuiMouseButton, lock_threshold: float = -1.0) -> bool:    # imgui_internal.h:2944
    pass
# IMGUI_API ImGuiModFlags GetMergedModFlags();    /* original C++ signature */
def get_merged_mod_flags() -> ImGuiModFlags:    # imgui_internal.h:2947
    pass

# Docking
# (some functions are only declared in imgui.cpp, see Docking section)
# IMGUI_API void          DockContextInitialize(ImGuiContext* ctx);    /* original C++ signature */
def dock_context_initialize(ctx: ImGuiContext) -> None:    # imgui_internal.h:2954
    pass
# IMGUI_API void          DockContextShutdown(ImGuiContext* ctx);    /* original C++ signature */
def dock_context_shutdown(ctx: ImGuiContext) -> None:    # imgui_internal.h:2955
    pass
# IMGUI_API void          DockContextClearNodes(ImGuiContext* ctx, ImGuiID root_id, bool clear_settings_refs);     /* original C++ signature */
def dock_context_clear_nodes(ctx: ImGuiContext, root_id: ImGuiID, clear_settings_refs: bool) -> None:    # imgui_internal.h:2956
    """ Use root_id==0 to clear all"""
    pass
# IMGUI_API void          DockContextRebuildNodes(ImGuiContext* ctx);    /* original C++ signature */
def dock_context_rebuild_nodes(ctx: ImGuiContext) -> None:    # imgui_internal.h:2957
    pass
# IMGUI_API void          DockContextNewFrameUpdateUndocking(ImGuiContext* ctx);    /* original C++ signature */
def dock_context_new_frame_update_undocking(ctx: ImGuiContext) -> None:    # imgui_internal.h:2958
    pass
# IMGUI_API void          DockContextNewFrameUpdateDocking(ImGuiContext* ctx);    /* original C++ signature */
def dock_context_new_frame_update_docking(ctx: ImGuiContext) -> None:    # imgui_internal.h:2959
    pass
# IMGUI_API void          DockContextEndFrame(ImGuiContext* ctx);    /* original C++ signature */
def dock_context_end_frame(ctx: ImGuiContext) -> None:    # imgui_internal.h:2960
    pass
# IMGUI_API ImGuiID       DockContextGenNodeID(ImGuiContext* ctx);    /* original C++ signature */
def dock_context_gen_node_id(ctx: ImGuiContext) -> ImGuiID:    # imgui_internal.h:2961
    pass
# IMGUI_API void          DockContextQueueDock(ImGuiContext* ctx, ImGuiWindow* target, ImGuiDockNode* target_node, ImGuiWindow* payload, ImGuiDir split_dir, float split_ratio, bool split_outer);    /* original C++ signature */
def dock_context_queue_dock(ctx: ImGuiContext, target: ImGuiWindow, target_node: ImGuiDockNode, payload: ImGuiWindow, split_dir: ImGuiDir, split_ratio: float, split_outer: bool) -> None:    # imgui_internal.h:2962
    pass
# IMGUI_API void          DockContextQueueUndockWindow(ImGuiContext* ctx, ImGuiWindow* window);    /* original C++ signature */
def dock_context_queue_undock_window(ctx: ImGuiContext, window: ImGuiWindow) -> None:    # imgui_internal.h:2963
    pass
# IMGUI_API void          DockContextQueueUndockNode(ImGuiContext* ctx, ImGuiDockNode* node);    /* original C++ signature */
def dock_context_queue_undock_node(ctx: ImGuiContext, node: ImGuiDockNode) -> None:    # imgui_internal.h:2964
    pass
# IMGUI_API bool          DockContextCalcDropPosForDocking(ImGuiWindow* target, ImGuiDockNode* target_node, ImGuiWindow* payload, ImGuiDir split_dir, bool split_outer, ImVec2* out_pos);    /* original C++ signature */
def dock_context_calc_drop_pos_for_docking(target: ImGuiWindow, target_node: ImGuiDockNode, payload: ImGuiWindow, split_dir: ImGuiDir, split_outer: bool, out_pos: ImVec2) -> bool:    # imgui_internal.h:2965
    pass
# IMGUI_API bool          DockNodeBeginAmendTabBar(ImGuiDockNode* node);    /* original C++ signature */
def dock_node_begin_amend_tab_bar(node: ImGuiDockNode) -> bool:    # imgui_internal.h:2966
    pass
# IMGUI_API void          DockNodeEndAmendTabBar();    /* original C++ signature */
def dock_node_end_amend_tab_bar() -> None:    # imgui_internal.h:2967
    pass
# IMGUI_API bool          GetWindowAlwaysWantOwnTabBar(ImGuiWindow* window);    /* original C++ signature */
def get_window_always_want_own_tab_bar(window: ImGuiWindow) -> bool:    # imgui_internal.h:2973
    pass
# IMGUI_API void          BeginDocked(ImGuiWindow* window, bool* p_open);    /* original C++ signature */
def begin_docked(window: ImGuiWindow, p_open: bool) -> bool:    # imgui_internal.h:2974
    pass
# IMGUI_API void          BeginDockableDragDropSource(ImGuiWindow* window);    /* original C++ signature */
def begin_dockable_drag_drop_source(window: ImGuiWindow) -> None:    # imgui_internal.h:2975
    pass
# IMGUI_API void          BeginDockableDragDropTarget(ImGuiWindow* window);    /* original C++ signature */
def begin_dockable_drag_drop_target(window: ImGuiWindow) -> None:    # imgui_internal.h:2976
    pass
# IMGUI_API void          SetWindowDock(ImGuiWindow* window, ImGuiID dock_id, ImGuiCond cond);    /* original C++ signature */
def set_window_dock(window: ImGuiWindow, dock_id: ImGuiID, cond: ImGuiCond) -> None:    # imgui_internal.h:2977
    pass

# Docking - Builder function needs to be generally called before the node is used/submitted.
# - The DockBuilderXXX functions are designed to _eventually_ become a public API, but it is too early to expose it and guarantee stability.
# - Do not hold on ImGuiDockNode* pointers! They may be invalidated by any split/merge/remove operation and every frame.
# - To create a DockSpace() node, make sure to set the ImGuiDockNodeFlags_DockSpace flag when calling DockBuilderAddNode().
#   You can create dockspace nodes (attached to a window) _or_ floating nodes (carry its own window) with this API.
# - DockBuilderSplitNode() create 2 child nodes within 1 node. The initial node becomes a parent node.
# - If you intend to split the node immediately after creation using DockBuilderSplitNode(), make sure
#   to call DockBuilderSetNodeSize() beforehand. If you don't, the resulting split sizes may not be reliable.
# - Call DockBuilderFinish() after you are done.
# IMGUI_API void          DockBuilderDockWindow(const char* window_name, ImGuiID node_id);    /* original C++ signature */
def dock_builder_dock_window(window_name: str, node_id: ImGuiID) -> None:    # imgui_internal.h:2988
    pass
# IMGUI_API ImGuiDockNode*DockBuilderGetNode(ImGuiID node_id);    /* original C++ signature */
def dock_builder_get_node(node_id: ImGuiID) -> ImGuiDockNode:    # imgui_internal.h:2989
    pass
# IMGUI_API ImGuiID       DockBuilderAddNode(ImGuiID node_id = 0, ImGuiDockNodeFlags flags = 0);    /* original C++ signature */
def dock_builder_add_node(node_id: ImGuiID = 0, flags: ImGuiDockNodeFlags = 0) -> ImGuiID:    # imgui_internal.h:2991
    pass
# IMGUI_API void          DockBuilderRemoveNode(ImGuiID node_id);                     /* original C++ signature */
def dock_builder_remove_node(node_id: ImGuiID) -> None:    # imgui_internal.h:2992
    """ Remove node and all its child, undock all windows"""
    pass
# IMGUI_API void          DockBuilderRemoveNodeDockedWindows(ImGuiID node_id, bool clear_settings_refs = true);    /* original C++ signature */
def dock_builder_remove_node_docked_windows(node_id: ImGuiID, clear_settings_refs: bool = True) -> None:    # imgui_internal.h:2993
    pass
# IMGUI_API void          DockBuilderRemoveNodeChildNodes(ImGuiID node_id);           /* original C++ signature */
def dock_builder_remove_node_child_nodes(node_id: ImGuiID) -> None:    # imgui_internal.h:2994
    """ Remove all split/hierarchy. All remaining docked windows will be re-docked to the remaining root node (node_id)."""
    pass
# IMGUI_API void          DockBuilderSetNodePos(ImGuiID node_id, ImVec2 pos);    /* original C++ signature */
def dock_builder_set_node_pos(node_id: ImGuiID, pos: ImVec2) -> None:    # imgui_internal.h:2995
    pass
# IMGUI_API void          DockBuilderSetNodeSize(ImGuiID node_id, ImVec2 size);    /* original C++ signature */
def dock_builder_set_node_size(node_id: ImGuiID, size: ImVec2) -> None:    # imgui_internal.h:2996
    pass
# IMGUI_API ImGuiID       DockBuilderSplitNode(ImGuiID node_id, ImGuiDir split_dir, float size_ratio_for_node_at_dir, ImGuiID* out_id_at_dir, ImGuiID* out_id_at_opposite_dir);     /* original C++ signature */
def dock_builder_split_node(node_id: ImGuiID, split_dir: ImGuiDir, size_ratio_for_node_at_dir: float, out_id_at_dir: ImGuiID, out_id_at_opposite_dir: ImGuiID) -> ImGuiID:    # imgui_internal.h:2997
    """ Create 2 child nodes in this parent node."""
    pass
# IMGUI_API void          DockBuilderCopyDockSpace(ImGuiID src_dockspace_id, ImGuiID dst_dockspace_id, ImVector<const char*>* in_window_remap_pairs);    /* original C++ signature */
def dock_builder_copy_dock_space(src_dockspace_id: ImGuiID, dst_dockspace_id: ImGuiID, in_window_remap_pairs: List[str]) -> None:    # imgui_internal.h:2998
    pass
# IMGUI_API void          DockBuilderCopyNode(ImGuiID src_node_id, ImGuiID dst_node_id, ImVector<ImGuiID>* out_node_remap_pairs);    /* original C++ signature */
def dock_builder_copy_node(src_node_id: ImGuiID, dst_node_id: ImGuiID, out_node_remap_pairs: List[ImGuiID]) -> None:    # imgui_internal.h:2999
    pass
# IMGUI_API void          DockBuilderCopyWindowSettings(const char* src_name, const char* dst_name);    /* original C++ signature */
def dock_builder_copy_window_settings(src_name: str, dst_name: str) -> None:    # imgui_internal.h:3000
    pass
# IMGUI_API void          DockBuilderFinish(ImGuiID node_id);    /* original C++ signature */
def dock_builder_finish(node_id: ImGuiID) -> None:    # imgui_internal.h:3001
    pass

# Drag and Drop
# IMGUI_API bool          IsDragDropActive();    /* original C++ signature */
def is_drag_drop_active() -> bool:    # imgui_internal.h:3004
    pass
# IMGUI_API bool          BeginDragDropTargetCustom(const ImRect& bb, ImGuiID id);    /* original C++ signature */
def begin_drag_drop_target_custom(bb: ImRect, id: ImGuiID) -> bool:    # imgui_internal.h:3005
    pass
# IMGUI_API void          ClearDragDrop();    /* original C++ signature */
def clear_drag_drop() -> None:    # imgui_internal.h:3006
    pass
# IMGUI_API bool          IsDragDropPayloadBeingAccepted();    /* original C++ signature */
def is_drag_drop_payload_being_accepted() -> bool:    # imgui_internal.h:3007
    pass

# Internal Columns API (this is not exposed because we will encourage transitioning to the Tables API)
# IMGUI_API void          SetWindowClipRectBeforeSetChannel(ImGuiWindow* window, const ImRect& clip_rect);    /* original C++ signature */
def set_window_clip_rect_before_set_channel(window: ImGuiWindow, clip_rect: ImRect) -> None:    # imgui_internal.h:3010
    pass
# IMGUI_API void          BeginColumns(const char* str_id, int count, ImGuiOldColumnFlags flags = 0);     /* original C++ signature */
def begin_columns(str_id: str, count: int, flags: ImGuiOldColumnFlags = 0) -> None:    # imgui_internal.h:3011
    """ setup number of columns. use an identifier to distinguish multiple column sets. close with EndColumns()."""
    pass
# IMGUI_API void          EndColumns();                                                                   /* original C++ signature */
def end_columns() -> None:    # imgui_internal.h:3012
    """ close columns"""
    pass
# IMGUI_API void          PushColumnClipRect(int column_index);    /* original C++ signature */
def push_column_clip_rect(column_index: int) -> None:    # imgui_internal.h:3013
    pass
# IMGUI_API void          PushColumnsBackground();    /* original C++ signature */
def push_columns_background() -> None:    # imgui_internal.h:3014
    pass
# IMGUI_API void          PopColumnsBackground();    /* original C++ signature */
def pop_columns_background() -> None:    # imgui_internal.h:3015
    pass
# IMGUI_API ImGuiID       GetColumnsID(const char* str_id, int count);    /* original C++ signature */
def get_columns_id(str_id: str, count: int) -> ImGuiID:    # imgui_internal.h:3016
    pass
# IMGUI_API ImGuiOldColumns* FindOrCreateColumns(ImGuiWindow* window, ImGuiID id);    /* original C++ signature */
def find_or_create_columns(window: ImGuiWindow, id: ImGuiID) -> ImGuiOldColumns:    # imgui_internal.h:3017
    pass
# IMGUI_API float         GetColumnOffsetFromNorm(const ImGuiOldColumns* columns, float offset_norm);    /* original C++ signature */
def get_column_offset_from_norm(columns: ImGuiOldColumns, offset_norm: float) -> float:    # imgui_internal.h:3018
    pass
# IMGUI_API float         GetColumnNormFromOffset(const ImGuiOldColumns* columns, float offset);    /* original C++ signature */
def get_column_norm_from_offset(columns: ImGuiOldColumns, offset: float) -> float:    # imgui_internal.h:3019
    pass

# Tables: Candidates for public API
# IMGUI_API void          TableOpenContextMenu(int column_n = -1);    /* original C++ signature */
def table_open_context_menu(column_n: int = -1) -> None:    # imgui_internal.h:3022
    pass
# IMGUI_API void          TableSetColumnWidth(int column_n, float width);    /* original C++ signature */
def table_set_column_width(column_n: int, width: float) -> None:    # imgui_internal.h:3023
    pass
# IMGUI_API void          TableSetColumnSortDirection(int column_n, ImGuiSortDirection sort_direction, bool append_to_sort_specs);    /* original C++ signature */
def table_set_column_sort_direction(column_n: int, sort_direction: ImGuiSortDirection, append_to_sort_specs: bool) -> None:    # imgui_internal.h:3024
    pass
# IMGUI_API int           TableGetHoveredColumn();     /* original C++ signature */
def table_get_hovered_column() -> int:    # imgui_internal.h:3025
    """ May use (TableGetColumnFlags() & ImGuiTableColumnFlags_IsHovered) instead. Return hovered column. return -1 when table is not hovered. return columns_count if the unused space at the right of visible columns is hovered."""
    pass
# IMGUI_API float         TableGetHeaderRowHeight();    /* original C++ signature */
def table_get_header_row_height() -> float:    # imgui_internal.h:3026
    pass
# IMGUI_API void          TablePushBackgroundChannel();    /* original C++ signature */
def table_push_background_channel() -> None:    # imgui_internal.h:3027
    pass
# IMGUI_API void          TablePopBackgroundChannel();    /* original C++ signature */
def table_pop_background_channel() -> None:    # imgui_internal.h:3028
    pass

# IMGUI_API ImGuiTable*   TableFindByID(ImGuiID id);    /* original C++ signature */
def table_find_by_id(id: ImGuiID) -> ImGuiTable:    # imgui_internal.h:3032
    pass
# IMGUI_API bool          BeginTableEx(const char* name, ImGuiID id, int columns_count, ImGuiTableFlags flags = 0, const ImVec2& outer_size = ImVec2(0, 0), float inner_width = 0.0f);    /* original C++ signature */
def begin_table_ex(name: str, id: ImGuiID, columns_count: int, flags: ImGuiTableFlags = 0, outer_size: ImVec2 = ImVec2(0, 0), inner_width: float = 0.0) -> bool:    # imgui_internal.h:3033
    pass
# IMGUI_API void          TableBeginInitMemory(ImGuiTable* table, int columns_count);    /* original C++ signature */
def table_begin_init_memory(table: ImGuiTable, columns_count: int) -> None:    # imgui_internal.h:3034
    pass
# IMGUI_API void          TableBeginApplyRequests(ImGuiTable* table);    /* original C++ signature */
def table_begin_apply_requests(table: ImGuiTable) -> None:    # imgui_internal.h:3035
    pass
# IMGUI_API void          TableSetupDrawChannels(ImGuiTable* table);    /* original C++ signature */
def table_setup_draw_channels(table: ImGuiTable) -> None:    # imgui_internal.h:3036
    pass
# IMGUI_API void          TableUpdateLayout(ImGuiTable* table);    /* original C++ signature */
def table_update_layout(table: ImGuiTable) -> None:    # imgui_internal.h:3037
    pass
# IMGUI_API void          TableUpdateBorders(ImGuiTable* table);    /* original C++ signature */
def table_update_borders(table: ImGuiTable) -> None:    # imgui_internal.h:3038
    pass
# IMGUI_API void          TableUpdateColumnsWeightFromWidth(ImGuiTable* table);    /* original C++ signature */
def table_update_columns_weight_from_width(table: ImGuiTable) -> None:    # imgui_internal.h:3039
    pass
# IMGUI_API void          TableDrawBorders(ImGuiTable* table);    /* original C++ signature */
def table_draw_borders(table: ImGuiTable) -> None:    # imgui_internal.h:3040
    pass
# IMGUI_API void          TableDrawContextMenu(ImGuiTable* table);    /* original C++ signature */
def table_draw_context_menu(table: ImGuiTable) -> None:    # imgui_internal.h:3041
    pass
# IMGUI_API void          TableMergeDrawChannels(ImGuiTable* table);    /* original C++ signature */
def table_merge_draw_channels(table: ImGuiTable) -> None:    # imgui_internal.h:3042
    pass
# IMGUI_API void          TableSortSpecsSanitize(ImGuiTable* table);    /* original C++ signature */
def table_sort_specs_sanitize(table: ImGuiTable) -> None:    # imgui_internal.h:3044
    pass
# IMGUI_API void          TableSortSpecsBuild(ImGuiTable* table);    /* original C++ signature */
def table_sort_specs_build(table: ImGuiTable) -> None:    # imgui_internal.h:3045
    pass
# IMGUI_API ImGuiSortDirection TableGetColumnNextSortDirection(ImGuiTableColumn* column);    /* original C++ signature */
def table_get_column_next_sort_direction(column: ImGuiTableColumn) -> ImGuiSortDirection:    # imgui_internal.h:3046
    pass
# IMGUI_API void          TableFixColumnSortDirection(ImGuiTable* table, ImGuiTableColumn* column);    /* original C++ signature */
def table_fix_column_sort_direction(table: ImGuiTable, column: ImGuiTableColumn) -> None:    # imgui_internal.h:3047
    pass
# IMGUI_API float         TableGetColumnWidthAuto(ImGuiTable* table, ImGuiTableColumn* column);    /* original C++ signature */
def table_get_column_width_auto(table: ImGuiTable, column: ImGuiTableColumn) -> float:    # imgui_internal.h:3048
    pass
# IMGUI_API void          TableBeginRow(ImGuiTable* table);    /* original C++ signature */
def table_begin_row(table: ImGuiTable) -> None:    # imgui_internal.h:3049
    pass
# IMGUI_API void          TableEndRow(ImGuiTable* table);    /* original C++ signature */
def table_end_row(table: ImGuiTable) -> None:    # imgui_internal.h:3050
    pass
# IMGUI_API void          TableBeginCell(ImGuiTable* table, int column_n);    /* original C++ signature */
def table_begin_cell(table: ImGuiTable, column_n: int) -> None:    # imgui_internal.h:3051
    pass
# IMGUI_API void          TableEndCell(ImGuiTable* table);    /* original C++ signature */
def table_end_cell(table: ImGuiTable) -> None:    # imgui_internal.h:3052
    pass
# IMGUI_API ImRect        TableGetCellBgRect(const ImGuiTable* table, int column_n);    /* original C++ signature */
def table_get_cell_bg_rect(table: ImGuiTable, column_n: int) -> ImRect:    # imgui_internal.h:3053
    pass
# IMGUI_API const char*   TableGetColumnName(const ImGuiTable* table, int column_n);    /* original C++ signature */
def table_get_column_name(table: ImGuiTable, column_n: int) -> str:    # imgui_internal.h:3054
    pass
# IMGUI_API ImGuiID       TableGetColumnResizeID(const ImGuiTable* table, int column_n, int instance_no = 0);    /* original C++ signature */
def table_get_column_resize_id(table: ImGuiTable, column_n: int, instance_no: int = 0) -> ImGuiID:    # imgui_internal.h:3055
    pass
# IMGUI_API float         TableGetMaxColumnWidth(const ImGuiTable* table, int column_n);    /* original C++ signature */
def table_get_max_column_width(table: ImGuiTable, column_n: int) -> float:    # imgui_internal.h:3056
    pass
# IMGUI_API void          TableSetColumnWidthAutoSingle(ImGuiTable* table, int column_n);    /* original C++ signature */
def table_set_column_width_auto_single(table: ImGuiTable, column_n: int) -> None:    # imgui_internal.h:3057
    pass
# IMGUI_API void          TableSetColumnWidthAutoAll(ImGuiTable* table);    /* original C++ signature */
def table_set_column_width_auto_all(table: ImGuiTable) -> None:    # imgui_internal.h:3058
    pass
# IMGUI_API void          TableRemove(ImGuiTable* table);    /* original C++ signature */
def table_remove(table: ImGuiTable) -> None:    # imgui_internal.h:3059
    pass
# IMGUI_API void          TableGcCompactTransientBuffers(ImGuiTable* table);    /* original C++ signature */
def table_gc_compact_transient_buffers(table: ImGuiTable) -> None:    # imgui_internal.h:3060
    pass
# IMGUI_API void          TableGcCompactTransientBuffers(ImGuiTableTempData* table);    /* original C++ signature */
def table_gc_compact_transient_buffers(table: ImGuiTableTempData) -> None:    # imgui_internal.h:3061
    pass
# IMGUI_API void          TableGcCompactSettings();    /* original C++ signature */
def table_gc_compact_settings() -> None:    # imgui_internal.h:3062
    pass

# Tables: Settings
# IMGUI_API void                  TableLoadSettings(ImGuiTable* table);    /* original C++ signature */
def table_load_settings(table: ImGuiTable) -> None:    # imgui_internal.h:3065
    pass
# IMGUI_API void                  TableSaveSettings(ImGuiTable* table);    /* original C++ signature */
def table_save_settings(table: ImGuiTable) -> None:    # imgui_internal.h:3066
    pass
# IMGUI_API void                  TableResetSettings(ImGuiTable* table);    /* original C++ signature */
def table_reset_settings(table: ImGuiTable) -> None:    # imgui_internal.h:3067
    pass
# IMGUI_API ImGuiTableSettings*   TableGetBoundSettings(ImGuiTable* table);    /* original C++ signature */
def table_get_bound_settings(table: ImGuiTable) -> ImGuiTableSettings:    # imgui_internal.h:3068
    pass
# IMGUI_API void                  TableSettingsAddSettingsHandler();    /* original C++ signature */
def table_settings_add_settings_handler() -> None:    # imgui_internal.h:3069
    pass
# IMGUI_API ImGuiTableSettings*   TableSettingsCreate(ImGuiID id, int columns_count);    /* original C++ signature */
def table_settings_create(id: ImGuiID, columns_count: int) -> ImGuiTableSettings:    # imgui_internal.h:3070
    pass
# IMGUI_API ImGuiTableSettings*   TableSettingsFindByID(ImGuiID id);    /* original C++ signature */
def table_settings_find_by_id(id: ImGuiID) -> ImGuiTableSettings:    # imgui_internal.h:3071
    pass

# Tab Bars
# IMGUI_API bool          BeginTabBarEx(ImGuiTabBar* tab_bar, const ImRect& bb, ImGuiTabBarFlags flags, ImGuiDockNode* dock_node);    /* original C++ signature */
def begin_tab_bar_ex(tab_bar: ImGuiTabBar, bb: ImRect, flags: ImGuiTabBarFlags, dock_node: ImGuiDockNode) -> bool:    # imgui_internal.h:3074
    pass
# IMGUI_API ImGuiTabItem* TabBarFindTabByID(ImGuiTabBar* tab_bar, ImGuiID tab_id);    /* original C++ signature */
def tab_bar_find_tab_by_id(tab_bar: ImGuiTabBar, tab_id: ImGuiID) -> ImGuiTabItem:    # imgui_internal.h:3075
    pass
# IMGUI_API ImGuiTabItem* TabBarFindMostRecentlySelectedTabForActiveWindow(ImGuiTabBar* tab_bar);    /* original C++ signature */
def tab_bar_find_most_recently_selected_tab_for_active_window(tab_bar: ImGuiTabBar) -> ImGuiTabItem:    # imgui_internal.h:3076
    pass
# IMGUI_API void          TabBarAddTab(ImGuiTabBar* tab_bar, ImGuiTabItemFlags tab_flags, ImGuiWindow* window);    /* original C++ signature */
def tab_bar_add_tab(tab_bar: ImGuiTabBar, tab_flags: ImGuiTabItemFlags, window: ImGuiWindow) -> None:    # imgui_internal.h:3077
    pass
# IMGUI_API void          TabBarRemoveTab(ImGuiTabBar* tab_bar, ImGuiID tab_id);    /* original C++ signature */
def tab_bar_remove_tab(tab_bar: ImGuiTabBar, tab_id: ImGuiID) -> None:    # imgui_internal.h:3078
    pass
# IMGUI_API void          TabBarCloseTab(ImGuiTabBar* tab_bar, ImGuiTabItem* tab);    /* original C++ signature */
def tab_bar_close_tab(tab_bar: ImGuiTabBar, tab: ImGuiTabItem) -> None:    # imgui_internal.h:3079
    pass
# IMGUI_API void          TabBarQueueReorder(ImGuiTabBar* tab_bar, const ImGuiTabItem* tab, int offset);    /* original C++ signature */
def tab_bar_queue_reorder(tab_bar: ImGuiTabBar, tab: ImGuiTabItem, offset: int) -> None:    # imgui_internal.h:3080
    pass
# IMGUI_API void          TabBarQueueReorderFromMousePos(ImGuiTabBar* tab_bar, const ImGuiTabItem* tab, ImVec2 mouse_pos);    /* original C++ signature */
def tab_bar_queue_reorder_from_mouse_pos(tab_bar: ImGuiTabBar, tab: ImGuiTabItem, mouse_pos: ImVec2) -> None:    # imgui_internal.h:3081
    pass
# IMGUI_API bool          TabBarProcessReorder(ImGuiTabBar* tab_bar);    /* original C++ signature */
def tab_bar_process_reorder(tab_bar: ImGuiTabBar) -> bool:    # imgui_internal.h:3082
    pass
# IMGUI_API bool          TabItemEx(ImGuiTabBar* tab_bar, const char* label, bool* p_open, ImGuiTabItemFlags flags, ImGuiWindow* docked_window);    /* original C++ signature */
def tab_item_ex(tab_bar: ImGuiTabBar, label: str, p_open: bool, flags: ImGuiTabItemFlags, docked_window: ImGuiWindow) -> Tuple[bool, bool]:    # imgui_internal.h:3083
    pass
# IMGUI_API ImVec2        TabItemCalcSize(const char* label, bool has_close_button);    /* original C++ signature */
def tab_item_calc_size(label: str, has_close_button: bool) -> ImVec2:    # imgui_internal.h:3084
    pass
# IMGUI_API void          TabItemBackground(ImDrawList* draw_list, const ImRect& bb, ImGuiTabItemFlags flags, ImU32 col);    /* original C++ signature */
def tab_item_background(draw_list: ImDrawList, bb: ImRect, flags: ImGuiTabItemFlags, col: ImU32) -> None:    # imgui_internal.h:3085
    pass
# IMGUI_API void          TabItemLabelAndCloseButton(ImDrawList* draw_list, const ImRect& bb, ImGuiTabItemFlags flags, ImVec2 frame_padding, const char* label, ImGuiID tab_id, ImGuiID close_button_id, bool is_contents_visible, bool* out_just_closed, bool* out_text_clipped);    /* original C++ signature */
def tab_item_label_and_close_button(draw_list: ImDrawList, bb: ImRect, flags: ImGuiTabItemFlags, frame_padding: ImVec2, label: str, tab_id: ImGuiID, close_button_id: ImGuiID, is_contents_visible: bool, out_just_closed: bool, out_text_clipped: bool) -> Tuple[bool, bool]:    # imgui_internal.h:3086
    pass

# Render helpers
# AVOID USING OUTSIDE OF IMGUI.CPP! NOT FOR PUBLIC CONSUMPTION. THOSE FUNCTIONS ARE A MESS. THEIR SIGNATURE AND BEHAVIOR WILL CHANGE, THEY NEED TO BE REFACTORED INTO SOMETHING DECENT.
# NB: All position are in absolute pixels coordinates (we are never using window coordinates internally)
# IMGUI_API void          RenderText(ImVec2 pos, const char* text, const char* text_end = NULL, bool hide_text_after_hash = true);    /* original C++ signature */
def render_text(pos: ImVec2, text: str, text_end: str = None, hide_text_after_hash: bool = True) -> None:    # imgui_internal.h:3091
    pass
# IMGUI_API void          RenderTextWrapped(ImVec2 pos, const char* text, const char* text_end, float wrap_width);    /* original C++ signature */
def render_text_wrapped(pos: ImVec2, text: str, text_end: str, wrap_width: float) -> None:    # imgui_internal.h:3092
    pass
# IMGUI_API void          RenderTextClipped(const ImVec2& pos_min, const ImVec2& pos_max, const char* text, const char* text_end, const ImVec2* text_size_if_known, const ImVec2& align = ImVec2(0, 0), const ImRect* clip_rect = NULL);    /* original C++ signature */
def render_text_clipped(pos_min: ImVec2, pos_max: ImVec2, text: str, text_end: str, text_size_if_known: ImVec2, align: ImVec2 = ImVec2(0, 0), clip_rect: ImRect = None) -> None:    # imgui_internal.h:3093
    pass
# IMGUI_API void          RenderTextClippedEx(ImDrawList* draw_list, const ImVec2& pos_min, const ImVec2& pos_max, const char* text, const char* text_end, const ImVec2* text_size_if_known, const ImVec2& align = ImVec2(0, 0), const ImRect* clip_rect = NULL);    /* original C++ signature */
def render_text_clipped_ex(draw_list: ImDrawList, pos_min: ImVec2, pos_max: ImVec2, text: str, text_end: str, text_size_if_known: ImVec2, align: ImVec2 = ImVec2(0, 0), clip_rect: ImRect = None) -> None:    # imgui_internal.h:3094
    pass
# IMGUI_API void          RenderTextEllipsis(ImDrawList* draw_list, const ImVec2& pos_min, const ImVec2& pos_max, float clip_max_x, float ellipsis_max_x, const char* text, const char* text_end, const ImVec2* text_size_if_known);    /* original C++ signature */
def render_text_ellipsis(draw_list: ImDrawList, pos_min: ImVec2, pos_max: ImVec2, clip_max_x: float, ellipsis_max_x: float, text: str, text_end: str, text_size_if_known: ImVec2) -> None:    # imgui_internal.h:3095
    pass
# IMGUI_API void          RenderFrame(ImVec2 p_min, ImVec2 p_max, ImU32 fill_col, bool border = true, float rounding = 0.0f);    /* original C++ signature */
def render_frame(p_min: ImVec2, p_max: ImVec2, fill_col: ImU32, border: bool = True, rounding: float = 0.0) -> None:    # imgui_internal.h:3096
    pass
# IMGUI_API void          RenderFrameBorder(ImVec2 p_min, ImVec2 p_max, float rounding = 0.0f);    /* original C++ signature */
def render_frame_border(p_min: ImVec2, p_max: ImVec2, rounding: float = 0.0) -> None:    # imgui_internal.h:3097
    pass
# IMGUI_API void          RenderColorRectWithAlphaCheckerboard(ImDrawList* draw_list, ImVec2 p_min, ImVec2 p_max, ImU32 fill_col, float grid_step, ImVec2 grid_off, float rounding = 0.0f, ImDrawFlags flags = 0);    /* original C++ signature */
def render_color_rect_with_alpha_checkerboard(draw_list: ImDrawList, p_min: ImVec2, p_max: ImVec2, fill_col: ImU32, grid_step: float, grid_off: ImVec2, rounding: float = 0.0, flags: ImDrawFlags = 0) -> None:    # imgui_internal.h:3098
    pass
# IMGUI_API void          RenderNavHighlight(const ImRect& bb, ImGuiID id, ImGuiNavHighlightFlags flags = ImGuiNavHighlightFlags_TypeDefault);     /* original C++ signature */
def render_nav_highlight(bb: ImRect, id: ImGuiID, flags: ImGuiNavHighlightFlags = ImGuiNavHighlightFlags_.type_default) -> None:    # imgui_internal.h:3099
    """ Navigation highlight"""
    pass
# IMGUI_API const char*   FindRenderedTextEnd(const char* text, const char* text_end = NULL);     /* original C++ signature */
def find_rendered_text_end(text: str, text_end: str = None) -> str:    # imgui_internal.h:3100
    """ Find the optional ## from which we stop displaying text."""
    pass
# IMGUI_API void          RenderMouseCursor(ImVec2 pos, float scale, ImGuiMouseCursor mouse_cursor, ImU32 col_fill, ImU32 col_border, ImU32 col_shadow);    /* original C++ signature */
def render_mouse_cursor(pos: ImVec2, scale: float, mouse_cursor: ImGuiMouseCursor, col_fill: ImU32, col_border: ImU32, col_shadow: ImU32) -> None:    # imgui_internal.h:3101
    pass

# Render helpers (those functions don't access any ImGui state!)
# IMGUI_API void          RenderArrow(ImDrawList* draw_list, ImVec2 pos, ImU32 col, ImGuiDir dir, float scale = 1.0f);    /* original C++ signature */
def render_arrow(draw_list: ImDrawList, pos: ImVec2, col: ImU32, dir: ImGuiDir, scale: float = 1.0) -> None:    # imgui_internal.h:3104
    pass
# IMGUI_API void          RenderBullet(ImDrawList* draw_list, ImVec2 pos, ImU32 col);    /* original C++ signature */
def render_bullet(draw_list: ImDrawList, pos: ImVec2, col: ImU32) -> None:    # imgui_internal.h:3105
    pass
# IMGUI_API void          RenderCheckMark(ImDrawList* draw_list, ImVec2 pos, ImU32 col, float sz);    /* original C++ signature */
def render_check_mark(draw_list: ImDrawList, pos: ImVec2, col: ImU32, sz: float) -> None:    # imgui_internal.h:3106
    pass
# IMGUI_API void          RenderArrowPointingAt(ImDrawList* draw_list, ImVec2 pos, ImVec2 half_sz, ImGuiDir direction, ImU32 col);    /* original C++ signature */
def render_arrow_pointing_at(draw_list: ImDrawList, pos: ImVec2, half_sz: ImVec2, direction: ImGuiDir, col: ImU32) -> None:    # imgui_internal.h:3107
    pass
# IMGUI_API void          RenderArrowDockMenu(ImDrawList* draw_list, ImVec2 p_min, float sz, ImU32 col);    /* original C++ signature */
def render_arrow_dock_menu(draw_list: ImDrawList, p_min: ImVec2, sz: float, col: ImU32) -> None:    # imgui_internal.h:3108
    pass
# IMGUI_API void          RenderRectFilledRangeH(ImDrawList* draw_list, const ImRect& rect, ImU32 col, float x_start_norm, float x_end_norm, float rounding);    /* original C++ signature */
def render_rect_filled_range_h(draw_list: ImDrawList, rect: ImRect, col: ImU32, x_start_norm: float, x_end_norm: float, rounding: float) -> None:    # imgui_internal.h:3109
    pass
# IMGUI_API void          RenderRectFilledWithHole(ImDrawList* draw_list, const ImRect& outer, const ImRect& inner, ImU32 col, float rounding);    /* original C++ signature */
def render_rect_filled_with_hole(draw_list: ImDrawList, outer: ImRect, inner: ImRect, col: ImU32, rounding: float) -> None:    # imgui_internal.h:3110
    pass
# IMGUI_API ImDrawFlags   CalcRoundingFlagsForRectInRect(const ImRect& r_in, const ImRect& r_outer, float threshold);    /* original C++ signature */
def calc_rounding_flags_for_rect_in_rect(r_in: ImRect, r_outer: ImRect, threshold: float) -> ImDrawFlags:    # imgui_internal.h:3111
    pass

# Widgets
# IMGUI_API void          TextEx(const char* text, const char* text_end = NULL, ImGuiTextFlags flags = 0);    /* original C++ signature */
def text_ex(text: str, text_end: str = None, flags: ImGuiTextFlags = 0) -> None:    # imgui_internal.h:3114
    pass
# IMGUI_API bool          ButtonEx(const char* label, const ImVec2& size_arg = ImVec2(0, 0), ImGuiButtonFlags flags = 0);    /* original C++ signature */
def button_ex(label: str, size_arg: ImVec2 = ImVec2(0, 0), flags: ImGuiButtonFlags = 0) -> bool:    # imgui_internal.h:3115
    pass
# IMGUI_API bool          CloseButton(ImGuiID id, const ImVec2& pos);    /* original C++ signature */
def close_button(id: ImGuiID, pos: ImVec2) -> bool:    # imgui_internal.h:3116
    pass
# IMGUI_API bool          CollapseButton(ImGuiID id, const ImVec2& pos, ImGuiDockNode* dock_node);    /* original C++ signature */
def collapse_button(id: ImGuiID, pos: ImVec2, dock_node: ImGuiDockNode) -> bool:    # imgui_internal.h:3117
    pass
# IMGUI_API bool          ArrowButtonEx(const char* str_id, ImGuiDir dir, ImVec2 size_arg, ImGuiButtonFlags flags = 0);    /* original C++ signature */
def arrow_button_ex(str_id: str, dir: ImGuiDir, size_arg: ImVec2, flags: ImGuiButtonFlags = 0) -> bool:    # imgui_internal.h:3118
    pass
# IMGUI_API void          Scrollbar(ImGuiAxis axis);    /* original C++ signature */
def scrollbar(axis: ImGuiAxis) -> None:    # imgui_internal.h:3119
    pass
# IMGUI_API bool          ScrollbarEx(const ImRect& bb, ImGuiID id, ImGuiAxis axis, ImS64* p_scroll_v, ImS64 avail_v, ImS64 contents_v, ImDrawFlags flags);    /* original C++ signature */
def scrollbar_ex(bb: ImRect, id: ImGuiID, axis: ImGuiAxis, p_scroll_v: ImS64, avail_v: ImS64, contents_v: ImS64, flags: ImDrawFlags) -> bool:    # imgui_internal.h:3120
    pass
# IMGUI_API bool          ImageButtonEx(ImGuiID id, ImTextureID texture_id, const ImVec2& size, const ImVec2& uv0, const ImVec2& uv1, const ImVec2& padding, const ImVec4& bg_col, const ImVec4& tint_col);    /* original C++ signature */
def image_button_ex(id: ImGuiID, texture_id: ImTextureID, size: ImVec2, uv0: ImVec2, uv1: ImVec2, padding: ImVec2, bg_col: ImVec4, tint_col: ImVec4) -> bool:    # imgui_internal.h:3121
    pass
# IMGUI_API ImRect        GetWindowScrollbarRect(ImGuiWindow* window, ImGuiAxis axis);    /* original C++ signature */
def get_window_scrollbar_rect(window: ImGuiWindow, axis: ImGuiAxis) -> ImRect:    # imgui_internal.h:3122
    pass
# IMGUI_API ImGuiID       GetWindowScrollbarID(ImGuiWindow* window, ImGuiAxis axis);    /* original C++ signature */
def get_window_scrollbar_id(window: ImGuiWindow, axis: ImGuiAxis) -> ImGuiID:    # imgui_internal.h:3123
    pass
# IMGUI_API ImGuiID       GetWindowResizeCornerID(ImGuiWindow* window, int n);     /* original C++ signature */
def get_window_resize_corner_id(window: ImGuiWindow, n: int) -> ImGuiID:    # imgui_internal.h:3124
    """ 0..3: corners"""
    pass
# IMGUI_API ImGuiID       GetWindowResizeBorderID(ImGuiWindow* window, ImGuiDir dir);    /* original C++ signature */
def get_window_resize_border_id(window: ImGuiWindow, dir: ImGuiDir) -> ImGuiID:    # imgui_internal.h:3125
    pass
# IMGUI_API void          SeparatorEx(ImGuiSeparatorFlags flags);    /* original C++ signature */
def separator_ex(flags: ImGuiSeparatorFlags) -> None:    # imgui_internal.h:3126
    pass
# IMGUI_API bool          CheckboxFlags(const char* label, ImS64* flags, ImS64 flags_value);    /* original C++ signature */
def checkbox_flags(label: str, flags: ImS64, flags_value: ImS64) -> bool:    # imgui_internal.h:3127
    pass
# IMGUI_API bool          CheckboxFlags(const char* label, ImU64* flags, ImU64 flags_value);    /* original C++ signature */
def checkbox_flags(label: str, flags: ImU64, flags_value: ImU64) -> bool:    # imgui_internal.h:3128
    pass

# Widgets low-level behaviors
# IMGUI_API bool          ButtonBehavior(const ImRect& bb, ImGuiID id, bool* out_hovered, bool* out_held, ImGuiButtonFlags flags = 0);    /* original C++ signature */
def button_behavior(bb: ImRect, id: ImGuiID, out_hovered: bool, out_held: bool, flags: ImGuiButtonFlags = 0) -> Tuple[bool, bool, bool]:    # imgui_internal.h:3131
    pass
# IMGUI_API bool          DragBehavior(ImGuiID id, ImGuiDataType data_type, void* p_v, float v_speed, const void* p_min, const void* p_max, const char* format, ImGuiSliderFlags flags);    /* original C++ signature */
def drag_behavior(id: ImGuiID, data_type: ImGuiDataType, p_v: Any, v_speed: float, p_min: Any, p_max: Any, format: str, flags: ImGuiSliderFlags) -> bool:    # imgui_internal.h:3132
    pass
# IMGUI_API bool          SliderBehavior(const ImRect& bb, ImGuiID id, ImGuiDataType data_type, void* p_v, const void* p_min, const void* p_max, const char* format, ImGuiSliderFlags flags, ImRect* out_grab_bb);    /* original C++ signature */
def slider_behavior(bb: ImRect, id: ImGuiID, data_type: ImGuiDataType, p_v: Any, p_min: Any, p_max: Any, format: str, flags: ImGuiSliderFlags, out_grab_bb: ImRect) -> bool:    # imgui_internal.h:3133
    pass
# IMGUI_API bool          SplitterBehavior(const ImRect& bb, ImGuiID id, ImGuiAxis axis, float* size1, float* size2, float min_size1, float min_size2, float hover_extend = 0.0f, float hover_visibility_delay = 0.0f, ImU32 bg_col = 0);    /* original C++ signature */
def splitter_behavior(bb: ImRect, id: ImGuiID, axis: ImGuiAxis, size1: np.ndarray, size2: np.ndarray, min_size2: float, hover_extend: float = 0.0, hover_visibility_delay: float = 0.0, bg_col: ImU32 = 0) -> bool:    # imgui_internal.h:3134
    pass
# IMGUI_API bool          TreeNodeBehavior(ImGuiID id, ImGuiTreeNodeFlags flags, const char* label, const char* label_end = NULL);    /* original C++ signature */
def tree_node_behavior(id: ImGuiID, flags: ImGuiTreeNodeFlags, label: str, label_end: str = None) -> bool:    # imgui_internal.h:3135
    pass
# IMGUI_API bool          TreeNodeBehaviorIsOpen(ImGuiID id, ImGuiTreeNodeFlags flags = 0);                         /* original C++ signature */
def tree_node_behavior_is_open(id: ImGuiID, flags: ImGuiTreeNodeFlags = 0) -> bool:    # imgui_internal.h:3136
    """ Consume previous SetNextItemOpen() data, if any. May return True when logging"""
    pass
# IMGUI_API void          TreePushOverrideID(ImGuiID id);    /* original C++ signature */
def tree_push_override_id(id: ImGuiID) -> None:    # imgui_internal.h:3137
    pass

# Template functions are instantiated in imgui_widgets.cpp for a finite number of types.
# To use them externally (for custom widget) you may need an "extern template" statement in your code in order to link to existing instances and silence Clang warnings (see #2036).
# e.g. " extern template IMGUI_API float RoundScalarWithFormatT<float, float>(const char* format, ImGuiDataType data_type, float v); "

# Data type helpers

# InputText

# Color
# IMGUI_API void          ColorTooltip(const char* text, const float* col, ImGuiColorEditFlags flags);    /* original C++ signature */
def color_tooltip(text: str, col: float, flags: ImGuiColorEditFlags) -> None:    # imgui_internal.h:3165
    pass
# IMGUI_API void          ColorEditOptionsPopup(const float* col, ImGuiColorEditFlags flags);    /* original C++ signature */
def color_edit_options_popup(col: float, flags: ImGuiColorEditFlags) -> None:    # imgui_internal.h:3166
    pass
# IMGUI_API void          ColorPickerOptionsPopup(const float* ref_col, ImGuiColorEditFlags flags);    /* original C++ signature */
def color_picker_options_popup(ref_col: float, flags: ImGuiColorEditFlags) -> None:    # imgui_internal.h:3167
    pass


# Shade functions (write over already created vertices)
# IMGUI_API void          ShadeVertsLinearColorGradientKeepAlpha(ImDrawList* draw_list, int vert_start_idx, int vert_end_idx, ImVec2 gradient_p0, ImVec2 gradient_p1, ImU32 col0, ImU32 col1);    /* original C++ signature */
def shade_verts_linear_color_gradient_keep_alpha(draw_list: ImDrawList, vert_start_idx: int, vert_end_idx: int, gradient_p0: ImVec2, gradient_p1: ImVec2, col0: ImU32, col1: ImU32) -> None:    # imgui_internal.h:3173
    pass
# IMGUI_API void          ShadeVertsLinearUV(ImDrawList* draw_list, int vert_start_idx, int vert_end_idx, const ImVec2& a, const ImVec2& b, const ImVec2& uv_a, const ImVec2& uv_b, bool clamp);    /* original C++ signature */
def shade_verts_linear_uv(draw_list: ImDrawList, vert_start_idx: int, vert_end_idx: int, a: ImVec2, b: ImVec2, uv_a: ImVec2, uv_b: ImVec2, clamp: bool) -> None:    # imgui_internal.h:3174
    pass

# Garbage collection
# IMGUI_API void          GcCompactTransientMiscBuffers();    /* original C++ signature */
def gc_compact_transient_misc_buffers() -> None:    # imgui_internal.h:3177
    pass
# IMGUI_API void          GcCompactTransientWindowBuffers(ImGuiWindow* window);    /* original C++ signature */
def gc_compact_transient_window_buffers(window: ImGuiWindow) -> None:    # imgui_internal.h:3178
    pass
# IMGUI_API void          GcAwakeTransientWindowBuffers(ImGuiWindow* window);    /* original C++ signature */
def gc_awake_transient_window_buffers(window: ImGuiWindow) -> None:    # imgui_internal.h:3179
    pass

# Debug Log
# IMGUI_API void          DebugLog(const char* fmt, ...) ;    /* original C++ signature */
def debug_log(fmt: str) -> None:    # imgui_internal.h:3182
    pass

# Debug Tools
# IMGUI_API void          ShowFontAtlas(ImFontAtlas* atlas);    /* original C++ signature */
def show_font_atlas(atlas: ImFontAtlas) -> None:    # imgui_internal.h:3190
    pass
# IMGUI_API void          DebugHookIdInfo(ImGuiID id, ImGuiDataType data_type, const void* data_id, const void* data_id_end);    /* original C++ signature */
def debug_hook_id_info(id: ImGuiID, data_type: ImGuiDataType, data_id: Any, data_id_end: Any) -> None:    # imgui_internal.h:3191
    pass
# IMGUI_API void          DebugNodeColumns(ImGuiOldColumns* columns);    /* original C++ signature */
def debug_node_columns(columns: ImGuiOldColumns) -> None:    # imgui_internal.h:3192
    pass
# IMGUI_API void          DebugNodeDockNode(ImGuiDockNode* node, const char* label);    /* original C++ signature */
def debug_node_dock_node(node: ImGuiDockNode, label: str) -> None:    # imgui_internal.h:3193
    pass
# IMGUI_API void          DebugNodeDrawList(ImGuiWindow* window, ImGuiViewportP* viewport, const ImDrawList* draw_list, const char* label);    /* original C++ signature */
def debug_node_draw_list(window: ImGuiWindow, viewport: ImGuiViewportP, draw_list: ImDrawList, label: str) -> None:    # imgui_internal.h:3194
    pass
# IMGUI_API void          DebugNodeDrawCmdShowMeshAndBoundingBox(ImDrawList* out_draw_list, const ImDrawList* draw_list, const ImDrawCmd* draw_cmd, bool show_mesh, bool show_aabb);    /* original C++ signature */
def debug_node_draw_cmd_show_mesh_and_bounding_box(out_draw_list: ImDrawList, draw_list: ImDrawList, draw_cmd: ImDrawCmd, show_mesh: bool, show_aabb: bool) -> None:    # imgui_internal.h:3195
    pass
# IMGUI_API void          DebugNodeFont(ImFont* font);    /* original C++ signature */
def debug_node_font(font: ImFont) -> None:    # imgui_internal.h:3196
    pass
# IMGUI_API void          DebugNodeFontGlyph(ImFont* font, const ImFontGlyph* glyph);    /* original C++ signature */
def debug_node_font_glyph(font: ImFont, glyph: ImFontGlyph) -> None:    # imgui_internal.h:3197
    pass
# IMGUI_API void          DebugNodeStorage(ImGuiStorage* storage, const char* label);    /* original C++ signature */
def debug_node_storage(storage: ImGuiStorage, label: str) -> None:    # imgui_internal.h:3198
    pass
# IMGUI_API void          DebugNodeTabBar(ImGuiTabBar* tab_bar, const char* label);    /* original C++ signature */
def debug_node_tab_bar(tab_bar: ImGuiTabBar, label: str) -> None:    # imgui_internal.h:3199
    pass
# IMGUI_API void          DebugNodeTable(ImGuiTable* table);    /* original C++ signature */
def debug_node_table(table: ImGuiTable) -> None:    # imgui_internal.h:3200
    pass
# IMGUI_API void          DebugNodeTableSettings(ImGuiTableSettings* settings);    /* original C++ signature */
def debug_node_table_settings(settings: ImGuiTableSettings) -> None:    # imgui_internal.h:3201
    pass
# IMGUI_API void          DebugNodeInputTextState(ImGuiInputTextState* state);    /* original C++ signature */
def debug_node_input_text_state(state: ImGuiInputTextState) -> None:    # imgui_internal.h:3202
    pass
# IMGUI_API void          DebugNodeWindow(ImGuiWindow* window, const char* label);    /* original C++ signature */
def debug_node_window(window: ImGuiWindow, label: str) -> None:    # imgui_internal.h:3203
    pass
# IMGUI_API void          DebugNodeWindowSettings(ImGuiWindowSettings* settings);    /* original C++ signature */
def debug_node_window_settings(settings: ImGuiWindowSettings) -> None:    # imgui_internal.h:3204
    pass
# IMGUI_API void          DebugNodeWindowsList(ImVector<ImGuiWindow*>* windows, const char* label);    /* original C++ signature */
def debug_node_windows_list(windows: List[ImGuiWindow], label: str) -> None:    # imgui_internal.h:3205
    pass
# IMGUI_API void          DebugNodeViewport(ImGuiViewportP* viewport);    /* original C++ signature */
def debug_node_viewport(viewport: ImGuiViewportP) -> None:    # imgui_internal.h:3207
    pass
# IMGUI_API void          DebugRenderViewportThumbnail(ImDrawList* draw_list, ImGuiViewportP* viewport, const ImRect& bb);    /* original C++ signature */
def debug_render_viewport_thumbnail(draw_list: ImDrawList, viewport: ImGuiViewportP, bb: ImRect) -> None:    # imgui_internal.h:3208
    pass




#-----------------------------------------------------------------------------
# [SECTION] ImFontAtlas internal API
#-----------------------------------------------------------------------------

class ImFontBuilderIO:    # imgui_internal.h:3218
    """ This structure is likely to evolve as we add support for incremental atlas updates"""
    pass

# Helper for font builder

#-----------------------------------------------------------------------------
# [SECTION] Test Engine specific hooks (imgui_test_engine)
#-----------------------------------------------------------------------------


#-----------------------------------------------------------------------------




# <submodule ImStb>
class ImStb:  # Proxy class that introduces typings for the *submodule* ImStb
    pass  # (This corresponds to a C++ namespace. All method are static!)



# </submodule ImStb>
####################    </generated_from:imgui_internal.h>    ####################

# </litgen_stub>

# fmt: on
